OpenMPT - Full Version History
------------------------------

- [New]    : new feature
- [Imp]    : improvement
- [Mod]    : change
- [Var]    : other
- [Fix]    : bug fix
- [Reg]    : known issue / regression / feature removal
- (tx XYZ) : thanks to XYZ for telling us about the bug / requesting the feature


Developers:
<initials> nick name  / real name        [email @openmpt.org]
   <al>    Relabs     / Ahti Leppänen    [relabs]
   <ec>    Ericus     / Eric Chavanon    [ericus]
   <jh>    manx       / Jörn Heusipp     [manx]
   <js>    Saga Musix / Johannes Schultz [sagamusix]
   <rf>    rewbs      / Robin Fernandes  [rewbs]
   <sp>    pelya      / Sergiy Pylypenko [pelya]
   <tn>    plastik_s  / Trevor Nunes     [plastik_s]
Patch submitters:
   <cs127> cs127
   <cs>    kode54     / Christopher Snowhill
   <da>    Revenant   / Devin Acker
   <ih>    xaimus     / Imran Hameed
   <jb>    JoaoBaptMG / João Baptista de Paula e Silva
   <kk>    SYRiNX     / Keith F. Kelly
   <ks>    coda       / Ken Snyder


Got questions, comments or bug reports? Visit https://openmpt.org/ where you can
find our issue tracker and forums.


v1.32.11.00 (15 August 2026, revision 25566)
--------------------------------------------
General Tab
- [Fix] <js> Fixed possible crash when hovering unavailable channel controls (with fewer than four channels active on the tab).

Pattern tab
- [Fix] <js> Parameter Editor: The display of rows that were not visible in the pattern editor was not updated properly while modifying (http://bugs.openmpt.org/view.php?id=1982).

IT
- [Fix] <js> Due to an Impulse Tracker bug in Compatible Gxx mode, Envelope Carry may not resume the envelope from the correct position when there is both an instrument number and tone portamento next to a note.

XM
- [Imp] <js> NitroTracker ignores instrument numbers where there is no note next to them, so they are no longer imported. Fixes various NitroTracker-made XMs such as notominous-a19.xm.

Other formats
- [Mod] <js> STK: Loosen heuristics a bit to allow STK.CRB-GreatMuzaxs6 to load.
- [Fix] <js> GT2: Loading file versions 6 and later was broken since OpenMPT 1.32.01.00.

Misc
- [Imp] <js> Enforce Windows 11's MIDI service to start up when OpenMPT launches, to avoid UI hangs when the user tries to use some MIDI functionality for the first time.

Third-Party Libraries
- [Imp] Update lhasa (v0.6.0) and mpg123 (v1.33.7)


v1.32.10.00 (17 May 2026, revision 25321)
-----------------------------------------
Pattern tab
- [Fix] <js> Fixed possible crash when trying to display a very long plugin parameter name in the status bar.

Sample tab
- [Imp] <js> Add Silence / Resize: Entered milliseconds values can now be fractional.
- [Fix] <js> Resampling with r8brain could introduce unwanted ringing artifacts at the end of the sample.

VST / DMO Plugins
- [Fix] <js> OpenMPT 1.32.09.00 reported incorrect PPQ positions to plugins, resulting in wild position fluctuations (http://forum.openmpt.org/index.php?topic=7465.0).

Other formats
- [Fix] <js> ULT: Sustain loops were stopped after a portamento (http://bugs.openmpt.org/view.php?id=1967).

Audio I/O
- [Fix] <js> When using ASIO with hardware timing, it was possible that GUI updates were not synchronized properly with audio.

Misc
- [Imp] <js> Improved screen reader accessibility in Add Silence / Resize and various Export dialogs.
- [Fix] <js> Fixed potential input focus issues in various parts of the user interface.

Bundled plugins
- [Fix] <jh> FXP preset files for the SymMOD echo could not be restored, and preset files for the DigiBooster Pro Echo could only be restored in 32-bit builds of OpenMPT (http://bugs.openmpt.org/view.php?id=1966).
- [Fix] <js> MIDI I/O Plugin: Editing a MIDI macro during playback could potentially cause nonsensical MIDI messages to be sent or even a crash.

Third-Party Libraries
- [Imp] Update mpg123 (v1.33.5) and unrar(v7.2.6)


v1.32.09.00 (1 April 2026, revision 25160)
------------------------------------------
VST / DMO Plugins
- [Fix] <js> In OpenMPT 1.32.07.00 and 1.32.08.00, trying to play notes from a bridged plugin window could cause a crash (http://bugs.openmpt.org/view.php?id=1962).
- [Fix] <js> The PPQ position reported to plugins was not updated if a module tick spanned multiple VST processing calls.

Other formats
- [Fix] <js> MID: Continued SysEx events on a MIDI track currently mapped to anything but the first MIDI port were treated like the start of a SysEx message instead.

Misc
- [Fix] <js> Since OpenMPT 1.32.01.00, spin buttons in the main toolbar could disappear when locking the screen or invoking a UAC prompt (http://bugs.openmpt.org/view.php?id=1929).

Bundled plugins
- [Fix] <js> MIDI I/O Plugin: Sometimes, multiple duplicate Song Position Pointer messages were sent.


v1.32.08.00 (24 March 2026, revision 25097)
-------------------------------------------
Playback
- [Fix] <js> A regression in OpenMPT 1.32.07.00 caused some chip sample loops to be detuned, most notably in MOD files.


v1.32.07.00 (22 March 2026, revision 25055)
-------------------------------------------
Pattern tab
- [Mod] <js> Effect info now shows volume and panning volume command parameters as both hex and decimal if hex volume column was enabled (http://bugs.openmpt.org/view.php?id=1943).
- [Fix] <js> Effect info for volume command panning was shown in decimal even if hex volume column was enabled (http://bugs.openmpt.org/view.php?id=1943).
- [Fix] <js> Choosing "Copy Pattern" from the order list context menu always copied the currently displayed pattern, not the one on which the context menu was invoked.

VST / DMO Plugins
- [Imp] <js> Plugin editors can now receive SysEx messages from OpenMPT's MIDI recording.
- [Fix] <js> Work around apparently broken channel negotiation in MaxSynths DR-910 plugin (http://forum.openmpt.org/index.php?topic=7442.0).

Playback
- [Fix] <js> Avoid potential read past end of sample data in a specific combination of reverse sample playback + offset past sample loop.

MOD
- [Fix] <js> ProTracker arpeggio wrapraound results in an effective period of 65536 on Paula, not pausing the sample entirely (tx eightbitbubsy).

Other formats
- [Fix] <js> ULT: Loop points were incorrectly limited for 16-bit samples (http://bugs.openmpt.org/view.php?id=1953).

Misc
- [Fix] <js> MIDI Recording: On recent versions of Windows 11, MIDI recording stopped working after receiving a SysEx message (http://forum.openmpt.org/index.php?topic=7456.0).
- [Fix] <js> MIDI Export: Exporting from MOD or S3M did not correctly export implicit note-offs when playing a new note on the same channel (http://bugs.openmpt.org/view.php?id=1946).
- [Fix] <js> Keyboard Settings: The instrument note map category was missing (http://bugs.openmpt.org/view.php?id=1945).
- [Fix] <js> Display Settings: Changing DPI awareness didn't mark the settings page as modified.

Third-Party Libraries
- [Imp] Update libopusenc (v0.3), mpg123 (v1.33.4), opus (v1.6.1), unrar(v7.2.4) and zlib (v1.3.2)


v1.32.06.00 (14 December 2025, revision 24626)
----------------------------------------------
Sample tab
- [Imp] <js> Shift-clicking the loop start / end spin buttons now moves the loop points finely, instead of snapping to the next self-similar point (tx Platonist).
- [Fix] <js> Using Shift to move loop or cue points when zoomed into the sample actually accelerated mouse movement, so it was no longer "fine" movement as intended.

Other formats
- [Fix] <js> PT36: Some MODs with samples larger than 64k inside PT36 containers were not read correctly (tx AliceLR).

Stream Export
- [Fix] <js> Exporting the same module multiple times (or exporting individual instruments / channels) could lead to files differing in length by one sample when using modern tempo mode.

Misc
- [Fix] <jh> Fixed crash when saving IT / MPTM files and shutting down OpenMPT on Wine 10.20 and potentially Wine 11.1 (http://bugs.openmpt.org/view.php?id=1933).
- [Fix] <js> MIDI Export: Choosing the percussion channel for an instrument and then keeping "Mapped" mode selected and never manually touching the dropdown menu resulted in wrong MIDI percussion notes to be exported.


v1.32.05.00 (9 November 2025, revision 24406)
---------------------------------------------
Pattern tab
- [Fix] <js> Since OpenMPT 1.31, having both "Contiunous scroll" and "Cursor wrap in pattern editor" disabled, jumping by beat or measure no longer jumped to the first or last row of the pattern and instead stayed on the current row if it was close to the start / end than a beat / measure (http://forum.openmpt.org/index.php?topic=7374.0).
- [Fix] <js> Transposing a selection didn't refresh the (potentially changed) default volume display if the selection of the last channel didn't contain the volume column.
- [Fix] <js> Automatically hiding the volume column didn't work for newly-created MODs (http://bugs.openmpt.org/view.php?id=1928).

Sample tab
- [New] <js> Added option to slice a sample at grid points instead of cue points, including a keyboard shortcut (http://forum.openmpt.org/index.php?topic=7376.0).
- [Fix] <js> Since OpenMPT 1.31.14.00, fine adjustment of sustain loop start / end was broken.

Instrument tab
- [Fix] <js> Sample Map dialog: Fixed font scaling in the keyboard display when moving the window between screens with different DPI settings.

IT
- [Mod] <js> Files are no longer interpreted as ModPlug-made (thus disabling all compatibility settings) just because instrument extensions are found (no such files are currently known to exist in the wild).

Third-Party Libraries
- [Imp] Update ancient (v2.3.0), mpg123 (v1.33.3) and unrar(v7.2.1)


v1.32.04.00 (6 September 2025, revision 24138)
----------------------------------------------
Pattern tab
- [Fix] <js> Find & Replace: Selecting a Transpose value of -4 or -5 caused the replace tab to assume that the replacement note was a PC event (tx cs127).
- [Fix] <js> Find & Replace: When finding a PC event and replacing it with a regular note, the instrument / volume fields were not always updated correctly (tx cs127).
- [Fix] <js> Quick Channel Settings: Avoid keyboard focus trap when navigating to the first or last channel and the keyboard focus was on one of the previous / next channel controls.
- [Fix] <js> The order list focus rectangle was sometimes not drawn with the correct colors.

Sample tab
- [Imp] <js> Added keyboard shortcuts for toggling loop types (http://forum.openmpt.org/index.php?topic=7354.0).
- [Fix] <js> Sample slicing did not adjust the sustain loop points in the sliced samples, and did not reset the "Keep sample on disk" setting.

IT
- [Fix] <js> Even when the filter cutoff envelope is stopped before its first tick is applied, the filter should still be activated (http://bugs.openmpt.org/view.php?id=1914).

Audio I/O
- [Fix] <js> It was possible that OpenMPT could crash when stopping playback of a module when using bridged plugins in combination with certain ASIO drivers, likely since OpenMPT 1.31.10.00 (tx coda).

Misc
- [Imp] <js> Quick Start Dialog: Collapsed status of item groups is now memorized (http://bugs.openmpt.org/view.php?id=1916).
- [Imp] <jh> On Windows XP and Wine 3.12 and older, messages with "don't show again" option now offer control over whether they should be shown again.
- [Imp] <jh> Wine integration now supports RtAudio 6.
- [Imp] <js> Several numeric input fields no longer allow arbitrary text to be entered into them.
- [Mod] <js> In export dialogs, the currently active subsong is now chosen for export by default.
- [Fix] <jh> Wine integration was broken on Wine 10.13 due to a Wine regression.

Third-Party Libraries
- [Imp] Update lhasa (v0.5.0), mpg123 (v1.33.2) and unrar(v7.1.10)


v1.32.03.00 (19 July 2025, revision 23823)
------------------------------------------
Playback
- [Fix] <js> Avoid potential read past end of sample data in a specific combination of reverse sample playback + offset past sample loop.
- [Fix] <js> Since OpenMPT 1.32.01.00, swapping between samples on the rear channels could introduce a click on the front channels.

IT
- [Fix] <js> Volume column slides no longer propagate their effect memory to the regular effect column volume slides.

Other formats
- [Imp] <js> FC: Allow files with a sequence size of 0 to load (fixes a broken copy of cult.smod).

Misc
- [Mod] <js> To improve accessibility, keyboard focus is now only returned to the lower editor views if the last input method before an interaction in the upper view was done through the mouse. If the last interaction was through the keyboard instead, the keyboard focus remains there (http://forum.openmpt.org/index.php?msg=51008).
- [Mod] <js> Keyboard Settings: A pointless warning sound was played when adding the first shortcut for a command
- [Fix] <js> Keyboard Settings: Since OpenMPT 1.32.01.00, the first command in the command list was no longer selected for keyboard navigation (http://bugs.openmpt.org/view.php?id=1908).
- [Fix] <jh> Wine Integration is no longer offered on Wine 10.11 due to a Wine bug breaking it (http://bugs.openmpt.org/view.php?id=1904).

Third-Party Libraries
- [Imp] Update UnRAR (v7.1.8)


v1.32.02.00 (29 June 2025, revision 23657)
------------------------------------------
Tree view
- [Fix] <js> Since OpenMPT 1.32.01.00, the MIDI input focus remained on the tree view after dragging an instrument to a sample or instrument editor, while keyboard input focus was on the editor (http://bugs.openmpt.org/view.php?id=1899).

Pattern tab
- [Imp] <js> Added keyboard shortcuts for expanding and shrinking patterns (default: Ctrl + Alt + E / D).

Sample tab
- [Imp] <jh> FLAC encoding can now be configured to be multithreaded, using all available CPU cores, by toggling the hidden setting "Sample Editor.FLACMultithreading".

Instrument tab
- [Fix] <cs127> When saving an ITI file, parts of the volume envelope were damaged (http://github.com/OpenMPT/openmpt/pull/32).
- [Fix] <js> Switching between envelopes using keyboard shortcuts didn't update accessible announcements (http://bugs.openmpt.org/view.php?id=1892).

Playback
- [Fix] <js> Previewing a sample, instrument or pattern note after pausing playback in a module using synth instruments continued playing those synth instruments (tx squeaktoy).

MPTM
- [Fix] <js> Inserting / duplicating / moving sequences reset the default tempo and speed for all sequences (http://forum.openmpt.org/index.php?topic=7345.0).

IT
- [Fix] <js> Picking up a note after a Note Cut effect through a lone instrument number restores the original note pitch without any portamento slides, as if there was a note.
- [Fix] <js> If there is a note and a tone portamento next to a Note Cut effect, the Note Cut is not executed - unless there is also a row delay effect and we are on the second repetition of the row.

S3M
- [Mod] <js> Old ModPlug Tracker versions allowed the 28th character of sample names to be used. Such sample names are now displayed correctly again.

Other formats
- [Fix] <js> MED: When triggering a synth note with a Synth Jump command on the same row, the initial speed command was not executed (http://www.un4seen.com/forum/?msg=145046).

Stream Export
- [Imp] <js> The currently active subsong is now selected by default for the single subsong export mode. This also applies to OPL and MIDI export (http://forum.openmpt.org/index.php?topic=7340.0).
- [Imp] <js> In export dialogs, the song index within the selected sequence is now also shown (http://forum.openmpt.org/index.php?topic=7340.0).
- [Imp] <jh> FLAC encoding is now multithreaded by default, using all available CPU cores. Can be disabled by toggling the hidden setting "Export.FLACMultithreading".

Misc
- [Imp] <js> Main toolbar: Icon groups can now be hidden as well. At least one icon group needs to be always visible, though (http://bugs.openmpt.org/view.php?id=1889).
- [Imp] <js> Added help button to Setup dialog title bar.
- [Imp] <js> A few more icons are now inverted when using dark themes.
- [Imp] <js> Added a default key binding for Toggle Between Upper / Lower View (Ctrl + Shift + Tab).
- [Imp] <js> TCB has been added to list of recognized file extensions for TCB Tracker modules. Both ModLand and Fujiology use .TCB instead of the canonical .MOD extension.
- [Fix] <js> Estimate Song Length: Subsong start order format was not adhering to the "Display rows / orders in hex" setting.
- [Fix] <js> Large parts of the GUI were broken in XP / Vista builds when running them on Windows 10 version 1607 or newer. (http://bugs.openmpt.org/view.php?id=1887).
- [Fix] <js> On Windows XP / Vista and Wine versions older 3.13, message boxes there were supposed to only show once were always shown instead.

Third-Party Libraries
- [Imp] Update miniz (v3.0.2), mpg123 (v1.33.0) and ogg (v1.3.6)


v1.32.01.00 (31 May 2025, revision 23242)
-----------------------------------------
Tree view
- [New] <js> The tree view can now also be placed on the right side of the window (View -> Toolbars).
- [Imp] <js> The Instrument Library now shows size information for samples in modules as well, and uses cached information for displaying file size and modification time of on-disk files instead of querying this information from the operating system every time a file is selected.
- [Mod] <js> The "Switch To Instrument Library" shortcut is no longer available if the tree view is hidden (http://bugs.openmpt.org/view.php?id=1802).
- [Mod] <js> When MIDI Library entries are unset by user, they are no longer replaced with the default soundfont after restarting OpenMPT (http://bugs.openmpt.org/view.php?id=1870).

General tab
- [New] <js> By holding Shift when pressing the Bypass checkbox, all other plugins are (un-)bypassed. Holding Ctrl instead, only Master plugins are affected.
- [Imp] <js> Expanded mix now also works with plugins that have no inputs.
- [Imp] <js> All mix modes are now available for instrument plugins as well. The old plugin mixing behaviour for instrument plugins is emulated with the new "Instrument" mix mode (http://forum.openmpt.org/index.php?topic=7178.0).

Pattern tab
- [New] <js> There is now a metronome that can be enabled from the toolbar or via a keyboard shortcut. The toolbar button also allows to change the metronome volume or replace metronome samples (http://bugs.openmpt.org/view.php?id=689).
- [New] <js> Merge functionality has been extended to support merging into multiple patterns with a user-specified length. This way, it becomes possible to automatically rearrange e.g. 64-row patterns into 128-row patterns in one go (http://bugs.openmpt.org/view.php?id=1750).
- [New] <js> Pattern Properties: When increasing pattern size, there is now an option to duplicate the existing contents to the newly-added rows (http://bugs.openmpt.org/view.php?id=431).
- [New] <js> Instrument / volume / effect column visibility can now be toggled independently. Column visibility is now remembered per-module if "Remember song window positions" is enabled (http://bugs.openmpt.org/view.php?id=1523).
- [New] <js> Add experimental hexadecimal volume column mode. Has to be enabled via hidden setting "Pattern.VolumeColumnInHex" and then manually assign the corresponding keys for A-F and reassign effect keys to something else (http://bugs.openmpt.org/view.php?id=1798).
- [New] <js> It is now possible to queue the next pattern to not only play when the current pattern is finished, but also when the current measure, beat or row is finished. This can be done through new order list context menu entries, four new keyboard shortcuts (combinations of Shift + Alt + Q), or as before by middle-clicking or Ctrl-left-clicking (together with the same modifier combinations of Shift and Alt as the aforementioned shortcuts, http://forum.openmpt.org/index.php?topic=7014.0).
- [New] <js> Added keyboard shortcuts for toggling most MIDI recording options (http://bugs.openmpt.org/view.php?id=500).
- [New] <js> Can now set a separate background color for the active row when recording is enabled (http://bugs.openmpt.org/view.php?id=856).
- [Imp] <js> Shortcuts that toggle settings with no immediate visual feedback now show the new setting value in the status bar (http://bugs.openmpt.org/view.php?id=500).
- [Imp] <js> It is now possible to solo a group of channels at once. The solo shortcut applies to all channels in the current pattern selection.
- [Imp] <js> It is now possible in the Pattern Properties dialog to edit the properties of multiple patterns without having to close and re-open the dialog every time, and also change their names (http://forum.openmpt.org/index.php?topic=3454.0).
- [Imp] <js> Global S9x commands are now applied while seeking as well.
- [Imp] <js> Added hidden setting "Pattern Editor.AutoHideVolumeColumnForMOD" to disable the volume column by default for MOD and MOD-like formats (http://bugs.openmpt.org/view.php?id=1836).
- [Imp] <js> The built-in pattern font is now automatically scaled according to DPI settings. From 150% onward it is upscaled 2x, from 250% onward it's 3x, etc...
- [Imp] <js> "Continue song as soon as MIDI notes are being received" can now optionally start playback from the start of pattern, rather than from the current row (http://bugs.openmpt.org/view.php?id=445).
- [Imp] <js> Allow MIDI Pitch Bend messages to not be recorded at all, always record them as macros, always as finetune, or both (http://bugs.openmpt.org/view.php?id=1874).
- [Imp] <js> In sample mode, show default volume also for note-less instruments (http://github.com/OpenMPT/openmpt/pull/29).
- [Imp] <js> Reduced flickering text when updating channel and row headers.
- [Imp] <js> "Display rows / orders in hex" setting is now also applied to accessible announcements (http://bugs.openmpt.org/view.php?id=1876).
- [Fix] <js> When inserting or duplicating multiple patterns, it was possible that patterns at the end of the order list disappeared.
- [Fix] <js> Using the Toggle Overflow Paste shortcut didn't update the corresponding toolbar button.
- [Fix] <js> Checking or unchecking Overflow Paste in one pattern editor didn't update the button in other pattern editors.
- [Fix] <js> It wasn't possible to toggle the record / VU meters / Plugin Display icons using the space bar.
- [Fix] <js> Fixed various accessibility issues in Quick Channel Settings dialog (http://bugs.openmpt.org/view.php?id=1880).
- [Fix] <js> After inserting patterns in the order list, the status bar and accessible announcement text were not updated.

Sample tab
- [Imp] <js> Replaced pitch shifting and time stretching components. By default, Signalsmith Stretch is now used for both high-quality shifting and stretching, and a custom "Akai"-like implementation can be used alternatively in "Lo-Fi Mode". Both implementations can handle any pitch shifting and time stretching amounts, and apply both changes simultaneously (http://bugs.openmpt.org/view.php?id=1808).
- [Imp] <js> When resampling samples in MOD files, there is now an option to adjust pattern data accordingly (http://forum.openmpt.org/index.php?topic=7245.0).
- [Imp] <js> The default / global volume tooltips now also show the effective amplification based on the sample / synth volume specified in the General tab (http://forum.openmpt.org/index.php?topic=7308.0).
- [Mod] <js> Loop information is now saved in FLAC metadata similar to how it is saved in WAV metadata when only a sustain loop is present. This way, it is possible to distinguish it from a normal sample loop.
- [Mod] <js> When resampling, sample offset command parameters are now rounded and parameters are never set to 0, as that would just recall the previous offset.

Instrument tab
- [New] <js> Last edited instrument is now remembered per-module if "Remember song window positions" is enabled.

Comments tab
- [New] <js> In addition to copying sample / instrument texts, they can now be pasted as well.
- [Imp] <js> Sample and instrument names and filenames are now drawn using the Comments font (so typically a fixed-width font; http://bugs.openmpt.org/view.php?id=1758).
- [Imp] <js> Allow to click anywhere in the sample / instrument list to select or open the corresponding editor (http://bugs.openmpt.org/view.php?id=1883).

VST / DMO Plugins
- [New] <js> Can now load shell VST plugins (http://bugs.openmpt.org/view.php?id=1551).
- [Imp] <js> VST: Improve correctness of PPQ position reporting. The PPQ is now also correct when the tempo changes, and when breaking to the next pattern, the position is rounded to the next start of measure (partially fixes https://bugs.openmpt.org/view.php?id=1731).
- [Mod] <js> After seeking, plugins are informed immediately about the new playback position if playback is stopped (http://bugs.openmpt.org/view.php?id=1731).
- [Fix] <js> Before OpenMPT 1.26, it was possible to send MIDI notes to channel plugins if the current instrument had a valid MIDI channel but no plugin assigned. The old behaviour is now re-enabled for old modules that rely on it.
- [Reg] <js> When a plugin referenced by a module isn't found, it is no longer added to the plugin library if it can be automatically found in the root of the VST plugin path specified in the OpenMPT settings.

Playback
- [Fix] <js> The retrigger command could behave differently when a MIDI channel was assigned to the active instrument (http://bugs.openmpt.org/view.php?id=1587).
- [Fix] <js> NNA channels associated with VST plugins or the MIDI I/O plugin will no longer cause channel starvation with NNA set to "Continue".
- [Fix] <js> Some plugin notes could keep playing forever when previewing samples or instruments while all NNA channels were in use.
- [Fix] <js> Avoid clicks on sample transition when applying a portamento effect between two different samples.

MPTM
- [New] <js> Every sequence has its own default tempo and speed now (http://bugs.openmpt.org/view.php?id=1322).

IT
- [Imp] <js> Default cue points are no longer set for samples in IT files and old enough MPTM files that don't use any volume-column offset commands (http://bugs.openmpt.org/view.php?id=1540).
- [Fix] <js> When using tone portamento to another sample after the previous sample's sustain loop has been released, the new sample should also not play its sustain loop.
- [Fix] <js> When triggering an empty instrument note slot, completely ignore the pattern cell - do not reset the currently playing instrument's envelopes (fixes wayfinder's Jet Rider), and also don't process any effects - including global ones.
- [Fix] <js> Offset with instrument number but no note should play offset effect with previous note (http://bugs.openmpt.org/view.php?id=1785).
- [Fix] <js> Fixed various combinations of volume column and effect column portamento effects (http://bugs.openmpt.org/view.php?id=1827).
- [Fix] <js> Implemented a quirk in command Lxx that always executes a portamento down when no tone portamento has been set up before, sometimes causing the target note to be reached immediately, or sliding the note down very subtly.
- [Fix] <js> Envelope Carry should not be influenced by a previous note-off (fixes bridge.it by rs3, http://www.un4seen.com/forum/?msg=144272).

XM
- [Mod] <js> Increased maximum channel count from 127 to 128, as MilkyTracker can write such files as well (http://bugs.openmpt.org/view.php?id=1877).
- [Fix] <js> When a key-off is encountered before auto-vibrato sweep reaches full depth, the vibrato depth is reset.
- [Fix] <js> Offset effect memory should only be updated when the command is next to a note (tx cyrb).

S3M
- [Mod] <js> Impulse Tracker style edit timer is now stored, and also read from files made with Schism Tracker.
- [Fix] <js> Combined slides (Kxy / Lxy) are no longer run on the first tick of a row in files made with Scream Tracker (http://bugs.openmpt.org/view.php?id=1828).

MOD
- [Imp] <js> Groo's "The Ultimate Beeper" now plays like in ProTracker.
- [Imp] <js> Modules saved with TakeTracker can now be identified.
- [Imp] <js> Improved Tetramed detection.

Other formats
- [New] <js> Can now read PumaTracker (PUMA) modules (http://bugs.openmpt.org/view.php?id=1327).
- [New] <js> Can now read Face The Music (FTM) modules (http://bugs.openmpt.org/view.php?id=1411).
- [New] <js> Can now read Future Composer (FC / SMOD) modules (http://bugs.openmpt.org/view.php?id=39).
- [New] <js> Can now read Game Music Creator (GMC) modules (http://bugs.openmpt.org/view.php?id=1762).
- [New] <js> Can now read Chuck Biscuits / Black Artist (CBA) modules from the Expoze musicdisk by Heretics (http://bugs.openmpt.org/view.php?id=1792).
- [New] <js> Can now read TCB Tracker (MOD) modules (http://bugs.openmpt.org/view.php?id=1845).
- [New] <js> Can now read Real Tracker 2 (RTM) modules.
- [New] <js> Can now read Images Music System (IMS) modules.
- [New] <js> Can now read ChipTracker (MOD) modules.
- [New] <js> Can now read EasyTrax (ETX) modules.
- [New] <js> Can now read UNIC Tracker v1 (UNIC) files.
- [New] <js> MED: Synthesized and hybrid instruments are now supported (http://bugs.openmpt.org/view.php?id=1321).
- [New] <js> GT2: Better support for old "envelopes", in particular adding support for the previously missing tremor / tremolo / vibrato.
- [New] <js> NST: His Master's Noise "Mupp" instruments are now supported, as well as command 7 "mega-arp".
- [New] <js> Better support for automatic slide commands (commands that keep sliding on following rows) in various formats (http://bugs.openmpt.org/view.php?id=1773).
- [Imp] <js> The pattern channel limit was raised from 127 to 192 for imported formats.
- [Imp] <js> SymMOD: Files containing more channels than OpenMPT can handle are no longer rejected (http://www.un4seen.com/forum/?msg=143952).
- [Mod] <js> PSM: Sub-songs are now imported as independent sequences instead of being crammed together into the same order list.
- [Fix] <js> DTM: Portamentos are now also evaluated on the first tick of the row.
- [Fix] <js> MO3: If multiple sample slots shared the same Ogg Vorbis sample, only one sample slot was loaded.
- [Fix] <js> MED: Tempo parameters > 255 BPM were not imported properly if the files was imported as MOD instead of XM (http://www.un4seen.com/forum/?msg=143478).
- [Fix] <js> MED: Import notes that exceed OpenMPT's note range.
- [Fix] <js> MED: Better handling of high octaves for non-MIDI instruments (http://www.un4seen.com/forum/?msg=144154).
- [Fix] <js> MED: Improve handling of low tempos in BPM mode (http://www.un4seen.com/forum/?msg=144160).
- [Fix] <js> MED: For IFFOCT instruments with extra sample loop information, the loop length was not correct. Sample transpose was also not applied correctly for IFFOCT instruments.
- [Fix] <js> MED: Command FFF should not stop a note if it is triggered on the same row (http://www.un4seen.com/forum/?msg=144691).
- [Fix] <js> MED: Set Pitch command (FFD) was not implemented (http://www.un4seen.com/forum/?msg=145039).

Stream Export
- [New] <js> Can now export all sub songs to individual files (http://bugs.openmpt.org/view.php?id=1515).
- [Imp] <js> Repeat count can now also be specified when exporting a pattern range or exporting all sub songs.
- [Imp] <js> Normalize and Clear Plugin Buffer choices are remembered across runs. Clear Plugin Buffer is now enabled by default.
- [Reg] <js> It is no longer possible to export a range of sequences.

Misc
- [New] <js> Added a quick start "project assistant" view that is shown whenever there is no module loaded (http://bugs.openmpt.org/view.php?id=863).
- [New] <js> In addition to the "Previous Order" and "Next Order" shortcuts, there are now also shortcuts that can delay the pattern transition until the next measure, beat or row is reached. When the song isn't playing, they behave like the normal "Previous Order" and "Next Order" shortcuts in the pattern editor (http://forum.openmpt.org/index.php?topic=7014.0).
- [New] <js> Added shortcut for browsing template modules (File/Open Template).
- [New] <js> Key bindings with Impulse Tracker-like and FastTracker-like note entry (but otherwise identical keyboard shortcuts) can now be applied directly from the keyboard settings dialog, without the need for external keymap files.
- [New] <js> Auto save: When auto saving to a user-specified folder, it is now possible to automatically delete old auto save files (default: older than 30 days).
- [New] <js> Auto save: Old auto save files are now moved to the recycling bin by default instead of being deleted permanently. Old behaviour can be restored in the auto save settings.
- [New] <js> MIDI Export can now write sub songs to individual files (http://bugs.openmpt.org/view.php?id=1515).
- [New] <js> Added a /play command line switch, which automatically starts playback of one of the modules passed via the command-line (http://bugs.openmpt.org/view.php?id=1751).
- [New] <js> Templates can now be opened from the "New" icon's dropdown menu in the main toolbar (http://bugs.openmpt.org/view.php?id=254).
- [New] <js> The main toolbar now shows the global volume of the currently playing module, and can also be used to modify it (http://bugs.openmpt.org/view.php?id=277).
- [Imp] <js> The visibility of all song info controls in the main toolbar can now be toggled via the context menu. The readouts can now also be edited directly in addition to the spin buttons.
- [Imp] <js> If the main toolbar is too wide to fit the window's size, it now wraps around. In vertical mode, it also wraps around more sensibly.
- [Imp] <js> Allow changing the base octave by entering digits 0 to 8 or + and - into the octave edit field in the main toolbar.
- [Imp] <js> Precision of time display in status bar was increased to show tenths of a second (http://bugs.openmpt.org/view.php?id=1791).
- [Imp] <js> When creating a new MOD file, it is now possible to specify whether it should be an Amiga MOD (4 channels, enable ProTracker quirks and Amiga resampler) or a PC MOD (8 channels, disable ProTracker quirks and Amiga resampler) (http://bugs.openmpt.org/view.php?id=1830).
- [Imp] <js> DPI-awareness can now be set in the Display options directly, without the need to edit hidden settings. High-DPI and mixed-DPI behaviour has been greatly improved in many aspects, and OpenMPT is now DPI-aware by default. The old hidden settings Display.HighResUI and Display.UseGDIUpscaling are gone and not migrated.
- [Imp] <js> When "Remember song window positions" is active, the last active state is now remembered for all tabs, not just the currently active tab.
- [Imp] <js> "Find MPT Hacks" now warns about S3Ms using extended OPL3 waveforms (as it was possible in early OpenMPT versions with OPL support).
- [Imp] <js> Channel Manager: It is now possible to interact with channels that have been marked for deletion.
- [Imp] <js> Redesign keyboard settings dialog. Assigned shortcuts are now immediately visible without having to manually select each shortcut. Potential cross-context conflicts between shortcuts are now always visible when selecting one of the shortcuts, and not just when editing them.
- [Imp] <js> The previously hidden setting "Pattern Editor.IgnoreSongTimeSignature" can now be changed directly via the Display settings.
- [Imp] <js> Tuning Dialog: The the dialog is now resizable.
- [Imp] <js> Auto save directory is now created when it's missing.
- [Mod] <js> Channel mute status is no longer saved by default.
- [Mod] <js> Auto save no longer defaults to saving in the song's original folder (http://bugs.openmpt.org/view.php?id=1837).
- [Mod] <js> Custom context menus are now handled using a new keyboard shortcut instead of hardcoding the Application key. Shift + F10 was added as a default alternative to the Application key for keyboards that don't have this key (http://bugs.openmpt.org/view.php?id=1815).
- [Mod] <js> New default keyboard shortcuts that conflict with existing shortcut are now added if the conflicting shortcut is in a more specific context, as the latter would override it anyway. Previously, it was the other way around, potentially changing existing shortcut behaviours.
- [Mod] <js> Global keyboard shortcuts no longer have priority over shortcuts in more specific contexts if they conflict, making their behaviour consistent with other contexts.
- [Mod] <js> Folder browser now uses modern browser style when available. The old browser style can be enforced by the hidden setting "Display.UseOldStyleFolderBrowser" (http://bugs.openmpt.org/view.php?id=1687).
- [Mod] <js> When auto-saving to a custom folder, sample paths for external samples are no longer relative in auto-saved files. This way, it is guaranteed that they will still work correctly when being moved back to the module's original folder.
- [Mod] <js> Various context menus are now opened when releasing the right mouse button, not when pressing it.
- [Mod] <js> Special key interception (Windows / Caps Lock / Scroll Lock / Num Lock) is now only active in contexts where a shortcut using that key is present (so e.g. having Note Off assigned to Caps Lock will now allow Caps Lock to be used as normal in another text edit field).
- [Fix] <js> Various keyboard handling issues on Wine should be fixed (http://bugs.openmpt.org/view.php?id=713).
- [Fix] <js> The "Previous Order" and "Next Order" shortcuts now also work when the pattern editor isn't focussed (http://bugs.openmpt.org/view.php?id=1489).
- [Fix] <js> Fixed various keyboard focus issues when switching between upper and lower half of editor views or switching to another application and back (http://bugs.openmpt.org/view.php?id=1799, http://bugs.openmpt.org/view.php?id=1800).
- [Fix] <js> Fixed accessibility issues in the Chord Editor (http://bugs.openmpt.org/view.php?id=1886).
- [Reg] <js> Global keyboard shortcuts can no longer be triggered while a menu or context menu is open.
- [Reg] <js> On Windows XP and Wine 3.12 and older, messages with "don't show again" option are now always shown at most once (the checkbox is no longer visible).

Bundled plugins
- [New] <js> MIDI I/O Plugin: Can now send an initial MIDI dump on playback start.
- [New] <js> MIDI I/O Plugin: The plugin now has its own extended MIDI macro system: Automating any plugin parameter (via PC events or, maybe a bit pointlessly, Zxx macros) sends MIDI macros that follow the same format as Zxx macros, but unlike Zxx macros they are not limited in length.
- [New] <js> MIDI I/O Plugin: A new virtual output device has been added to allow for MIDI messages to be forwarded to the configured output plugin. This way, the new macro mechanism can also be used together with other plugins and not just MIDI devices.
- [Imp] <js> MIDI I/O Plugin: PPQ position is now sent when "send timing information" is enabled. Position updates are sent at the start of every measure, and when changing playback position.
- [Imp] <js> MIDI I/O Plugin: The plugin editor is now resizable.
- [Fix] <js> MIDI I/O Plugin: When a MIDI device is lost temporarily, OpenMPT tries to re-open the correct device (identified by name or friendly name) when playback is started.
- [Reg] <js> MIDI I/O Plugin: The possibility to automate the MIDI input or output port was removed. The resolution of automation parameters was nowhere near enough to be able to actually select devices in a meaningful way.

Third-Party Libraries
- [Imp] Update nlohmann-json (v3.12.0), RtMidi (v6.0.0) and UnRAR (v7.1.6)


v1.31.15.00 (23 March 2025, revision 23072)
-------------------------------------------
Sample tab
- [Imp] <js> Relaxed BRR file rejection heuristics a bit (http://bugs.openmpt.org/view.php?id=1859).
- [Imp] <js> Loop and cue point information is now also copied for sample selections (http://bugs.openmpt.org/view.php?id=1869).
- [Fix] <js> Possible crash when replacing a sample with a shorter one while outside of the sample editor, and then returning to the same sample slot (http://bugs.openmpt.org/view.php?id=1866).
- [Fix] <js> Drawing sample data from right to left caused the drawn lines to not be interpolated properly.

Instrument tab
- [Fix] <js> Fixed crash when trying to remove the only point of an envelope.

Misc
- [Fix] <js> If multiple keyboard layouts were installed, note key mapping could be based on the wrong layout, causing e.g. B-4 and Note-Off keys to be swapped on the default key map with an active US keyboard layout but also a German layout being present.

Third-Party Libraries
- [Imp] Update FLAC (v1.5.0)


v1.31.14.00 (6 January 2025, revision 22819)
--------------------------------------------
Pattern tab
- [Fix] <js> Upon data entry, the status bar display was not updated unless playback was running.
- [Fix] <js> Fixed potential crash when trying to move the cursor past the start or end of a pattern when the order list is empty (http://bugs.openmpt.org/view.php?id=1854).

Sample tab
- [Imp] <js> Pressing Ctrl while moving loop points or clicking loop start / end spin buttons now moves the loop, keeping the loop length constant.
- [Imp] <js> Cue preview shortcuts now set the cue point if it's currently unused and the sample is being previewed (http://bugs.openmpt.org/view.php?id=1852).
- [Fix] <js> Time stretching didn't update cue points.

Playback
- [Fix] <js> Default velocity for instrument plugins was broken in OpenMPT 1.31.13.00 (tx coda).
- [Fix] <js> MIDI Macros: An unfinished byte right before an "s" SysEx checksum macro letter was not considered in the checksum.
- [Fix] <js> Avoid NNA channel starvation due to sample-based instruments that have a MIDI channel assigned and NNA set to "Continue". It can still happen if a VST plugin or the MIDI I/O plugin is associated with the instrument. Other built-in plugins are not affected (http://bugs.openmpt.org/view.php?id=1848).

XM
- [Imp] <js> Warn when saving an instrument that references more than 16 (compatibility export) or 32 samples (http://bugs.openmpt.org/view.php?id=1846).
- [Imp] <js> Identify XMs saved with Digitrakker that were converted from other formats.
- [Fix] <js> In non-compatible linear slide mode, the sample rate could wrap around with portamento slides to extremely low frequencies. This should only happen in compatible mode.

Other formats
- [Imp] <js> MO3: XM dummy command W is now imported.
- [Fix] <js> ITP: Instruments paths were always read as relative paths since OpenMPT 1.31.01.00, usually causing them to fail to load.
- [Fix] <js> ITP: Since OpenMPT 1.28.01.00, instrument and envelope flags were no longer read correctly.

Misc
- [Imp] <js> Fine tempo adjustment shortcuts now also work with formats that don't support fractional tempo.
- [Imp] <js> "Find MPT Hacks" now warns when an XM instrument uses more than 16 samples (http://bugs.openmpt.org/view.php?id=1846).
- [Fix] <js> Passing a relative path to a module file as a command-line parameter for OpenMPT did not work as intended since OpenMPT 1.29.10.00.
- [Fix] <js> Real BPM approximation reported infinity when rows per beat was set to 0. A default of 4 rows per beat is now assumed in this situation.
- [Fix] <js> Advanced Settings: It was not possible to enter fractional values for settings of type float with system locales using a decimal separator other than ".".

Third-Party Libraries
- [Imp] Update mpg123 (v1.32.10) and UnRAR (v7.1.2)


v1.31.13.00 (1 December 2024, revision 22403)
---------------------------------------------
Tree view
- [Imp] <js> Add option to open modules and instrument library entries in Explorer through the context menu (http://bugs.openmpt.org/view.php?id=677).
- [Fix] <js> The folder browser could not handle paths longer than 260 characters.

Pattern tab
- [Fix] <js> Special note keys (Note Cut / Off / Fade / PC / PCs) were not available in the default key map on various keyboard layouts (http://bugs.openmpt.org/view.php?id=1838).
- [Fix] <js> When partially pasting a normal pattern event over a PC event, the effect column was not erased properly if it wasn't part of the copied region.
- [Fix] <js> When evaluating MIDI macros containing letters "u" or "v" during seeking, the initial global volume was applied to them, rather than the global volume that would be reached at that pattern position.

Instrument tab
- [Imp] <js> When moving the last envelope point, avoid it snapping back quickly when moving backwards (http://bugs.openmpt.org/view.php?id=297).
- [Imp] <js> Show tooltips for disabled envelope toolbar buttons, and show the button name in the toolbar.
- [Fix] <js> When importing a soundfont instrument, its bank number was off by one (http://bugs.openmpt.org/view.php?id=1842).

Mod Conversion
- [Imp] <js> Improve handling of the transpose = -1 / finetune = 0 case when converting samples from another format to MOD. This combination is now automatically translated to finetune = -8.

IT
- [Imp] <js> Don't report files claiming to be made with Impulse Tracker 2.08+ as IT-made if they have no edit timer.
- [Fix] <js> Ignore sample data in slots that don't have the "sample data present" flag set, if the file vaguely looks IT-made to avoid playing garbage caused by an Impulse Tracker bug that should not be audible (http://www.un4seen.com/forum/?topic=20542.0).

S3M
- [Imp] <js> Detect early Schism Tracker versions.

MOD
- [Imp] <js> When trying to detect MOD files with broken order lists, the file size is now rounded down to an even number. This helps identifying some malformed files (MOD files can technically not have an odd size).
- [Fix] <js> Also enable ProTracker-compatible tremolo ramp waveform for M!K! modules.
- [Fix] <js> In ProTracker 1/2 mode, retrigger with instrument-less notes now keeps using the previous sample offset.

Other formats
- [Imp] <js> Warn when Startrekker AM companion file for synthesized instruments is most likely missing.
- [Imp] <js> DBM / IMF / MED: When merging pattern commands, allow to move offset to volume column at the expense of a lower offset resolution. Slightly improves playback of ShowMeLove.med (http://www.un4seen.com/forum/?msg=144136).
- [Fix] <js> MED: Fix correct octave transposition in some MED files that have hardware mixing disabled but sample transpose enabled. Fixed Journey.med (http://www.un4seen.com/forum/?msg=143713).
- [Fix] <js> MED: Don't enable Amiga resampler if any stereo samples are found, as it does not support stereo samples (http://www.un4seen.com/forum/?msg=144058).
- [Fix] <js> MED: Fix tempo in some files using software mixing mode and legacy tempo values (http://www.un4seen.com/forum/?msg=144080).
- [Fix] <js> MED: Avoid importing effect memory for some commands (http://www.un4seen.com/forum/?msg=144131).
- [Fix] <js> MED: Retrigger with instrument-less note now keeps using the previous sample offset. Fixes Kris Hadalot.med (http://www.un4seen.com/forum/?msg=144130).
- [Fix] <js> MED: Disable sample swapping on notes with portamento, and don't resume stopped notes with portamento. Fixes Homeward_Trek.med by Soundburst (http://www.un4seen.com/forum/?msg=144148).
- [Fix] <js> MED: Only use 7-bit volume commands in MMD3 files made with a new enough version of MED Soundstudio.
- [Fix] <js> STM: Do not sanitize sample loop data. Scream Tracker 2 reads into the next sample's data when loops exceed the sample length (http://www.un4seen.com/forum/?msg=144130).

Module cleanup
- [Fix] <js> Possible crash when searching for unused samples if an instrument refers to a non-existing sample slot.

Misc
- [Imp] <js> Added the possibility to disable enhanced GDI upscaling via hidden setting "Display.UseGDIUpcaling". This may fix freezes when opening the editors of some older VST plugins when this mode is enabled (http://bugs.openmpt.org/view.php?id=1524).
- [Imp] <js> Channel Manager: Channel buttons now have tooltips.
- [Mod] <js> When enabling the "Display.HighResUI" option, OpenMPT claimed to support per-monitor awareness. This was not really usable, so OpenMPT now only claims to support one system-wide DPI setting.
- [Mod] <js> Auto save no longer uses relative paths for external samples when auto saving to a user-specified folder.
- [Fix] <js> MIDI recording: Velocity amplification was rounded down to integer multiples of 100% (http://bugs.openmpt.org/view.php?id=1835).
- [Fix] <js> After loading a module with missing external samples, OpenMPT still prompted to save those empty sample slots to disk when closing the module. Doing that resulted in a crash.
- [Fix] <js> Fix truncated display of first item in checkbox lists in particular "Display.HighResUI" enabled. Potentially also fixes http://bugs.openmpt.org/view.php?id=1480
- [Fix] <js> When changing a shortcut via a search that had results in multiple contexts, a wrong context could be assigned to the shortcut.
- [Fix] <js> File/Append shortcut didn't work.
- [Fix] <js> Cleaning up auto save files, scanning for missing samples or creating the list of templates or example songs in paths longer than 260 characters did not work.
- [Fix] <ze> When saving a copy of a module, its modified status is no longer reset (http://bugs.openmpt.org/view.php?id=1843).
- [Fix] <js> On Windows XP, the advanced settings list was not formatted correctly.

Third-Party Libraries
- [Imp] Update mpg123 (v1.32.9)


v1.31.12.00 (26 October 2024, revision 21983)
---------------------------------------------
Pattern tab
- [Fix] <js> Keyboard entry was broken in several pattern columns in OpenMPT 1.31.11.00 (http://bugs.openmpt.org/view.php?id=1834).


v1.31.11.00 (26 October 2024, revision 21948)
---------------------------------------------
Pattern tab
- [Imp] <js> Undo steps are no longer created when entering data into the pattern that doesn't actually result in any change (e.g. adding another 0 to an effect parameter that is already 0).
- [Imp] <js> There is now a shortcut for stream export from the order list (http://bugs.openmpt.org/view.php?id=1831).
- [Mod] <js> Rename "Render to Wave" context menu item to "Stream Export".

Instrument tab
- [Fix] <js> When importing instruments in an IT file, restrict fadeout value to multiples of 32.

Mod Conversion
- [Mod] <js> When converting to IT, clamp maximum tempo to 255 BPM and restrict instrument fadeout to multiples of 32.

VST / DMO Plugins
- [Fix] <js> Plugin editor: Adjust window height after pasting a preset if the menu bar height changed due to a longer or shorter preset name.

IT
- [Imp] <js> Don't import SAx High Offset command for IT 1.xx modules. This feature was added in Impulse Tracker 2.00.
- [Imp] <js> Limit Vxx parameter to V80 for files made with old Schism Tracker versions (see http://github.com/schismtracker/schismtracker/issues/531).
- [Mod] <js> When using compatibility export, pattern length is restricted to 32 - 200 rows. Pattern break commands are inserted when required.
- [Fix] <js> Impulse Tracker 2.14 patch version information was incorrect (tx cs127).

S3M
- [Imp] <js> Insert pattern break commands on the last pattern row when trying to save patterns shorter than 64 rows.
- [Mod] <js> O00 effects are no longer ignored if the tracker version in the file header indicates Scream Tracker 3.00 / 3.01, but the file was clearly saved with another tool (e.g. UNMO3).
- [Mod] <cs127> As files made with Scream Tracker 3.20 and 3.21 cannot be told apart, both versions are now shown in the "last saved with" information (http://github.com/OpenMPT/openmpt/pull/24).
- [Fix] <js> Impulse Tracker 2.14 patch version information was incorrect (tx cs127).

MOD
- [Imp] <js> Insert pattern break commands on the last pattern row when trying to save patterns shorter than 64 rows.

Other formats
- [Imp] <js> ULT: Try to preserve global commands if there's e.g. both a speed and tempo command in the same cell. Fixes trance mission.ult (http://www.un4seen.com/forum/?msg=143764).
- [Imp] <cs127> STM: Improve "last saved with" tracker identification (http://github.com/OpenMPT/openmpt/pull/23)
- [Imp] <js> SymMOD: When running out of Zxx macros, try to find the closest macro to use instead. Fixes files like ocean view.symmod with tons of filter sweeps (http://www.un4seen.com/forum/?msg=143932).
- [Mod] <js> SymMOD: Ignore unknown hunks instead of rejecting entire file, as that's what Symphonie does as well. Fixes reading of Natsh1.SymMOD, which has garbage at the end of the file (http://www.un4seen.com/forum/?msg=143961).
- [Fix] <js> OKT: Disable loop on type "B" samples if they're used on a mixed channel. Fixes sinfonia.okta (http://www.un4seen.com/forum/?msg=143764).
- [Fix] <js> OKT: The last sample slot was never loaded.
- [Fix] <js> PTM: Halve offset command strength for 16-bit samples. Fixes leveled.ptm (http://www.un4seen.com/forum/?msg=143764).

Stream Export
- [Fix] <js> Aborting was not possible during the normalization step.

Misc
- [Imp] <js> Keyboard Settings: New shortcuts are now accepted by pressing the new "Set" button or by double-clicking into the shortcut field to improve accesibility (http://bugs.openmpt.org/view.php?id=1825).
- [Mod] <js> "Find MPT Hacks" now detects IT instruments with fadeout values that are not multiples of 32, and warns about patterns shorter than 32 rows.
- [Fix] <js> The "update available" tooltip could cause a really long hang if the previous OpenMPT session was ended in a minimized window state (http://bugs.openmpt.org/view.php?id=1723).
- [Fix] <js> Prevent "Close All" keyboard shortcut from being activated when a dialog is open. It was not possible to close any files in this situation, but the modified status of all files was reset.

Third-Party Libraries
- [Imp] Update mpg123 (v1.32.8)


v1.31.10.00 (22 September 2024, revision 21662)
-----------------------------------------------
Tree view
- [Fix] <js> Remove keyboard focus from tree when it is about to be hidden (http://bugs.openmpt.org/view.php?id=1802).

Pattern tab
- [Imp] <js> Channel settings can now be opened from channel context menu.

Instrument tab
- [Imp] <js> SFZ: Reduce memory usage of regions using the offset / end opcodes (e.g. SFZ files generated Sforzando's SF2 conversion process).

Mod Conversion
- [Imp] <js> Enable sustain loop on last envelope point when converting a volume envelope from XM that has no loops set (http://bugs.openmpt.org/view.php?id=1805).

VST / DMO Plugins
- [Fix] <js> Effect column Cxx volume command (MOD / XM style) was never sent to plugins. In particular this means that MIDI export did not export such volume commands.
- [Fix] <js> For plugin IDs with the highest bit set, cache information retrieval was not possible due to incorrect INI key formatting, causing such plugins to be rescanned every time.
- [Fix] <js> Avoid crash in plugin bridge if plugin changes channel configuration without notifying the host (http://bugs.openmpt.org/view.php?id=1807).

Other formats
- [New] <js> MID: SF2 sound banks embedded in RMI files are now also recognized.
- [Imp] <js> PTM: Use square root pan law, like in XM files.
- [Imp] <js> OKT: Don't drop global commands when setting paired channel volume, and try to write channel volume on the next row in this situation (http://www.un4seen.com/forum/?msg=143684
- [Imp] <js> MED: Allow tempo parameters < 32 BPM.
- [Fix] <js> MED: Command 09 (set speed) was limited to 20 ticks per row instead of 32 ticks per row (http://www.un4seen.com/forum/?msg=143294).
- [Fix] <js> MED: Disallow free panning if hardware mixing is enabled (http://www.un4seen.com/forum/?msg=143278).
- [Fix] <js> MED: For MOD-style vibrato, a speed parameter of 0 was not treated as effect memory (http://www.un4seen.com/forum/?msg=143464).
- [Fix] <js> MED: Fix pattern index exhaustion in modules with multiple sub songs (http://www.un4seen.com/forum/?msg=143464).
- [Fix] <js> MID: Embedded DLS sound banks were not being read.
- [Fix] <js> SFX: Ignore unused data at end of oneshot samples which sometimes caused clicky noises (http://www.un4seen.com/forum/?msg=143414).

Module cleanup
- [Fix] <js> Plugins only referenced by to-be-removed channels were not removed.

Misc
- [Imp] <js> When using the /shared command line parameter, modules are now opened in the OpenMPT window that was last interacted with, instead of a more or less random one.
- [Imp] <js> When appending to an MPTM module, copy over restart position to the newly-created sequence.
- [Fix] <js> Huge soundfonts failed to load if the hidden setting "Misc.CacheCompleteFileBeforeLoading" was used and the soundfont would not fit in memory.

Third-Party Libraries
- [Imp] Update mpg123 (v1.32.7)

Installer/release package
- [Mod] <cs127> Added FST to list of recognized file extensions. AMP uses this extension for multichannel MODs.


v1.31.09.00 (21 July 2024, revision 21219)
------------------------------------------
General tab
- [Fix] <js> The fix for garbled graphics in OpenMPT 1.31.08.00 broke graphical updates when using UI scaling in Windows (http://bugs.openmpt.org/view.php?id=1789).

Pattern tab
- [New] <js> Added shortcuts to go to a specific column within a pattern cell (http://bugs.openmpt.org/view.php?id=1797).
- [Mod] <js> S88 / E88 effect parameter explanation is now shown as "1 R" instead of "Center" as there is no real panning center with these commands (http://bugs.openmpt.org/view.php?id=1796).
- [Fix] <js> The next pattern is now also drawn if "always center active row" is turned off if there is enough space (http://bugs.openmpt.org/view.php?id=22).
- [Fix] <js> Possible crash when seeking with sample sync.

Sample tab
- [Fix] <js> When switching from an OPL instrument to a regular sample slot, keyboard focus remained on the now-invisible OPL editing controls (http://bugs.openmpt.org/view.php?id=1795).

VST / DMO Plugins
- [Fix] <js> Since OpenMPT 1.26.01.00, VST plugins were only loaded if their plugin type ID matched the expected value. However, some old files specify the wrong type ID, in which case those plugins were no longer loaded. The old behaviour was restored.

IT
- [Imp] <js> Identify files saved with itwriter.

XM
- [Imp] <js> For files saved with registered MadTracker 2 versions, do not show binary garbage (the user ID) in the "last saved with" information, instead simply show "registered".
- [Fix] <js> For some truncated files, the used tracker was not identified correctly.
- [Fix] <js> oggmod does not support stereo samples but keeps the stereo flag when encoding such samples. They are now imported as mono samples instead of not importing them at all (tx AliceLR).

S3M
- [Imp] <js> Identify files saved with early Impulse Tracker versions, Sound Club 2, Liquid Tracker, NESMusa, UNMO3, deMODifier, Kosmic To-S3M, and better tell old ModPlug Tracker versions apart.

MOD
- [Fix] <js> Allow sample swapping to work when swapping from a non-looping, stopped sample back to a looping sample (fixes MOD.energy, http://www.un4seen.com/forum/?msg=143034).

Other formats
- [Imp] <js> MID: Allow importing up to 32 MIDI channels by either using the official port selection mechanism of the SMF format, or alternatively by using a Yamaha extension (http://forum.openmpt.org/index.php?topic=7200.0).
- [Imp] <js> DTM: Identify files saved with Digital Tracker 2.3.
- [Imp] <js> DBM: Import second sustain point in case the first sustain point is not set, or if it has a lower index than the first.
- [Fix] <js> DBM: When several instruments referenced the same sample with different properties (volume, loop points, etc.), only one set of properties was imported (fixes DBM.Supernova, http://www.un4seen.com/forum/?msg=143091).
- [Fix] <js> DBM: Prioritize effects more correctly when the same effect is encountered in both effect columns of a cell (fixes DBM.143_Gnoj, http://www.un4seen.com/forum/?msg=143155).
- [Fix] <js> DBM: Don't import offset effects when there's a tone portmento next to them (fixes DBM.123_Savo, http://www.un4seen.com/forum/?msg=143155).
- [Fix] <js> DBM: A few IT-specific playback quirks are disabled for more accurate playback (e.g. in "Are You Flying With Me?" by Jazzcat).
- [Fix] <js> AMF: When running out of sample slots, file reading became be misaligned because the sample name was not skipped.
- [Fix] <js> MED: Command 0F was not imported. Upper frequency limits should be more accurate now.
- [Fix] <js> MED: Channel panning is now only applied in MMD2 files if the free pan flag is set (http://www.un4seen.com/forum/?msg=143276).
- [Fix] <js> MED: Volume command resolution was incorrect for pre-MMD3 files (http://www.un4seen.com/forum/?msg=143276).

Misc
- [Fix] <js> Keyboard focus was not restored properly in the upper half of the editor views when switching from and back to OpenMPT (http://bugs.openmpt.org/view.php?id=1795).
- [Fix] <js> Keyoard configuration: Changing the category dropdown selection while "Find Key" was active did not refresh the key list properly.

Third-Party Libraries
- [Imp] Update ancient (2024-07-15). This update adds support for Pack-Ice and PMC formats, and fixes a crash with malformed PPMQ files.


v1.31.08.00 (9 June 2024, revision 20987)
-----------------------------------------
General tab
- [Fix] <js> Updates received from other views could cause unintended data changes (e.g. truncating fractional tempo if it is technically unsupported by current format).
- [Fix] <js> Since OpenMPT 1.30, it was possible that leftovers from a previously visited tab could remain visible under some circumstances.

Pattern tab
- [Fix] <js> Navigating up on the first row of a pattern with "Play whole row while navigating" enabled but "Continuous scroll" disabled played the row and advanced to the second row instead of doing nothing (http://bugs.openmpt.org/view.php?id=1781).
- [Fix] <js> After deleting an effect, it was possible that its now-invisible parameter could still affect effect memory in S3M files.

Other formats
- [Imp] <js> MED: Additional command pages can now be read (http://bugs.openmpt.org/view.php?id=1783).
- [Imp] <js> MED: Echo DSP is now emulated (http://www.un4seen.com/forum/?msg=143034).
- [Fix] <js> AMS: Default channel panning was broken, using all-center panning instead of MOD-style panning.
- [Fix] <js> STP: Correctly import volume slides where both nibbles are set.
- [Fix] <js> DSm: Only the first 48 samples were ever read.
- [Fix] <js> DSm: Don't import as Amiga module (and thus allow Amiga resampler to be enabled), as this PC format can easily exceed the Amiga frequency range.
- [Fix] <cs127 & js> STM / STX: Don't set channel panning. ScreamTracker 2 only outputs mono sound.

Third-Party Libraries
- [Imp] Update ancient (v2.2.0) and UnRAR (v7.0.9)


v1.31.07.00 (12 May 2024, revision 20796)
-----------------------------------------
Pattern tab
- [Fix] <js> Find & Replace: In the plugin parameter dropdown, parameter 999 was missing if the number of plugin parameters was unknown.

Comments tab
- [Fix] <js> Sample / instrument name editing was broken since OpenMPT 1.31.01.00 (tx SoDa7).

Playback
- [Fix] <js> The OPL emulation produced unwanted clicks with mix rates exceeding 65 kHz (http://bugs.openmpt.org/view.php?id=1775).
- [Fix] <js> MIDI macro command s didn't compute the correct checksum if a device ID was made up from two bytes (e.g. Roland XV-5080).

IT
- [Imp] <js> Disable a few more compatibility flags for ITs made with older Schism Tracker versions (http://bugs.openmpt.org/view.php?id=1764).
- [Mod] <js> Halve the output volume of files saved with ChibiTracker, as its mixer is about half as loud as ours.

XM
- [Imp] <js> Detect files saved with PlayerPRO. Improved detection of files saved with ModPlug Tracker.
- [Mod] <js> Files with impossibly small pattern headers are now rejected, like FastTracker 2 does.

S3M
- [Imp] <js> Detect files saved with PlayerPRO.
- [Fix] <js> In mono mode, the ratio between sample and OPL volume was incorrect (http://bugs.openmpt.org/view.php?id=1774).

MOD
- [Mod] <js> Changed VBlank timing heuristic to always assume CIA timing when long samples (unsupported by original ProTracker) are found.
- [Fix] <js> Disable NoiseTracker quirks if empty sample slots have a default volume other than 0 (http://bugs.openmpt.org/view.php?id=1765).
- [Fix] <js> 7-bit panning detection may have returned incorrect results for MODs with a channel count other than 4.

Other formats
- [Imp] <js> STK: Loosen SoundTracker file rejection heuristics a bit to allow loading of files with overly long samples (romantic.stk) and malformed song titles (schmokk.mod, scramble_2.mod and others). Other heuristics has been tightened a bit.
- [Imp] <js> MED: Improve handling of default tempo, panning and channel volume in files containing more than one song (fixes sugar n spice.mmd3, http://www.un4seen.com/forum/?msg=142659).
- [Mod] <js> MO3: Further reduce maximum allowed music data (not samples) size from 2 GiB to 512 MiB.
- [Mod] <js> MDL: Slightly more accurate import of pattern command 9 (enabling envelopes instead of setting envelope position).
- [Fix] <cs127> ULT: Support the highest three octaves.

Misc
- [Mod] <js> Channel Manager: Allow middle-click to open Quick Channel Settings for all formats.
- [Imp] <js> When auto-saving, display the currently saving module's filename in the status bar.
- [Fix] <js> Fixed possible crash when merging sequences.
- [Fix] <jh> It was possible that OpenMPT would crash on shutdown if an automatic update check was still running in the background (http://bugs.openmpt.org/view.php?id=1760).

Bundled plugins
- [Fix] <js> When changing the output plugin from the LFO plugin's editor, the change was not reflected in the General tab.

Third-Party Libraries
- [Imp] Update mpg123 (v1.32.6) and opus (v1.5.2)


v1.31.06.00 (24 March 2024, revision 20438)
-------------------------------------------
Sample tab
- [Imp] <js> Audio is no longer blocked while updating the GUI after pasting a sample.

IT
- [Fix] <js> In OpenMPT 1.31.05.00, MIDI macros in IT files made with older MPT versions were no longer working (http://bugs.openmpt.org/view.php?id=1753).

Other formats
- [Fix] <js> MED: Transposed samples were playing too low in some files (e.g. mix94.mmd1).
- [Fix] <js> OKT: Some files with garbage at the end were rejected (e.g. katharsis - piano lesson.okta).
- [Fix] <js> SymMOD: Fixed potential crash with malformed sustain loops.

Misc
- [New] <js> Added two more octaves worth of note key assignments suitable for micro-tuning (http://bugs.openmpt.org/view.php?id=1727).
- [Fix] <js> File / sample sizes in the instrument browser and comments tab were displayed incorrectly if a size less than 1024 bytes ended in 0.

Bundled plugins
- [Mod] <js> The "Triangle" waveform in the Chorus / Flanger DMO plugins is now labelled "Square" instead to reflect its actual behaviour.
- [Fix] <js> There was a periodic click when playing a module using the Chorus or Flanger DMO plugin at a mix rate exceeding ~136.5 kHz (http://bugs.openmpt.org/view.php?id=1752).
- [Fix] <js> Since OpenMPT 1.29.13.00, the Distortion plugin sounded incorrect when using certain parameter combinations.

Third-Party Libraries
- [Imp] Update ancient (2024-03-23)


v1.31.05.00 (3 March 2024, revision 20196)
------------------------------------------
Tree view
- [Fix] <js> The search filter was no longer applied when the instrument library was refreshed.

Pattern tab
- [New] <js> Using the new hidden setting "Pattern Editor.IgnoreSongTimeSignature", it is now possible to ignore the time signature provided by the module and use the pre-configured defaults from the Display tab instead (http://bugs.openmpt.org/view.php?id=1746).
- [Fix] <js> Notes no longer hang on transpose or data entry (http://bugs.openmpt.org/view.php?id=1724).
- [Fix] <js> Data Entry could insert volume column commands even in MOD format when turning "virtual" default volume commands into real commands. This feature of Data Entry is now disabled for MOD files, as the alternative - moving the newly-added command to the effect column - would be counter-intuitive (http://bugs.openmpt.org/view.php?id=1738).
- [Fix] <js> Assigning / unassigning a plugin to / from an instrument didn't update their plugin editor button in the pattern tab.

Sample tab
- [New] <js> Can now convert sustain loops to normal loops and vice versa. If both loop types are set, the commands swap the two loops.
- [Fix] <js> Transpose value was sometimes off-by-one after manually entering sample rate.
- [Fix] <js> Reset sample reverse flag when loading new samples or converting between formats.
- [Fix] <js> Avoid accidental single-pixel sample data selections and jumpy selection start / end points with zoomed-out or auto-zoomed samples (quite likely introduced in OpenMPT 1.30.04.00).

Instrument tab
- [Imp] <js> SFZ: global_label opcode (instrument name) is now read and written.
- [Imp] <js> SFZ: Sustain point is no longer set on volume envelopes if it's the last point of the envelope and its value is neutral (0).
- [Fix] <js> SFZ: <, = and various whitespace characters are now omitted when writing name labels, to ensure that the resulting SFZ file can be parsed unambiguously.
- [Fix] <js> Clearing the note map due to plugin assignment didn't update other instrument tabs of the same song accordingly.

VST / DMO Plugins
- [Fix] <js> Prior to OpenMPT 1.30, if an instrument was set to use MIDI program 1 or bank 1, this program or bank change was not sent to plugins (unless another instrument previously explicitly selected a different program or bank for this plugin). This was fixed in OpenMPT 1.30, but that behaviour change broke existing modules, so for tracks made with earlier OpenMPT versions, the old behaviour is applied again.

IT
- [Imp] <js> A few more compatibility flags are now disabled for modules saved with earlier Schism Tracker versions.
- [Fix] <js> MIDI macros were reset in IT 2.14 / 2.15 files that declared to be compatible with older IT versions (fixes spx-visionsofthepast.it, http://bugs.openmpt.org/view.php?id=1745).

Other formats
- [Imp] <js> OKT: Work around missing negative arpeggio implementation by transposing the notes up an octave (http://bugs.openmpt.org/view.php?id=1732).
- [Fix] <js> OKT: Channel volume commands were sometimes lost over less important effects (http://bugs.openmpt.org/view.php?id=1732).
- [Fix] <js> IMF: Do not verify magic bytes in sample header. "Leaving All Behind" by Karsten Koch uses unexpected magic bytes, Orpheus ignores them just like the instrument header magic bytes.
- [Fix] <js> Gzip archives: In some cases, decompression failed despite the file being valid.

Misc
- [Fix] <js> Opening links through the Open File / Save File dialogs could lead to a crash (http://bugs.openmpt.org/view.php?id=1739).
- [Fix] <js> Allow end-of-tune optimizations for XM F00 command to also work with MIDI / OPL export (http://bugs.openmpt.org/view.php?id=1741).
- [Fix] <jh> OpenMPT no longer ran on Windows N editions without the Media Feature Pack installed since OpenMPT 1.31.01.00 (http://bugs.openmpt.org/view.php?id=1749).
- [Fix] <js> Keyboard Settings: Switching between categories broke in OpenMPT 1.31.04.00.
- [Fix] <js> Moving a plugin didn't update its MIDI mapping directives.
- [Fix] <js> MIDI Export: Exported drum keys were off by one since OpenMPT 1.30.03.00 unless Mapped mode was chosen.
- [Fix] <js> Copying an instrument from another module (through the tree view or when appending modules) that referenced a tuning didn't copy that tuning over to the current module, eventually leading to a crash when the other module was closed.
- [Fix] <js> Fixed possible inconsistent UI state after removing instruments.

Third-Party Libraries
- [Imp] Update Crypto++ (v8.9.0), mpg123 (v1.32.4), nlohmann-json (v3.11.3), UnRAR (v7.0.7) and zlib (v1.3.1)

Installer/release package
- [Mod] <js> Updated US_mpt_classic_(nobuyuki).mkb.


v1.31.04.00 (27 August 2023, revision 19605)
--------------------------------------------
Pattern tab
- [Mod] <js> Fixed volume and envelope position issues when seeking with sample sync and the target row contained a note without instrument number.

Sample tab
- [Fix] <js> IFF: The workaround for 8SVX files with claimed zero-length body chunks (to accommodate for http://bugs.openmpt.org/view.php?id=117) was too aggressive, causing also files with empty NAME chunks to not load properly (http://bugs.openmpt.org/view.php?id=1715).
- [Fix] <js> IFF: 16-bit mono samples were saved as little-endian instead of big-endian.
- [Fix] <js> Remove cue points from newly-created samples after slicing at cue points. The old cue points no longer make sense in the context of the new sample.

VST / DMO Plugins
- [Mod] <js> MIDI data is no longer sent to bypassed VST plugins.
- [Fix] <js> The new instrument plugin tone portamento mechanism broke after encountering a note-off event.

Bundled plugins
- [Fix] <js> MIDI I/O Plugin: Fix potential crash while suspending.

Misc
- [Imp] <js> MIDI pitch bend is now applied to samples outside of the pattern view as well (e.g. sample / instrument / comments tab).
- [Fix] <js> Improve scrolling support for laptops with precision touchpads (http://bugs.openmpt.org/view.php?id=1638).
- [Fix] <js> Clear find text boxes in keyboard settings when manually switching categories dropdown to avoid inconsistent display.

Third-Party Libraries
- [Imp] Update ancient (v2.1.1), Crypto++ (v8.8.0), FLAC (v1.4.3), unrar (v6.2.10) and zlib (v.1.3)


v1.31.03.00 (18 June 2023, revision 19401)
------------------------------------------
Tree view
- [Fix] <js> Since OpenMPT 1.31.01.00, refreshing the tree view was much slower than necessary when an item in the file browser was selected.

Pattern tab
- [Fix] <js> Interpolating a command with two independent nibble parameters caused a wrong result if the direction of interpolation differed between the two nibbles (tx NoobTracker).

Sample tab
- [Fix] <js> Trying to load unsupported files could sometimes cause the currently loaded sample data in that slot to be removed even if the raw sample import dialog was going to be shown later.

MOD
- [New] <js> Can now read modified 8-channel MOD files from the DOS game Aleshar - The World Of Ice.

Other formats
- [Fix] <js> MED: Fixed possible crash with some malformed files.

Misc
- [Mod] <jh> When updating portable installations, the update is now downloaded into the portable installation directory instead of the system's temporary directory, allowing to update several portable installations at the same time (http://bugs.openmpt.org/view.php?id=1702).
- [Fix] <js> Sustain point was disabled on soundfont drum keys with custom envelope, and envelope settings from a drum kit's global zone were not applied to individual drums (http://bugs.openmpt.org/view.php?id=1706).

Third-Party Libraries
- [Imp] Update lhasa (v0.4.0)


v1.31.02.00 (7 May 2023, revision 19251)
----------------------------------------
Pattern tab
- [Mod] <js> Special handling of Tab key on input fields was removed. The global shortcut for switching between upper / lower views should be used instead (http://bugs.openmpt.org/view.php?id=1697).

Sample tab
- [Fix] <js> Fixed some rounding issues when transposing samples especially at lower sample rates (tx elz).

IT
- [Imp] <js> Improved fingerprinting of early ModPlug Tracker versions.

Other formats
- [Imp] <js> XMF: Modules from Astroidea demos can now be read as well.

Misc
- [Imp] <js> Appending a module also merges its edit history (http://bugs.openmpt.org/view.php?id=1700).
- [Fix] <js> Switching between module formats could permanently erase user-assigned effect letter shortcuts (smooth MIDI macros, finetune, etc).
- [Fix] <js> Loading keyboard shortcuts from a file made automatically assigned effect letter shortcuts inaccessible (potentially fixes http://bugs.openmpt.org/view.php?id=1571).
- [Fix] <jh> Automatic updates were not available on builds for Windows XP and Vista, despite being advertised to work in OpenMPT 1.31 (http://bugs.openmpt.org/view.php?id=1699).

Installer/release package
- [Fix] <jh> For new installations, the installer for Windows XP and Vista suggested an incorrect default path (http://bugs.openmpt.org/view.php?id=1699).


v1.31.01.00 (30 April 2023, revision 19143)
-------------------------------------------
Tree view
- [New] <js> The instrument library can now be filtered. The default shortcut for invoking the filter is Ctrl + F. The filter supports * (any number of characters) and ? (single character) wildcards (http://bugs.openmpt.org/view.php?id=1566).
- [New] <js> The instrument library can now also be sorted by file size and modification date. Sorting can be changed through the context menu or user-defined keyboard shortcuts.
- [New] <js> Selecting a file in the instrument library now shows its file size and modification date in the status bar.
- [Imp] <js> Most keyboard shortcuts are now configurable.

General tab
- [Mod] <js> In OpenMPT 1.30, inserting a plugin before the current slot was changed to keep the moved plugin selected, instead of staying in the current (newly inserted) slot. This behaviour change was now reverted, as it is more likely that the user intends to insert a new plugin there and not change the settings of the moved plugins.

Pattern tab
- [New] <js> Added shortcuts to scroll the pattern view without having to use the mouse (tx isdera).
- [Imp] <js> Seeking with sample sync now supports portamento up / down and IMF / PTM note slides.
- [Imp] <js> Edit step and pattern navigation now also work beyond the next or previous pattern if the jumping distance is larger than the pattern size.
- [Imp] <js> Dummy command W can now be inserted into XM files for syncing purposes in other module players (http://bugs.openmpt.org/view.php?id=1373).
- [Imp] <js> Effect visualizer: For PC events, the currently edited plugin parameter can now be selected from a dropdown menu (http://bugs.openmpt.org/view.php?id=1677).
- [Imp] <js> Improved focus handling on the instrument selection dropdown: Navigating using cursor keys no longer reverts the keyboard focus back to the pattern editor immediately.
- [Mod] <js> The selection key being pressed no longer causes automatic cursor moves caused by Edit Step to stop at the pattern end (http://bugs.openmpt.org/view.php?id=1698).
- [Mod] <js> The hidden setting "Pattern Editor.DefaultSequenceMargins" is now applied to the scroll bar range, too.

Sample tab
- [New] <js> It is now possible to follow the play cursor when the sample waveform is zoomed in and not fully visible, as long as only a single note is being previewed. This can be enabled through the settings dialog or a keyboard shortcut (Shift + F by default).
- [New] <js> Added two new shortcuts to finetune the sample rate, working the same way as the spin buttons on the finetune / sample rate edit field. Default bindings are Shift + Up / Down.
- [New] <js> Samples can now be saved as Amiga IFF (8SVX / 16SVX) as well.
- [Imp] <js> Double-clicking a timeline item now pops up an input dialog for finetuning that item.
- [Reg] <js> Completely removed the hideable warning when trying to do sign conversion on a sample currently playing. This feature broke a long while ago with the default sample play behaviour anyway.

Comments tab
- [New] <js> Instruments and samples can now be previewed via MIDI input as well.
- [Imp] <js> Added mono / stereo indication to sample list. Sample size formatting is now more flexible.
- [Fix] <js> Windows error sound no longer plays when holding keys for note preview.

VST / DMO Plugins
- [New] <js> Tone portamento can now be applied to plugins the same way as it works for samples (assuming that the target note is within the plugin's pitch bend range), and as a result now works properly in MIDI export as well.
- [New] <js> Individual plugins can now be auto-suspended if they output silence for four seconds. As before, the default auto-suspend state for newly added plugins can be set through the hidden setting "VST Plugins.EnableAutoSuspend" (http://bugs.openmpt.org/view.php?id=605).
- [Mod] <js> Arpeggio notes no longer reset the current pitch bend position. Fixed some other arpeggio edge cases as well.

Playback
- [Imp] <js> Reduced aliasing when downsampling with the Sinc + Low-Pass resampler (tx eightbitbubsy).
- [Imp] <js> XM fine portamentos are now also sent to plugins and also work when exporting XM to MIDI.
- [Mod] <js> The sample position is now rounded instead of truncated when resampling without interpolation.
- [Mod] <js> The filter cutoff frequency is no longer rounded to integer frequency values.
- [Mod] <js> Recalling a sample's default volume using an instrument number (as opposed to regular volume commands) previously ramped the volume change smoothly over a whole tick. Now the user-configured ramp settings are used instead (as it would happen when using a volume command to achieve the same effect, http://bugs.openmpt.org/view.php?id=1666).

IT
- [Mod] <js> Mono samples are now stored with lossless IT sample compression by default. As compressed stereo samples are still not supported properly by some software that is most likely not going to be updated anymore, compression for stereo samples remain disabled for now (but can, as before, still be enabled through the hidden setting "Misc.ITCompressionStereo").

IT::Compatible Playback Mode
- [Fix] <js> Initial "last note memory" of every channel is C-0, so a lone instrument number without note triggers that note.

S3M
- [Imp] <js> Better approximation of old "stereo control" SAx command used in Purple Motion's PANIC.S3M.
- [Fix] <js> In ScreamTracker 3.03 and later, OPL notes with tone portamento next to them are delayed until the next row and then the new pitch is used instantly (http://bugs.openmpt.org/view.php?id=1613).

MOD
- [Fix] <js> Lone instrument number with retrigger effect should swap sample immediately. Fixes "catfood" by no9 (http://bugs.openmpt.org/view.php?id=1584).

Other formats
- [New] <js> Can now read 667 (Composer 667) modules.
- [New] <js> Can now read GTK (Graoumf Tracker) and GT2 (Graoumf Tracker / Graoumf Tracker 2) modules.
- [New] <js> Can now read a variant of the DSMI AMF format called DMF, as found in various DOS games distributed by Webfoot (Tronic, H2O, PowBall, etc.).
- [New] <js> Can now read DSM modules made with Dynamic Studio.
- [New] <js> Can now read XMF modules from the DOS game Imperium Galactica.
- [New] <js> Can now read the hacked MOD format (.DMF) from the game "Apocalypse Abyss".
- [Imp] <js> MED: Tempos higher than 255 BPM are now tried to be imported using Parameter Extension (#xx) mechanism (http://bugs.openmpt.org/view.php?id=1665).
- [Imp] <js> MED: MMD1 files with more than 16 channels are now supported.
- [Imp] <js> ULT: Import 8-bit volume commands with full precision.
- [Mod] <js> DSM: Remove special handling for non-MOD effects in DSIK DSM files. The origin of those effect commands is actually the newly-supported Dynamic Studio DSM format, not the DSIK DSM format.
- [Fix] <js> MO3: Envelope sustain was not imported correctly if the source file was an XM (http://bugs.openmpt.org/view.php?id=1695).
- [Fix] <js> In OpenMPT 1.30, it was no longer possible to load MMCMP / PP20 / XPK-compressed modules inside ZIP / RAR / LHA containers. This is now possible again (http://bugs.openmpt.org/view.php?id=1549).

Stream Export
- [Imp] <jh> FLAC: Added 32-Bit output support.

Module cleanup
- [Imp] <js> In instrument mode, the whole module is rendered virtually for more accurate detection of unused samples. This takes a bit more time, but finds unused samples more reliably. Especially if a pattern started with an instrument-less note on some channel, that note was marked as used for any instrument, leading to unused samples not being detected.

Misc
- [New] <js> Added two new shortcuts: Play Song from Cursor / Pause and Play Song from Pattern Start / Pause (http://bugs.openmpt.org/view.php?id=1619).
- [Imp] <js> Instead of re-adding all non-conflicting default shortcuts every time a keymap is loaded, they will now only be added if the keymap was last saved with an older version of OpenMPT than the version that introduced the default shortcut (http://bugs.openmpt.org/view.php?id=1615).
- [Imp] <js> DLS / SF2: Added support for delay and hold envelope sections as well as pitch envelopes. Individual envelopes for each drum key are now supported.
- [Imp] <js> "Last saved with" field in Song Properties now indicates whether the module was saved with ModPlug Player ADPCM sample compression.
- [Imp] <js> MIDI Export: Channel panning is now exported as MIDI CC 10. If several notes play on the same MIDI channel, the last triggered note's panning is always considered.
- [Imp] <jh> Builds for Windows XP and Vista can now receive automatic updates as well.
- [Mod] <js> When a text field is focussed, native text field shortcuts (such as Ctrl + A and others) are now preferred over OpenMPT shortcuts that are specific to the current view. Previously, they already took precedence over global OpenMPT shortcuts that apply to all views.
- [Mod] <js> When a text field is focussed, global shortcuts using Shift + Enter or just Enter are no longer blocked if the text field is a single-line field, as well as Alt + Cursor keys in any text fields.
- [Mod] <js> When pressing the Play / Stop shortcut while the song is in paused or step mode, playback now continues as with the Play / Pause shortcut.
- [Mod] <js> Channel Manager: Channel color gradient is now right-aligned so that it does not clash with the mute / select indicators.
- [Reg] <jh> The minimum supported operating version for modern builds is now Windows 10 21H2 Build 19042. Older Windows 10 versions are still supported by legacy builds.

Third-Party Libraries
- [Imp] Update opus (v1.4), r8brain (v6.2) and RtMidi (v5.0.0)


v1.30.12.00 (15 April 2023, revision 19028)
-------------------------------------------
Sample tab
- [Fix] <js> Stopping a sample preview could stop unrelated plugin notes.

Instrument tab
- [Fix] <js> Saving ITI files with embedded samples created broken ITI files if the source samples were marked as external (http://forum.openmpt.org/index.php?topic=6957.0).

MOD
- [Imp] <js> VBlank heuristics are now applied to MOD files with M!K! signature. Fixes mod.siedler ii (tx AliceLR).
- [Mod] <js> NoiseTracker MODs are now always played with VBlank timing (tx AliceLR).

Other formats
- [Imp] <js> MED: Add support for default instrument pitch.
- [Mod] <js> 669: Reject files with lots of control characters in song message.
- [Fix] <js> MED: Global play transpose value was not considered for MMD0 files.

Misc
- [Imp] <js> Allow arrow up / down keys and scroll wheel to modify various edit fields in Stream Export and settings dialogs.
- [Imp] <js> Tab order in Plugin Manager was changed to make the plugin list reachable more easily (http://bugs.openmpt.org/view.php?id=1680).
- [Fix] <js> In OpenMPT 1.30.11.00, browsing for all module types showed all 3-letter file extensions in addition to modules (http://bugs.openmpt.org/view.php?id=1678).
- [Fix] <js> Song length calculation stopped at first encountered F00 command in XM files instead of looking for further sub songs.

Third-Party Libraries
- [Imp] Update mpg123 (v1.31.3)


v1.30.11.00 (5 March 2023, revision 18811)
------------------------------------------
Tree view
- [Fix] <js> When previewing soundfont or MIDI library items, a click was heard on note-off (http://bugs.openmpt.org/view.php?id=1659).

Pattern tab
- [Imp] <js> Quick Paste only sets the module as modified if the pattern contents were changed.
- [Fix] <js> Don't allow notes or effects not supported by the current module type to be pasted through Quick Cursor Paste.
- [Fix] <js> After seeking with sample sync, the filter settings of playing notes were not updated since OpenMPT 1.30.09.00.
- [Fix] <js> Effect info: XM commands E10 / E20 / EA0 / EB0 now correctly show "continue" for parameter info.

Sample tab
- [Imp] <js> The correct endianness of 16SV IFF sample data is now determined heuristically, to support both IFF files created by some (broken) PC software and files using the correct endianness.
- [Imp] <js> Fix single-cycle loops in some IFF samples.

Instrument tab
- [Fix] <js> If the first notes assigned to a sample in a key map required no transposition but the transposition changed for higher notes, the "Transpose Samples / Reset Map" feature was still available, even though it shouldn't be.
- [Fix] <js> Possible crash when hovering the envelope area of malformed instruments with a set release node but no envelope points (http://bugs.openmpt.org/view.php?id=1672).

Mod Conversion
- [Fix] <js> MOD commands E10 / E20 / EA0 / EB0 are no longer preserved when converting to other formats, as the MOD format applies no effect memory for them.

Playback
- [Fix] <js> The fix for the OPL cutoff bug introduced in OpenMPT 1.30.09.00 was incomplete (http://bugs.openmpt.org/view.php?id=1671).
- [Fix] <js> Avoid potential deadlock when a VST plugin is auto-bypassed due to an exception.
- [Fix] <js> Possible crash when playing instruments with a set release node but no envelope points (http://bugs.openmpt.org/view.php?id=1672).

Other formats
- [Fix] <js> ULT: Offset commands exceeding 65535 samples were sometimes not imported correctly even if there was room for them.

Misc
- [Fix] <js> When saving modules extracted from ZIP files and other archive types, there was no prompt for a new filename, instead overwriting the original archive file.
- [Fix] <js> Song length calculation and seeking in (malformed) modules with thousands of short sub-songs has been sped up.

Third-Party Libraries
- [Imp] Update UnRAR (v6.2.6)


v1.30.10.00 (29 January 2023, revision 18674)
---------------------------------------------
Pattern tab
- [Fix] <js> When jumping around in the module, the tempo was sometimes incorrectly limited to 255 BPM.

Sample tab
- [Fix] <js> Normalizing all samples or removing DC offset from all samples didn't mark external samples as modified (except for the currently selected one).

Instrument tab
- [Fix] <js> Previewing filtered instruments produced a repetitive click sound in OpenMPT 1.30.09.00 (http://bugs.openmpt.org/view.php?id=1655).

Comments tab
- [Fix] <js> The displayed middle-C frequency was slightly off for MOD files.

Mod Conversion
- [Fix] <js> Translation between MOD / XM E5x and MPTM / IT / S3M S2x Set Finetune commands did not take the different scales of the commands into account.
- [Fix] <js> Wrong PAL middle-C frequency was used when converting from MOD to MPTM / IT / S3M.

Playback
- [Fix] <js> Initial instrument cutoff was broken for OPL instruments in OpenMPT 1.30.09.00 (http://bugs.openmpt.org/view.php?id=1657).

Other formats
- [Fix] <js> Loading DSym files was completely broken in OpenMPT 1.30.09.00.

Misc
- [Fix] <jh> After auto-updating from a previous version with no modules open, an empty module was created.

Third-Party Libraries
- [Imp] Update mpg123 (v1.31.2)


v1.30.09.00 (8 January 2023, revision 18451)
--------------------------------------------
Tree view
- [Fix] <js> Instead of playing silence, preview for missing MIDI library soundfont items was falling back to the first instrument in the soundfont.
- [Mod] <js> ZIP files are no longer tried to be resolved as links in the file browser. This may slightly speed up populating the file browser, and should fix a potential crash reported by a user (http://bugs.openmpt.org/view.php?id=1645).

Pattern tab
- [Imp] <js> When recording MIDI pitch bend events, changes are now applied live (http://bugs.openmpt.org/view.php?id=1640).
- [Imp] <js> VU meters now scale better with larger pattern fonts and high-DPI displays.
- [Fix] <js> After removing channels, the pattern cursor sometimes became invisible if the channel it was previously located in no longer existed.

Sample tab
- [Fix] <js> Vertical lines sometimes showed up in zoomed-in waveforms.
- [Fix] <js> The dragging improvements from OpenMPT 1.30.04.00 are no longer applied to cue points and loop points, as the old behaviour is arguably better-suited there.
- [Fix] <js> Avoid overwriting sample slot when loading an OPL instrument from an S3I file but current format doesn't support OPL.
- [Fix] <js> The forward / backward mouse buttons to navigate to the next / previous sample slot now also work when clicking into the OPL editor.

Instrument tab
- [Fix] <js> Live update of filter settings only worked for running notes if the filter envelope was active.

IT
- [Fix] <js> In sample mode, portamento to a different sample turns off the filter if cutoff / resonance was previously 127 / 0.

S3M
- [Imp] <js> Detect files saved with Graoumf Tracker instead of claiming they were made with OpenMPT 4.47.
- [Fix] <js> Pattern loop state was not propagated anymore since OpenMPT 1.30, leading to wrong song length calculation and SB0 + SBx being located on different channels not working properly anymore (http://bugs.openmpt.org/view.php?id=1641).

Bundled plugins
- [Imp] <js> MIDI I/O Plugin: MIDI Start message is no longer sent when previewing notes in pattern / sample / instrument editors or when pattern stepping is enabled (http://forum.openmpt.org/index.php?topic=6880.0).

Misc
- [Fix] <jh> Update Check: On modern portable amd64 installations, updates for the legacy version were downloaded instead (http://bugs.openmpt.org/view.php?id=1642).

Third-Party Libraries
- [Imp] Update UnRAR (v6.2.3)


v1.30.08.00 (13 November 2022, revision 18159)
----------------------------------------------
Pattern tab
- [Imp] <js> More accurate effect description when combining volume column cue points with regular offset.

Sample tab
- [Fix] <js> Avoid drawing sample waveform from uninitialized memory under some very specific circumstances.

Other formats
- [Fix] <js> MO3: Sample filenames were not imported correctly.

Module cleanup
- [Fix] <js> Automatic Sample Trimmer: Avoid over-trimming samples that are used for MOD-style sample swapping - it is important that the whole sample is preserved in this case even if it is playing completely silently, as the timing of sample swap depends on reaching that sample's end or loop end.

Stream Export
- [Fix] <jh> Little-endian RAW export was broken since OpenMPT 1.30.01.00, exporting big-endian samples instead.

Misc
- [New] <js> Added Play / Stop shortcut (http://bugs.openmpt.org/view.php?id=1619).
- [Imp] <js> Keyboard Settings: If no choices are set, the Restore button now restores all default choices for the given shortcut (http://bugs.openmpt.org/view.php?id=1630).
- [Fix] <js> OPL Export: Pressing the Cancel button didn't abort the conversion process.
- [Fix] <kk & js> Most keyboard shortcuts were not accessible with Microsoft's RDP client for iOS and potentially other virtual keyboards (http://bugs.openmpt.org/view.php?id=1634).

Third-Party Libraries
- [Imp] Update flac (v1.4.2), mpg123 (v1.31.1) and UnRAR (v6.2.2)


v1.30.07.00 (25 September 2022, revision 17944)
-----------------------------------------------
Tree view
- [Imp] <js> Allow ESC to cancel label editing.

Pattern tab
- [Mod] <js> Clarify that a 0 digit means using the previous value in the effect info of vibrato / tremolo / panbrello pattern commands.

Sample tab
- [Imp] <jh> 32-bit FLAC files can now be read.
- [Fix] <js> Inserting or deleting cue points no longer marks external samples as modified.

Instrument tab
- [Fix] <js> SFZ: Don't import one-shot loop type as an actual loop. The only difference to the no_loop type is the note-off behaviour.

VST / DMO Plugins
- [Fix] <js> Previous notes were not stopped properly when a new note was struck and all mix channels were occupied.

Playback
- [Fix] <js> Possible crash when playing manipulated IT / MPTM files with a T00 command.

Other formats
- [Imp] <js> MID: Fall back to just finding suitable soundfont instrument by MSB bank if MSB + LSB search was not successful. This is particularly relevant for SF2 soundfonts as they only support the bank MSB (http://bugs.openmpt.org/view.php?id=1628).
- [Fix] <js> MTM: In MultiTracker, setting speed and tempo are mutually exclusive commands. Still, some MultiTracker modules were made to be played with external players such as DMP, so they actually rely on "standard" speed / tempo behaviour. Decide which behaviour to use by checking of speed and tempo commands are found on the same row (tx AliceLR).
- [Fix] <js> MTM: Ignore sample loops if the loop end is <= 2.

Bundled plugins
- [Fix] <js> Echo DMO: Migrate left and right delay values in modules made with OpenMPT versions between 1.27.01.00 and 1.30.05.00 to the correct interpretation (http://bugs.openmpt.org/view.php?id=1631).

Misc
- [Fix] <js> MIDI Export: Fixed some issues with stuck notes and inconsistent state updates between channels.

Third-Party Libraries
- [Imp] Update flac (v1.4.1)


v1.30.06.00 (21 August 2022, revision 17755)
--------------------------------------------
Tree view
- [Fix] <js> Under some circumstances (e.g. after removing all unused patterns in Song Cleanup and then removing all patterns in a second Song Cleanup), the complete upper tree view could be emptied, eventually leading to a crash (tx eightbitbubsy).
- [Fix] <js> Show BRR files in sample browser (http://bugs.openmpt.org/view.php?id=1617).

Pattern tab
- [Imp] <js> In multi-channel record mode, PC events (both when recorded from plugin or via MIDI mapping) are now distributed to all channels of the current record group (http://bugs.openmpt.org/view.php?id=1622).

Sample tab
- [Fix] <js> Calculate correct selection point after scrolling with an 1:x zoom factor (http://bugs.openmpt.org/view.php?id=1611).
- [Fix] <js> When the crossfade dialog was allowed to be opened because normal loop points were set despite the loop itself not being enabled, it still tried to use the sustain loop points instead, even if they resulted in an empty loop.

VST / DMO Plugins
- [Fix] <js> Don't send All Controllers Off to T-Force Trance Gate 2 plugin, as it also resets some user-configured parameters such as resonance (http://bugs.openmpt.org/view.php?id=1610).

Other formats
- [Fix] <js> DBM: Sample middle-C frequencies were slightly off. laffik_-_marynarze.dbm sounds much more bearable now.
- [Fix] <js> DBM: Fixed pattern break parameter interpretation.

Bundled plugins
- [Fix] <js> Echo DMO: Setting the delay parameter to 0 yielded a 2-second echo delay instead of 1ms.
- [Fix] <js> Digi Booster Echo: Setting the delay parameter to 0 yielded a 510ms echo delay instead of approximately 334ms.

Third-Party Libraries
- [Imp] Update mpg123 (v1.30.2), nlohmann json (v3.11.2) and UnRAR (v6.1.7)


v1.30.05.00 (12 June 2022, revision 17503)
------------------------------------------
Tree view
- [New] <js> Can now (un-)bypass all plugins at once through the tree view, or alternatively just all effect plugins (http://bugs.openmpt.org/view.php?id=1410).

Pattern tab
- [Imp] <js> Allow "Jump to previous / next entry in column" shortcuts to be used together with the selection key. Search is only performed in the current pattern in this case (http://bugs.openmpt.org/view.php?id=1598).
- [Mod] <js> There are now default key bindings for "Jump to previous / next entry in column" (Ctrl + Alt + Up / Down).
- [Fix] <js> When stalling the pattern auto-follow (e.g. while drawing a selection) and transitioning to the next order containing the same pattern again, the order list and pattern editor weren't updated to reflect the new order position (tx NoobTracker).
- [Fix] <js> When the currently selected order item contained the same pattern as the first order item, restarting song playback gave the visual impression that the previously selected order item was still being played instead of the first order item.

Sample tab
- [Fix] <js> Consecutive transposition especially with middle-C frequencies below 8363 Hz could cause a wrong sample rate to be calculated in IT / MPTM.
- [Fix] <js> Displaying extremely long samples with a very low sample rate could cause OpenMPT to hang.

Instrument tab
- [New] <js> Added a new option to the sample map context menu, "Transpose Samples / Reset Map", which - if at all possible - resets the instrument's note mapping to the default and compensates for that by transposing samples instead (http://bugs.openmpt.org/view.php?id=1596).

Mod Conversion
- [Fix] <js> Remove portamento up / down and volume slide commands with parameter 00 when converting from MOD.

Playback
- [Fix] <js> Bidi-looped samples sometimes stopped playing at the end of the loop (http://bugs.openmpt.org/view.php?id=1597).

Installer/release package
- [Mod] <js> Re-mapped some assignments in DE_jojo.mkb to match newly added default shortcuts.


v1.30.04.00 (24 April 2022, revision 17270)
-------------------------------------------
Tree view
- [Imp] <js> Allow plugin instances to be removed through the context menu or pressing the Delete key (http://bugs.openmpt.org/view.php?id=1583).

General tab
- [Imp] <js> Allow plugin instances to be removed with a dedicated button (http://bugs.openmpt.org/view.php?id=1583).

Pattern tab
- [Imp] <js> Parameter Editor: Remember last window position in addition to size (http://bugs.openmpt.org/view.php?id=1579).
- [Fix] <js> Pitch / Pan Separation and Random Variation instrument properties were not resetting properly when seeking, potentially causing instruments to be played e.g. at a vastly different pan position compared to playing the module continuously.

Sample tab
- [Imp] <js> When in instrument mode, slicing at cue points now assigns the sample name to newly added instruments.
- [Mod] <js> Allow broken SBI files created with JuceOPLVSTi to be loaded.
- [Mod] <js> The sample grid is no longer applied to sample drawing.
- [Fix] <js> Drawing sample data with Shift pressed could cause a crash in OpenMPT 1.30.03.00 (http://bugs.openmpt.org/view.php?id=1592).
- [Fix] <js> Dragging improvements from OpenMPT 1.30.03.00 actually made things worse when zooming into a sample (http://bugs.openmpt.org/view.php?id=1581).

Other formats
- [Fix] <js> MED: Stereo samples were not imported correctly.

Misc
- [Fix] <js> Fixed a crash when trying to play song from current pattern if the pattern is not part of the current order list.

Third-Party Libraries
- [Imp] Update zlib (v1.2.12)


v1.30.03.00 (13 March 2022, revision 17105)
-------------------------------------------
Tree view
- [Fix] <js> Avoid playing a sound when double-clicking the folder of a soundfont drum instrument (http://bugs.openmpt.org/view.php?id=1516).

General tab
- [Imp] <js> Plugin dry / wet ratio display is now updated immediately when modified through macros or plugin volume handling (http://bugs.openmpt.org/view.php?id=1463).
- [Fix] <js> The tempo slider position was not set correctly in the MPTM format (tx coda).

Pattern tab
- [Imp] <js> The base octave setting now respects the current instrument's group size where possible (http://bugs.openmpt.org/view.php?id=1568).
- [Imp] <js> Goto Dialog: Limit channel and row spinners to current pattern and module limits (http://bugs.openmpt.org/view.php?id=1575).
- [Mod] <js> Data Entry shortcuts and Ctrl + Scroll Wheel now only affect "special" notes if no regular notes are selected (http://bugs.openmpt.org/view.php?id=1573).
- [Fix] <js> Go To Dialog: Fixed rare crash when module is playing while the jump is being applied (http://bugs.openmpt.org/view.php?id=1578).
- [Fix] <js> Correctly apply shared effect memory when seeking in S3M files.
- [Fix] <js> Apply Command S (S3M / IT / MPTM) effect memory when seeking.

Sample tab
- [Imp] <js> Improve behaviour when dragging a timeline item in the sample editor and the initial grab point wasn't exactly the horizontal position of the item.

Mod Conversion
- [Fix] <js> MOD / XM command EBF conversion was broken in OpenMPT 1.30.02.00.

VST / DMO Plugins
- [Mod] <js> Apply (hidden) auto-suspend setting when new adding plugins to a module, not when creating a plugin instance (which also happens when loading an existing module).
- [Fix] <js> With malformed modules, the LFO plugin could output invalid parameter changes to other plugins, causing a crash depending on how the target plugin handles such invalid parameters.

Playback
- [Fix] <js> Fixed potential crash when using the Amiga BLEP resampler and playing extremely high notes.

Other formats
- [Fix] <js> MO3: Pattern indices 254 / 255 are no longer treated as +++ / --- when the original file was a MOD / XM.

Misc
- [Imp] <js> Apply default channel colors when changing the number of channels via Song Properties.
- [Mod] <js> The active instrument is now remembered more consistently when switching between tabs. This allows to e.g. change to a specific instrument in the pattern editor, then go to the instrument editor and see the same instrument there (as before) and finally go to the sample editor and also see the correct sample there.
- [Mod] <js> MIDI Export: Default to mapped drum export.

Third-Party Libraries
- [Imp] Update flac (v1.3.4), r8brain (v5.6) and UnRAR (v6.1.6)


v1.30.02.00 (30 January 2022, revision 16761)
---------------------------------------------
Tree view
- [Fix] <js> Display of large directories could be rather slow due to trying to resolve links for pretty much any file.
- [Fix] <js> When browsing the contents of a module, the "back" mouse button now behaves the same as the backspace key (it goes back to the directory containing the module).

General tab
- [Imp] <js> Added tooltips to disabled controls explaining why they are disabled.

Pattern tab
- [New] <js> New option "Play whole row when navigating" can be found in the general settings to play the current row when navigating vertically.
- [New] <js> New keyboard shortcut "Toggle row playback when navigating" to toggle aforementioned option without having to visit general settings.
- [Imp] <js> Seeking in the module now updates filter state, plugin dry / wet ratio and plugin parameter changes from MIDI macros (http://bugs.openmpt.org/view.php?id=1497).
- [Imp] <js> Better display of finetune command semantics when there's an instrument number next to the command (http://bugs.openmpt.org/view.php?id=1536).
- [Fix] <js> Note Properties: Switching to / from an extended command broke effect parameter display (http://bugs.openmpt.org/view.php?id=1535).

Sample tab
- [Imp] <js> Added timeline context menu entry to quickly add a cue point if there are any unused cue points (http://forum.openmpt.org/index.php?topic=6767.0).
- [Imp] <js> Added .sam to recognized raw sample extensions (http://bugs.openmpt.org/view.php?id=1546).
- [Imp] <js> When an exising sample already uses the .s3i extension, offer it as the default format to save the sample (http://bugs.openmpt.org/view.php?id=1546).
- [Mod] <js> Allow sustain loops to be edited even if the current format doesn't support them, in case they were imported from another format (http://bugs.openmpt.org/view.php?id=1544).
- [Mod] <js> Newly created samples no longer set the default cue points to multiples of 2048 samples (http://bugs.openmpt.org/view.php?id=1540).
- [Fix] <js> Fixed a crash when hovering sample display of a sample slot that failed to load an external sample.
- [Fix] <js> The sample value shown as percentage in the status bar was displayed as a value between 0 and 1 instead of 0 and 100 as intended.

Mod Conversion
- [Fix] <js> MOD / XM command EBF is now converted to MPTM / IT / S3M command DFE instead of DFF, as the latter slides up, not down.

Playback
- [Mod] <js> The letter "z" is now evaluated in fixed MIDI macros (Z80...ZFF) the same way as in Impulse Tracker.

MPTM
- [Fix] <js> Avoid using NaN or infinite values for tuning when reading corrupted custom tunings.

S3M
- [Fix] <js> Introducing the "Send OPL key-off when triggering notes" compatibility setting broke retrigger for OPL notes again (they retriggered rather than not retriggering).
- [Fix] <js> Retriggering a note no longer resets its pitch after a portamento, just like in IT.
- [Fix] <js> Partially implement retrigger behaviour for stopped notes in SoundBlaster mode: Like in IT, it is not possible to retrigger a sample that has already stopped playing.

MOD
- [Imp] <js> Validate the contents of "hidden" patterns beyond the end of the order list when the file size matches the expected size when only taken "official" patterns into account. This fixes Shofixti Ditty.mod from Star Control 2 while keeping other (partly broken) modules working.
- [Fix] <js> Loosened VBlank timing heuristics so that "frame of mind" by Dascon plays correctly.

Other formats
- [Fix] <js> DIGI: Improve compatibility with E3x reverse sample command.
- [Fix] <js> DSym: Tempos < 32 were treated as tempo slides (http://bugs.openmpt.org/view.php?id=1545).
- [Fix] <js> MED: Command 20 (reverse sample) should only be applied when it's next to a note.
- [Fix] <js> SymMOD: Key-off command was not implemented properly.
- [Fix] <js> Fixed a possible hang when closing a module containing 65536 or more patterns.

Module cleanup
- [Fix] <js> The automatic sample trimmer sometimes calculated incorrect sizes for samples played in reverse and bidi-looped samples (http://bugs.openmpt.org/view.php?id=1547).

Misc
- [Imp] <js> Improved startup time for OpenMPT configurations with many / large soundfonts.
- [Imp] <js> SF2: Support tuning on the preset level.
- [Imp] <js> Added S3I to default format choice in sample editor settings.
- [Imp] <js> The default artist name can now be set in the Welcome dialog.
- [Mod] <js> When opening files, they are now first tried to be loaded as modules, and only when that fails they are tried again as an archive. This fixes loading songs using plugins that store their plugin data chunk as a ZIP file (e.g. RetroPlug, http://bugs.openmpt.org/view.php?id=1548).
- [Mod] <js> The VSTNeverUnloadAnyPlugin hidden setting introduced in OpenMPT 1.30.01.00 was moved from the INI category "BrokenPluginWorkarounds" to category "Broken Plugin Workarounds" (same as VSTMaskAllCrashes setting).
- [Fix] <js> When trying to open a malformed file in a new OpenMPT instance and sending this file to an already running OpenMPT instance, the newly launched instance tried to open the file a second time after the other instance gave up, so two error messages were shown.
- [Fix] <js> When passing files to an already running OpenMPT instance, this instance is now moved to the foreground before sending files over, not after. This makes it possible to instantly see error messages in that other instance before it has given control back to the newly launched instance.
- [Fix] <js> The search filter in the compatibility settings dialog was case sensitive.
- [Fix] <js> Fixed a crash when there's an invalid character in a MIDI macro string that wasn't entered by the user in the MIDI macro dialog but was already present in the file.

Bundled plugins
- [Fix] <js> I3DL2Reverb: Fix possible output of NaN values with some extremely impractical set of reverb parameters.

Third-Party Libraries
- [Imp] Update ancient (v2.0.0), nlohmann json (v3.10.5) and UnRAR (v6.1.4)


v1.30.01.00 (23 December 2021, revision 16290)
----------------------------------------------
Tree view
- [Imp] <js> It is now possible to also load instruments from the MIDI library or soundfonts into the sample / instrument tab using Ctrl + (Shift +) Enter (http://bugs.openmpt.org/view.php?id=1491).
- [Imp] <js> It is now possible to extract a complete soundfont drum kit into a single instrument slot by dragging its folder rather than an individual note (tx Keffie).

General tab
- [Imp] <js> Changes to channel properties can now be undone and redone.
- [Imp] <js> Tooltips are shown for channel volume and panning sliders as well as plugin gain.
- [Imp] <js> User-chosen plugin names are now shown in addition to library names in plugin dropdown list.

Pattern tab
- [New] <js> Channels can now be color-coded. In addition to the pattern editor, channel color is also shown and editable in the General Tab, Quick Channel Settings and Channel Manager. Default colors can be changed in Display settings (http://bugs.openmpt.org/view.php?id=1316).
- [New] <js> Pattern Goto Dialog: Can now directly jump to a timestamp.
- [Imp] <js> Quick Channel Settings: Tooltips are shown for volume and panning sliders.
- [Mod] <js> Selecting a non-existing pattern in the order list now no longer keeps displaying the previously edited pattern, to avoid giving the impression that the recently-selected pattern is actually being edited.
- [Mod] <js> Typing in a pattern number into the order list now instantly updates the displayed pattern.
- [Mod] <js> "Dummy" commands are now shown as semi-transparent text.
- [Fix] <js> Fix issues with Data Entry shortcuts on commands that take two nibble parameters (e.g. volume slides).

Sample tab
- [New] <js> Added a timeline which shows sample positions in seconds or samples, and visualizes loop points and cue points, allowing them to be dragged around with the mouse. Press Shift while dragging for finetuning (http://bugs.openmpt.org/view.php?id=659).
- [New] <js> Added option to convert ping-pong loops to unidirectional loops (http://bugs.openmpt.org/view.php?id=1376).
- [New] <js> Resampling can now optionally adjust offset commands in patterns. This does not work properly with offsets affected by the SAx "high offset" command currently.
- [New] <js> Raw sample import can now try to automatically determine the correct raw format. More raw format options are now available, too.
- [New] <js> IFF MAUD samples can now be imported.
- [New] <js> The sample value under mouse cursor is now shown in the status bar.
- [Imp] <js> Cue points can now be deleted by right-clicking their marker in the timeline.
- [Imp] <js> Speed up redrawing of sample waveform when modifying the sample selection or loop points.
- [Imp] <js> Loading or renaming a sample now automatically updates the associated instrument's name too if the instrument previously had the same name as the sample or no name, and if no other samples are assigned to it (http://bugs.openmpt.org/view.php?id=1445).
- [Imp] <js> Time stretch parameter setup is now more usable.
- [Imp] <js> Dropping an item from the tree view with Shift pressed now drops it into a new sample slot.
- [Imp] <js> Added a shortcut for raw sample import.
- [Mod] <js> Opus / Vorbis: Instead of rejecting large samples, they are now trimmed to the maximum supported length and a warning is shown.

Instrument tab
- [Imp] <js> Dropping an item from the tree view with Shift pressed now drops it into a new instrument slot.
- [Imp] <js> Zoom level is now remembered when switching between tabs (http://bugs.openmpt.org/view.php?id=1506).

Mod Conversion
- [Imp] <js> Ping-pong loops are now automatically converted to unidirectional loops when converting to MOD / S3M.
- [Mod] <js> Converting to MPTM no longer asks if the order list should be split into multiple sequences if it contains separator items. This action can still be carried out manually from the order list context menu instead.

VST / DMO Plugins
- [New] <jh> OpenMPT and the default plugin bridge now use Data Execution Prevention by default. For older plugins that are not compatible with DEP, high-entropy ASLR or Large Address Awareness, a legacy plugin bridge is provided, which will be used for all plugins previously added to OpenMPT. Newly added plugins will not use the legacy bridge, unless they are detected to require it or if the user chooses so (http://bugs.openmpt.org/view.php?id=1291, http://bugs.openmpt.org/view.php?id=1402).
- [Imp] <js> Plugin Editor: Added a menu item to rename the plugin instance.
- [Imp] <js> Plugin Editor: Bypass status is now shown in title bar.
- [Mod] <jh> A new hidden settings "Broken Plugins Workarounds.VSTMaskAllCrashes" was added that no longer catches crashes in VST plugins but rather passes them on directly to the crash handler (http://bugs.openmpt.org/view.php?id=1401).
- [Fix] <js> When implementing the Flanger DMO effect, some details in the original effect were overlooked. For modules made with OpenMPT 1.27 - 1.29, a legacy plugin using the old implementation (close to the Chorus DMO) is provided (this does not show up in the Plugin Manager) and used automatically in those modules (http://bugs.openmpt.org/view.php?id=1474).
- [Fix] <js> If an instrument's MIDI program or bank was set to 1, it wasn't transmitted together with the first note playing on that channel, only when a different program or bank was previously chosen on that channel.

Playback
- [Imp] <js> Improved precision of ping-pong loop length particularly for very small samples.
- [Fix] <js> By default, an OPL note-off message is now sent on every note change. Most of the time, there is no audible difference, but this fixes missing notes in ADLIBSP.S3M. The old behaviour is retained through a compatibility flag (http://bugs.openmpt.org/view.php?id=1446).
- [Fix] <js> Samples played at the wrong volume when rendering or playing modules in mono (http://forum.openmpt.org/index.php?topic=6711.0).
- [Fix] <js> Even after OpenMPT 1.29.15.00 the filter reset logic was still not 100% identical to Impulse Tracker: A note triggered on tick 0 of a row with a Pattern Delay effect still caused the filter to be reset on repetitions of that row even though the note wasn't retriggered.

MPTM
- [New] <js> Volume column o00 + effect column Oxx now work together as percentage offset. If parameter extension #xx is used, it increases the granularity of the percentage. SAx does not affect this command combination.
- [New] <js> Volume column oyy + effect column Oxx (yy > 0) now work together as well: The effect column offset is added to the sample cue.
- [New] <js> Two new commands, Finetune (+) and Finetune (Smooth) (*), which double as micro-tuning commands and absolute pitch wheel messages for plugins. They are centered around value 80h, and fractional precision can be extended using an additional # command on the next row. The micro-tuning depth corresponds to the pitch wheel depth of the instrument; 1 semitone is used in sample mode (http://forum.openmpt.org/index.php?topic=6379.0).

MPTM::Custom Tuning
- [New] <js> Added character '*' to drawable letters for built-in fonts.
- [Imp] <js> S2x (Set Finetune) now adjusts the finetune of the note by -8...+7 tuning steps.

IT
- [Imp] <js> Added read-only support for BeRoTracker commands 1 and 2 (equivalent to XM commands K and L, http://bugs.openmpt.org/view.php?id=1528).
- [Fix] <js> Internally, Impulse Tracker always calculates sample playback speed in Hertz instead of periods, even with Linear Slides disabled. Using periods instead can cause small yet audible discrepancies. OpenMPT now also supports frequency instead of periods for Amiga Slides. Fixes "Watching Her Smile" (http://bugs.openmpt.org/view.php?id=1344).
- [Fix] <js> Pitch/Pan Separation was affected by note-off commands, and wasn't reset by panning commands like in Impulse Tracker.

XM
- [Imp] <js> BeRoTracker saves smooth MIDI macros in a different way from OpenMPT. This command is now imported correctly (http://bugs.openmpt.org/view.php?id=1531).
- [Fix] <js> Emulate FT2 Tone Portamento quirk that inverts portamento direction after the target was reached (if target note was higher than previous note).

S3M
- [Imp] <js> S3M files saved with Impulse Tracker and latest Schism Tracker now also compute sample playback speed in Hertz.
- [Imp] <js> Depending on whether an S3M file was last saved in Scream Tracker with the Sound Blaster or Gravis Ultrasound drivers loaded, different compatibility flags are now applied. For files saved with the GUS, the sample volume factor is now also ignored (fixes volume levels in S3Ms made on the GUS, in particular if they use both samples and OPL instruments).
- [Imp] <js> Enforce the lower frequency bound (http://bugs.openmpt.org/view.php?id=961).

MOD
- [New] <js> OpenMPT only supported "TDZ4" to "TDZ9" magic bytes for TakeTracker modules, which should not even exist. Added support for 1 to 3 channel TakeTracker modules used "TDZ1" to "TDZ3" magic bytes.
- [Imp] <js> Allow EFx (Invert Loop) effect to work with 16-bit and stereo samples, which would later be converted to 8-bit mono samples anyway.
- [Fix] <js> Loosened VBlank timing heuristics so that the original copy of Guitar Slinger from Dizzy Tunes II plays correctly.

Other formats
- [New] <da & js> Can now read Symphonie (SymMOD) modules (http://bugs.openmpt.org/view.php?id=672).
- [New] <js> Can now read Digital Symphony (DSym) modules.
- [New] <js> Can now read MUS modules from Psycho Pinball and Micro Machines 2.
- [New] <js> Can now read FMT modules made with Davey W Taylor's FM Tracker.
- [New] <js> Can now read STX modules, a transitional format between STM and S3M (http://bugs.openmpt.org/view.php?id=1521).
- [New] <jh> Modules packed with various legacy compression formats (in particular many more XPK variants) can now be read. All formats supported by the ancient library (https://github.com/temisu/ancient) are supported.
- [Imp] <js> DMF / IMF: Improved accuracy of finetune commands.
- [Imp] <js> MDL: Implemented finetune command.
- [Imp] <js> OKT: Various accuracy improvements such as: Sharing volume between mixed channels, volume commands on mixed channels are permanent (not reset with new notes), mixed channels do not support default sample volume, 7-bit samples are actually supposed to be played as-is (not amplified to full 8-bit range), reject speed command parameters >= 20.
- [Mod] <js> Warn during saving of an imported file when any playback compatibility settings are enabled that are not supported by the current editing format. These settings are disabled automatically.
- [Reg] <jh> Modules compressed with MMCMP, PP20 or XPK can no longer be read from inside another archive.

Stream Export
- [New] <jh> Can now export AU files with µ-law and A-law encoding.
- [Mod] <jh> Default dither is now 1-bit dither with 1st order noise shaping instead of 0.5-bit dither. Although this adds a higher noise floor in the upper part of the spectrum than the old default, the harmonic distortion is reduced, and the signal-to-noise ratio in the lower part of the spectrum is improved. Especially with high samplerates (> 48kHz), this is a clear improvement over the old default, because the added noise floor will be mostly above the audible spectrum.

Audio I/O
- [Mod] <jh> Default dither is now 1-bit dither with 1st order noise shaping instead of 0.5-bit dither.
- [Reg] <jh> Support for DirectSound output was removed.

Misc
- [New] <jh & js> OpenMPT updates can now be downloaded and installed automatically. This is currently not supported on Wine (http://bugs.openmpt.org/view.php?id=1011).
- [New] <jh> OpenMPT is now also available for Windows on ARM.
- [New] <js> Can now export OPL register dump as VGZ/VGM/DRO files (http://bugs.openmpt.org/view.php?id=1488).
- [New] <js> Can now open SF2 soundfonts with compressed samples (commonly referred to as SF3, see https://github.com/FluidSynth/fluidsynth/wiki/SoundFont3Format).
- [New] <js> Added new hidden setting "Misc.UseSingleInstance" (default false) which allows to force OpenMPT to only ever open a single instance (http://bugs.openmpt.org/view.php?id=1429).
- [New] <js> Added a button to Mixer settings to easily revert ramping settings to defaults (tx eightbitbubsy).
- [New] <js> Added a new shortcut to quickly toggle between all lower and upper views (http://bugs.openmpt.org/view.php?id=1367).
- [Imp] <js> Saving samples / instruments and Stream Export now reports if there was a write failure, e.g. due to full disk (http://bugs.openmpt.org/view.php?id=1161).
- [Imp] <js> Keyboard shortcuts can now also be bound to MIDI notes in addition to MIDI CCs (http://bugs.openmpt.org/view.php?id=1396).
- [Imp] <js> Infinite pattern loops are now detected in song length calculation. This also improves seeking accuracy in modules with pattern loops (http://bugs.openmpt.org/view.php?id=1146).
- [Imp] <jh> Register OpenMPT with Restart Manager. This allows the installer to automatically close and restart OpenMPT.
- [Imp] <jh> OpenMPT now reports if loading a module fails due to being out of memory.
- [Mod] <jh> Hidden settings "VST Plugins.FullyUnloadPlugins" is now named "BrokenPluginsWorkarounds.VSTNeverUnloadAnyPlugin" and its meaning inverted. The old setting is migrated automatically.
- [Fix] <js> Fixed possible crash when playing notes via MIDI with lots of active NNA channels (http://bugs.openmpt.org/view.php?id=1514).
- [Reg] <jh> Remove hidden setting "Misc.ShowSettingsOnNewVersion".

Bundled plugins
- [Fix] <js> I3DL2Reverb: Fix possible output of NaN values with some extremely impractical sets of reverb parameters.

Third-Party Libraries
- [Imp] Update PortAudio (v19.7.0), r8brain (v5.3), SoundTouch (v2.3.1) and UnRAR (v6.1.2)

Installer/release package
- [New] <js> Added a new German keymap (Impulse Tracker / OpenMPT crossover) by melcom. Updated coda's key map.
- [New] <jh> OpenMPT is now also available for ARM and ARM64 architectures.


v1.29.15.00 (5 December 2021, revision 16116)
---------------------------------------------
Tree view
- [Fix] <js> Samples extracted from MTM files through the tree view were corrupted (http://bugs.openmpt.org/view.php?id=1522).
- [Fix] <js> Clicking on folders under soundfont items caused some instrument of that soundfont to be played since OpenMPT 1.29.14.00 (http://bugs.openmpt.org/view.php?id=1516).

Pattern tab
- [Mod] <js> Effect visualizer: Enable PC event mode if the only command in the whole selection is a PC event, even if it is not on the first row (http://forum.openmpt.org/index.php?topic=6738.0).

Sample tab
- [Fix] <js> Switching to an OPL instrument after a zoomed-in sample was shown and not scrolled entirely to the left didn't display the OPL editor correctly.
- [Fix] <js> Show correct dB values for OPL instruments in Default Volume and Global Volume tooltips.

Playback
- [Fix] <js> The logic when to turn off the resonant filter was broken in some edge cases since OpenMPT 1.29.02.00 (http://bugs.openmpt.org/view.php?id=1520).
- [Imp] <js> OPL: Improved channel allocation strategy when there are lots of faded-out notes.

XM
- [Imp] <js> Disable FT2 arpeggio quirks for XMs made with Skale Tracker (fixes KAPTENFL.XM).

S3M
- [Mod] <js> Ignore O00 commands in files created with Scream Tracker 3.00 and 3.01, as this command only gained effect memory in version 3.03.

MOD
- [Fix] <js> Digital Tracker MODs have four unknown bytes right after the magic bytes which seem to be ignored even by Digital Tracker itself. Just skip over them (tx AliceLR).

Other formats
- [Imp] <js> IMF: Implemented XE1-XE3 commands, which disable individual envelopes. Command Nxy (cutoff slide + resonance) is now also partially supported (only resonance for now).
- [Fix] <js> IMF: Filter envelopes were upside down.
- [Fix] <js> MT2: External samples with relative paths pointing to the parent directory (like some MadTracker 2 example songs) didn't load correctly.
- [Fix] <js> STM: Use S3M-like sample swap behaviour.

Module cleanup
- [Fix] <js> Removing unused samples may have removed samples only played by instrument-less notes (tx melcom).

Misc
- [Fix] <js> SF2: Fix stereo samples once again.
- [Fix] <jh> Wine Integration: Some files were missing.

Installer/release package
- [New] <js> All executables and libraries are now signed with a code signing certificate.
- [Fix] <js> Remove legacy key commands from some keymaps, as they showed a warning when loading the keymap (tx melcom).


v1.29.14.00 (14 November 2021, revision 15948)
----------------------------------------------
Tree view
- [Fix] <js> Soundfonts used in the MIDI library sometimes caused unexpected instruments to be loaded due to the ordering of instruments in the soundfont file (e.g. GeneralUser GS). Now OpenMPT always loads the instrument with the lowest bank number (http://forum.openmpt.org/index.php?topic=6727.0).
- [Fix] <js> Soundfont drum instruments with more than 128 regions didn't work correctly (http://forum.openmpt.org/index.php?topic=6727.0).

Pattern tab
- [New] <js> Parameter Editor: Add a new fill option to only change parameters next to notes.
- [Mod] <js> Parameter Editor: Remember last fill action when reopening the editor.

Sample tab
- [Imp] <js> Loading drum samples from soundfonts now translates them to be usable at middle-C rather than at their original mapped key.

Playback
- [Fix] <js> MIDI Macros: When mixing internal and external MIDI messages in the same macro and using a smooth MIDI macro command, the external macros were no longer interpolated correctly.

Other formats
- [Fix] <js> IMF: Change envelope interpretation to be more like in XM instead of IT (sustain point has no precedence over normal loop, and loops are shortened by one tick).
- [Fix] <js> MED: Some samples had a ping-pong loop when there should be no loop at all.
- [Fix] <js> MT2: Ignore incorrect drums chunk size in early MT2 files (fixes e.g. "A little Rock" by Csumi).
- [Fix] <js> MT2: Work around initial master volume of 0 used in some files that apply a fade-in a the song start using track automation that would stay silent forever otherwise (track automation is currently not supported).
- [Fix] <js> Gzip archives: Correctly decode files larger than 4 GB (although it's unlikely that there's anything in there that OpenMPT could read), and reduce memory consumption during decompression.

Misc
- [Fix] SF2: Fix various issues with complex soundfonts such as GeneralUser GS, e.g. missing support for key ranges in presets.

Third-Party Libraries
- [Imp] Update mpg123 (v1.29.2)


v1.29.13.00 (3 October 2021, revision 15754)
--------------------------------------------
Tree view
- [Imp] <js> When browsing song contents, Backspace now goes back to the folder containing the song when in the lower half of the tree view. There is now also a context menu option to close the song (http://bugs.openmpt.org/view.php?id=1498).
- [Fix] <js> Module files are now also shown as directories in lower half of tree view when "Show All Files" is checked.

Pattern tab
- [Imp] <js> Grey out plugin names in channel headers if plugins are disabled on this channel.
- [Imp] <js> Pressing the Application key on the order list now opens the context menu (http://bugs.openmpt.org/view.php?id=1501).
- [Imp] <js> Added shortcuts for opening the channel context menu and channel plugin context menu (http://bugs.openmpt.org/view.php?id=1501).
- [Fix] <js> Seeking with sample sync sometimes didn't compute the correct sample position with pingpong-looped samples.
- [Fix] <js> In the instrument and effect columns, commands assigned to special keys (Num / Caps / Scroll Lock) were executed twice, so e.g. using scroll lock to toggle song follow mode didn't work in these columns.

Sample tab
- [Fix] <js> Switching between samples using keyboard shortcuts now updates the last used sample to use in the pattern and instrument editor just like when using the spin buttons or manually entering a sample number.

Instrument tab
- [Imp] <js> Pressing the Application key on the sample map now opens the context menu (http://bugs.openmpt.org/view.php?id=1501).
- [Fix] <js> Possible crash when releasing a note key that translates to a note above B-9.

Comments tab
- [Imp] <js> Added shortcut to start renaming samples / instruments (default: Ctrl+Enter).
- [Fix] <js> Since OpenMPT 1.29.01.00, it was pretty much impossible to rename instruments due to auditioning (tx Gargaj).

IT
- [Fix] <js> Tremor: Command I11 erroneously behaved like I00 (use previous parameter), unless IT Old Effects were enabled.

Other formats
- [Fix] <js> PTM: Panning was translated wrong in some edge cases.
- [Fix] <js> IMF / PTM: Note Slide commands were sometimes slightly off.
- [Fix] <js> DBM: Echo enable effect parameter range checks were incorrect.
- [Fix] <js> Possible crash when loading malformed MDL files.

Misc
- [Imp] <js> SFZ: Added support for reading various other *_label opcodes. They are not used for import but if their value contains spaces, it should no longer confuse the parser.
- [Fix] <js> When switching between tabs using keyboard shortcuts, and when switching between samples in the sample editor using keyboard shortcuts, the currently chosen instrument / sample is now updated correctly between pattern / samples / instrument editors (http://forum.openmpt.org/index.php?topic=6675.0).
- [Fix] <js> SF2: Region panning was not calculated correctly.
- [Fix] <js> SF2: Stereo sample merging didn't work for many soundfonts because panning values were stored for each envelope (of which there was one per instrument) rather than for each region.
- [Fix] <js> DLS: The first region of every instrument was not imported in OpenMPT 1.29.12.00 (http://bugs.openmpt.org/view.php?id=1504).
- [Fix] <js> When enabling the Display.HighResUI option, some file selector dialogs could hang (presumably due to a Windows bug) when hovering the file type dropdown on a mixed-DPI monitor setup (http://bugs.openmpt.org/view.php?id=1490).
- [Fix] <js> Key Config Dialog: Avoid bogus "Invalid Slot" message box when receiving MIDI CCs while the "Find Hotkey" input field is focussed.

Third-Party Libraries
- [Imp] Update nlohmann json (v3.10.2), mpg123 (v1.29.0)


v1.29.12.00 (22 August 2021, revision 15545)
--------------------------------------------
Tree view
- [Fix] <js> Drum key names were not displayed for SF2 soundfonts.

Pattern tab
- [Fix] <js> Find & Replace: Fixed various issues with replacing extended commands Sxy / Exy (http://bugs.openmpt.org/view.php?id=1486).

Playback
- [Fix] <js> Possible crash with malformed modules containing an invalid plugin chain or instruments pointing to invalid plugins.
- [Fix] <js> Possible crash after swapping to a sample with loop points set but not loop enabled.

MPTM
- [Fix] <js> Fixed excessive memory usage with files claiming to have an extremely high rows per beat count while also using tempo swing. Maximum rows per beat are now limited to 65536.

Other formats
- [Imp] <js> MIDI Import: Support loopEnd marker and EMIDI loop start / end CCs.
- [Fix] <js> STP: Avoid creating thousands of patterns when loading malformed files even though no more pattern data can be read.
- [Fix] <js> MMCMP: Fixed various possible crashes with malformed files.

Misc
- [Mod] <js> Song Properties: Reject 0 rows per beat in modern tempo mode.
- [Imp] <js> MIDI Export: Write loopStart and loopEnd cue markers (http://forum.openmpt.org/index.php?topic=6660.0).
- [Imp] <js> DLS / SF2: Support more than 128 regions per instrument (some complex drum programs can exceed the previous limit).
- [Fix] <js> SF2: Extracting drums from drum instruments with a global region didn't work since OpenMPT 1.29.01.00 (http://bugs.openmpt.org/view.php?id=1457).
- [Fix] <js> Avoid crash when attempting to open the Tempo Swing Settings dialog with rows per beat being set to 0.

Third-Party Libraries
- [Imp] Update mpg123 (v1.28.2), UnRAR (v6.0.7)


v1.29.11.00 (4 July 2021, revision 15407)
-----------------------------------------
General tab
- [Imp] <js> When replacing a plugin, keep the plugin chain intact by not clearing its output plugin.

Pattern tab
- [Fix] <js> In OpenMPT 1.29.10.00, it was no longer possible to resume samples on muted channels when seeking with sample sync enabled.
- [Fix] <js> Possible crash when trying to reset a playing channel.
- [Fix] <js> Resetting a channel could mark the module as modified.
- [Fix] <js> Previewing notes could cause clicks if the NNA was set to Note Cut.

Sample tab
- [Imp] <js> For OPL instruments, the actual middle-C note frequency is now shown in a tooltip when hovering the sample rate field.
- [Imp] <js> AIFF: Support reading another variant of 64-bit floating-point and 8-bit unsigned PCM compression types.
- [Mod] <js> AIFF: Ignore invalid sample offset instead of completely rejecting the file. Makes some old (technically malformed) AIFF files load that were previously rejected.
- [Fix] <js> Avoid Windows notification sounds when holding note keys when a widget is focussed in the OPL editor.

Instrument tab
- [Imp] <js> Add more mnemonic shortcuts for various widgets.
- [Fix] <js> Previewing notes could cause clicks if the NNA was set to Note Cut.

S3M
- [Imp] <js> Honor the Stereo flag not being set. This improves the sound of some tunes like Turbulence by Purple Motion.
- [Imp] <js> Detect MPT 1.0 alpha versions which didn't set the Stereo flag. In this case, the unset Stereo flag is also ignored because MPT 1.0 alpha used the default S3M channel panning anyway.
- [Fix] <js> Only for OPL instruments the high sample rate bits should be ignored; for PCM instruments they are clamped to 65535 Hz.

MOD
- [Fix] <js> Do not apply ProTracker loop length quirk to MODs that could have been made with Scream Tracker (fixes Soul-O-Matic by Purple Motion, http://bugs.openmpt.org/view.php?id=1472).

Other formats
- [Imp] <js> AMF (DSMI): Format revisions 1 and 9, as well as early (technically malformed) revision 10 files, are now supported. Surround panning commands and instrument number without note are now converted correctly.
- [Fix] <js> AMF (DSMI): Patterns and samples were not read correctly in some files (e.g. AVOID.AMF).
- [Fix] <js> GDM: Correctly import extra-fine portamentos (http://bugs.openmpt.org/view.php?id=1469).

Misc
- [Imp] <jh> Added shim to support RtAudio v5.0.0 in addition to v5.1.0. This re-adds support for current Ubuntu LTS and Debian systems with Wine Integration.
- [Fix] <js> SF2: Only merge mono layers if they have opposite panning. Previously, e.g. two left-panned layers would have also been merged.

Third-Party Libraries
- [Imp] Update mpg123 (v1.28.0), ogg (v1.3.5), r8brain (v5.2)


v1.29.10.00 (16 May 2021, revision 15016)
-----------------------------------------
General tab
- [Fix] <js> The tempo slider handle was shown in the wrong position for tempos close to 1000 BPM.

Pattern tab
- [Imp] <js> Interpolating the volume column between a cell with a Set Volume command and a cell with no volume command but a note and instrument is now possible (it uses the default volume of that sample for interpolation).
- [Fix] <js> Duplicating / adding / removing a channel, undoing and then redoing it caused the contents of the last channel to be lost (http://bugs.openmpt.org/view.php?id=1442).
- [Fix] <js> "Maintain sample sync on mute" was only enforced after manually muting a channel, and e.g. by restarting playback broke it again (http://bugs.openmpt.org/view.php?id=1125).

Sample tab
- [Imp] <js> Can now resample all samples at once by holding shift when pressing the resample button (http://bugs.openmpt.org/view.php?id=1368).

Instrument tab
- [Fix] <js> Saving an XI instrument from an IT or MPTM module could cause wrong transposition for samples with a middle-C frequency below 8363 Hz (http://bugs.openmpt.org/view.php?id=1449).
- [Fix] <js> Saving an ITI instrument from an XM module converted auto-vibrato sweep incorrectly.

Playback
- [Fix] <jh> In quad surround mode, Bass Expansion incorrectly applied DC removal to the front channels twice instead of applying it once to front and back channels.

MPTM
- [Fix] <js> The "Do not reset OPL channel status at end of envelopes" compatibility flag was effectively force-enabled for all modules made with OpenMPT 1.29, while it should have been disabled.
- [Fix] <js> Files with OPL instruments were sometimes written in a way so that older OpenMPT and libopenmpt versions without OPL support could no longer read certain song properties and warn that the file was created with a more recent version of OpenMPT.
- [Fix] <js> The old OpenMPT 1.28 retrigger behaviour for OPL instruments differed depending on the chosen output sample rate. Retrigger now always retriggers notes as expected, which was already the case when the mix rate was chosen to be 48000 Hz. The corresponding compatibility setting was removed, as it is no longer required.

IT
- [Imp] <js> Full OpenMPT version information (e.g. 1.29.10.00 instead of 1.29) is now written to IT files also when using compatibility export.

S3M
- [Imp] <js> Emulate IT short sample retrigger quirk in S3M files saved with Impulse Tracker and Schism Tracker.
- [Imp] <js> Full OpenMPT version information (e.g. 1.29.10.00 instead of 1.29) is now written to S3M files.

MOD
- [Fix] <js> Fixed possible crash when sample-swapping to a previously-deleted sample (tx bryc).
- [Fix] <js> ProTracker 3.6 doesn't support sample swapping. It is now disabled when loading a ProTracker 3.6 IFF module.
- [Fix] <js> Some files with "hidden" garbage patterns (e.g. altoflyt.mod) were not played correctly since OpenMPT 1.29.05.00 (http://bugs.openmpt.org/view.php?id=1458).
- [Fix] <js> E9x retrigger now works the same way as in ProTracker 2.

Other formats
- [Mod] <js> 669: Reject files that contain any pattern tempo higher than 15.
- [Fix] <js> MDL: Improve auto-vibrato accuracy.
- [Fix] <js> In OpenMPT 1.29.09.00, the "Save As" dialog now may have shown up every time after opening a file in an import-only format. Some actions like running the Automatic Sample Trimmer may have also prevented the dialog from showing up.
- [Fix] <js> Reduce memory consumption of malformed XPK-compressed files.

Stream Export
- [Fix] <jh> Exported 8-bit FLAC output was distorted since OpenMPT 1.29.01.00.
- [Fix] <jh> Do not offer dithering for 64-bit floating-point export.

Audio I/O
- [Mod] <jh> MME / Wave Out output devices are no longer marked as deprecated for now.

Misc
- [New] <js> Added keyboard shortcuts for increasing and decreasing tempo and ticks per row of currently playing module (tx jseb).
- [Fix] <js> Launching OpenMPT could take longer than it should depending on the current working directory, e.g. when opening modules from the task bar's jump list (http://bugs.openmpt.org/view.php?id=1444).
- [Fix] <js> Opening the help didn't open the correct page if the upper half of the view was focussed.
- [Fix] <js> Stop all playing samples when toggling "Compute note frequency in Hertz" compatibility setting.

Third-Party Libraries
- [Imp] Update mpg123 (v1.27.2)


v1.29.09.00 (11 April 2021, revision 14577)
-------------------------------------------
Tree view
- [Fix] <js> Holding a key to preview a sample or instrument in module now works as expected (no more cycling through items / playing "Ding" sound).

Pattern tab
- [New] <js> Added a new keyboard shortcut "Insert Separator" (Ctrl + Insert by default) to the order list which does the same thing as the identically-named context menu entry (http://bugs.openmpt.org/view.php?id=1437).
- [Imp] <js> Support instrument control S7x command when seeking with sample sync.
- [Fix] <js> Possible crash when resuming playback with "Play song from pattern start" combined with "Maintain sample sync on seek" (tx melcom).
- [Fix] <js> Pasting into a non-existent pattern (which would create a new pattern) didn't update the list of existing patterns in the tree view.
- [Fix] <js> Plugin names in instrument list are now updated immediately when renaming a plugin.
- [Fix] <js> Some characters were surrounded by colored frames when using proportional fonts.
- [Fix] <js> Avoid status bar updates (pattern selection size) from playing song while another song is being edited.

Instrument tab
- [Imp] <js> SFZ: Support loopcrossfade as an alias for loop_crossfade.
- [Fix] <js> SFZ: label_keyN values with spaces no longer break the parsing of following opcodes on the same line.
- [Fix] <js> SFZ export: Avoid creating folder names with trailing spaces and dots, as they are difficult to delete or move on Windows.

IT
- [Fix] <js> Instrument / sample panning was reset on note-off / fade commands (http://bugs.openmpt.org/view.php?id=1432).

Other formats
- [Fix] <js> With some imported formats, the "Save As" dialog didn't show up when trying to save them, overwriting the original file instead.
- [Fix] <js> Possible crash when loading some malformed files.
- [Fix] <js> Fix excessive memory consumption with malformed files in various formats.

Misc
- [Mod] <js> Welcome Dialog: The initial key map suggestion is now used even when not clicking the OK button.
- [Fix] <js> Modifier key state (Ctrl, Alt, Shift, Win) could sometimes get stuck when switching to another application.

Bundled plugins
- [Fix] <js> LFO Plugin: Frequency was not immediately reset when restoring parameters from saved file (http://bugs.openmpt.org/view.php?id=1440).

Third-Party Libraries
- [Imp] Update mpg123 (v1.26.5)


v1.29.08.00 (14 March 2021, revision 14303)
-------------------------------------------
General tab
- [Fix] <js> "Output To" plugin list could contain garbage when a plugin name was edited in another view of the same module.

Pattern tab
- [New] <js> Added keyboard shortcuts for adding and removing channels (http://bugs.openmpt.org/view.php?id=1427).
- [Mod] <js> If the order list is already longer than the format-supported maximum (e.g. because of import from another format), don't shrink the order list anymore when trying to duplicate a pattern.

Sample tab
- [Imp] <js> Splitting a stereo sample into two mono samples wastes less memory.
- [Fix] <js> On some systems, the OPL patch editor caused keyboard shortcuts to stop working (http://bugs.openmpt.org/view.php?id=1382).

Comments tab
- [Fix] <js> When activating the tab, the keyboard focus is set to the text editor (http://bugs.openmpt.org/view.php?id=1365).

S3M
- [Fix] <js> Some samples or OPL patches were imported with a too high sample rate if module was saved with Scream Tracker 3 (http://bugs.openmpt.org/view.php?id=1412).

Other formats
- [Imp] <js> Support loading 64-bit PCM and floating-point WAV files as a module.
- [Fix] <js> Possible crash when loading floating-point WAV file that claimed to have a bit depth of 8 bits or lower as a module.
- [Fix] <js> AMS: Avoid allocating excessive amount of memory for compressed song message in malformed files.

Misc
- [Mod] <js> Only force to rescan MIDI devices after receiving a device change notification from the system. Might fix a crash with buggy MIDI drivers.
- [Fix] <js> Properly resize text labels on main toolbar according to actual font size used (http://forum.openmpt.org/index.php?topic=6569.0).
- [Fix] <js> Some keys were missing when resetting the default keymap (tx isdera).

Third-Party Libraries
- [Imp] Update libvorbis (v1.3.7), UnRAR (v6.0.4)


v1.29.07.00 (31 January 2021, revision 14108)
---------------------------------------------
General tab
- [Imp] <js> Using the spinner, tempo is now incremented and decremented in steps of 1 BPM in all formats. The old behaviour for MPTM - using a 0.1 BPM step size - is now applied when holding Shift (similar to 0.01 BPM steps when holding Ctrl).
- [Mod] <js> "Output To" plugin list now shows user-chosen name first, then library name.
- [Mod] <js> "Output To" plugin list was not updated when a plugin was renamed.
- [Fix] <js> Renaming a plugin could become really slow the more plugins were loaded.

Pattern tab
- [Imp] <js> Update OPL channel state (in particular currently used instrument) when seeking.
- [Fix] <js> Rare crash when trying to interpolate a column without a selection (tx coda).
- [Fix] <js> Selecting a whole row by clicking on its row number didn't copy any channels left of the current scroll position.
- [Fix] <js> MIDI recording erroneously allowed writing smooth MIDI commands with formats that don't support this command.
- [Fix] <js> The Pattern Goto Dialog was not initialized correctly, not using the current pattern and order list location as intended.

Sample tab
- [Imp] <js> Pitch Shift can now also be applied to sample selections.
- [Imp] <js> Autotune no longer marks the module as modified if the frequency didn't change.
- [Imp] <da> Stereo 8SVX files are now supported.
- [Fix] <js> Converting a stereo sample to mono by only taking the right channel caused the first sample from the left channel to remain in the sample, and thus offseting the whole sample by one.
- [Fix] <js> There was a memory leak when aborting a Pitch Shift operation.

VST / DMO Plugins
- [Mod] <js> Removing a plugin from a module now removes all output routings to that plugin slot. Previously, loading a new plugin into the same slot caused other plugins to (unexpectedly) route their output to it.
- [Fix] <js> Dropping a VST plugin file on the OpenMPT window didn't apply plugin bridge default settings like when adding it through the Plugin Manager dialog.

MPTM::Custom Tuning
- [Fix] <jh> Allow editing note name also if a note outside the primary group is selected (http://forum.openmpt.org/index.php?topic=6531.0).

MOD
- [Fix] MOD: The FT2 tremolo quirk is now also applied to MOD files. FT2 just copied the quirky code from ProTracker!

Other formats
- [Imp] <js> DMF: Preserve effects better in some situations where there is more than one effect in a pattern cell.
- [Imp] <js> DMF: Improve import of finetune effect with parameters larger than +/-15.

Misc
- [Imp] <js> Always support inputting '-' as negative sign in numeric input fields, even if the system locale would use a different character.
- [Mod] <js> "Find MPT Hacks" no longer warns about artist name being set in MOD / S3M files, as it cannot be stored in those file types anyway.
- [Fix] <js> A memory leak was possible in some situations when loading a module failed due to insufficient memory being available.
- [Fix] <js> MIDI Export: Possible crash after importing an SF2 instrument (http://bugs.openmpt.org/view.php?id=1399).

Third-Party Libraries
- [Imp] Update mpg123 (v1.26.4), UnRAR (v6.0.3)


v1.29.06.00 (29 November 2020, revision 13926)
----------------------------------------------
General tab
- [Imp] <js> When entering a restart position that points to a non-playable order item, immediately show the corrected value when the input field loses focus.

Other formats
- [Imp] <js> DMF: Support early format beta versions (in particular versions 1-4).
- [Imp] <js> MED: Support MIDI program change and custom MIDI commands.
- [Fix] <js> MED: Also use octave wrapping in 8-channel mode for MMD0/MMD1 modules (http://bugs.openmpt.org/view.php?id=1386).
- [Fix] <js> MED: If 8-channel mode is activated, ignore BPM mode (http://bugs.openmpt.org/view.php?id=1384).
- [Fix] <js> MED: Emulate tempo commands F01 and F02 quirk (http://bugs.openmpt.org/view.php?id=1384).
- [Fix] <js> MED: Tempo commands below 32 BPM were interpreted as tempo slides (http://bugs.openmpt.org/view.php?id=1384).
- [Fix] <js> MED: Do not reject files with no instruments.
- [Fix] <js> MID: Relative RPN changes (in particular coarse tune) were not implemented correctly.
- [Fix] <js> IMF: Instrument sample mapping was off by one octave, notable in the guitar part of Astaris by Karsten Koch.

Misc
- [Imp] <js> When inverting icons in high contrast / dark themes, only invert their brightness but keep the hue.
- [Fix] <js> Since OpenMPT 1.29.01.00, Note Off / Cut / Fade shortcuts were missing in new installations, when resetting keys to defaults or when importing very old OpenMPT keyboard configurations (http://bugs.openmpt.org/view.php?id=1385).
- [Fix] <js> Keyboard Settings: Fixed possible crash in the keyboard setup when resetting a key mapping while a separator item was focussed.
- [Fix] <js> MIDI Export: In "Melodic (any)" mode, exported MIDI channels were inconsistent between notes / tracker events and Zxx macros past channel 10 (http://forum.openmpt.org/index.php?topic=6504.0).

Third-Party Libraries
- [Imp] Update UnRAR (v6.0.2)


v1.29.05.00 (25 October 2020, revision 13771)
---------------------------------------------
Pattern tab
- [New] <js> Added new shortcuts for moving channels (current selection if there is one, edit cursor otherwise, http://forum.openmpt.org/index.php?topic=6480.0).
- [Fix] <js> Disabling song looping didn't really work for anything but the first sub song in a seqeuence. Some related issues when song looping is disabled have also been fixed.
- [Fix] <js> Fixed highlighting of the currently selected pattern in the order list past the maximum supported length of the current format (e.g. when importing from some format that supports more than 128 orders into the MOD format).

Pattern tab::Find/Replace
- [Mod] <js> If a match is found in a pattern that is not part of the current sequence, the active sequence is automatically changed.

Sample tab
- [Fix] <js> More logical cue point moving when removing sample ranges.

Instrument tab
- [Imp] <js> Respect instrument NNA settings when playing notes via MIDI (http://bugs.openmpt.org/view.php?id=1371).

MOD
- [Mod] <js> Increased threshold for considering 8xx as panning commands from 820 to 830.

Other formats
- [Imp] <js> WOW: Fix loading of several files and harden WOW detection (http://bugs.openmpt.org/view.php?id=1380).
- [Fix] <js> STM: Changed tempo computation to behave like Scream Tracker 2.3 instead of Scream Tracker 2.2, as the playback frequencies we use for sample playback are closer to those of Scream Tracker 2.3.
- [Fix] <js> MED: Fix possible hang during load if a MED file claims to contain 256 songs.

Stream Export
- [Fix] <js> Avoid desynchronization between channels when doing per-channel export for S3M files (http://bugs.openmpt.org/view.php?id=1331).

Module cleanup
- [Fix] <js> Allow multiple sequences to be merged even if current song format is not MPTM.

Misc
- [Imp] <js> Improve some icons' visibility in high contrast / dark themes.


v1.29.04.00 (4 October 2020, revision 13649)
--------------------------------------------
Tree view
- [Imp] <js> Use natural sorting for filenames (http://bugs.openmpt.org/view.php?id=1359).

Pattern tab
- [Imp] <js> Added possibility to use %channel_name% in accessibility description format, which contains the channel name in addition to its index (http://forum.openmpt.org/index.php?topic=6480.0).

Sample tab
- [Imp] <js> The start and end point of an existing selection can now be modified by dragging them with the mouse.
- [Mod] <js> WAV / FLAC: When importing cue points and there are less than 9 cue points, remove the default cue points from the sample. On export, cue points past the sample end are no longer written.
- [Fix] <js> Playback position indication did not work when using a pattern-specific playback function (e.g. "play from current pattern") and the module was not playing before that.
- [Fix] <js> Ensure that adjusting sample frequency with the fine spinner always adds or subtracts at least one Hz.
- [Fix] <js> Slicing at cue points lost the first part of the sample if some cue point was 0.
- [Fix] <js> Trimming and resampling didn't adjust cue points accordingly.

Instrument tab
- [Fix] <js> Playback position indication did not work when using a pattern-specific playback function (e.g. "play from current pattern") and the module was not playing before that.

Mod Conversion
- [Fix] <js> Sample frequency to transpose + finetune conversion was wrong if the resulting transpose value was negative.

XM
- [Imp] <js> Support loading and saving (but not editing for now, apart from using the clipboard) command W, which is used e.g. by BASS for syncing purposes.

Other formats
- [Fix] <js> MO3: Avoid certain ModPlug hacks from being fixed up twice, which could lead to e.g. very narrow pan swing range for old OpenMPT IT files saved with a recent MO3 encoder version.
- [Fix] <js> PLM: Percentage offset (Mxx) was slightly off.

Misc
- [Fix] <js> Channel Manager is no longer redrawn on almost every unrelated UI update.


v1.29.03.00 (30 August 2020, revision 13550)
--------------------------------------------
Tree view
- [Imp] <js> Show hidden files if Windows Explorer is configured to do so. System files are now shown unless they are also hidden, as this is closer to Explorer's behaviour.
- [Fix] <js> Undoing the deletion of a pattern did not update the pattern list correctly (http://bugs.openmpt.org/view.php?id=1357).

Pattern tab
- [Fix] <js> Choosing Pattern Properties from the order list context menu always showed the properties of the currently edited pattern (http://bugs.openmpt.org/view.php?id=1356).
- [Fix] <js> It was not possible to redo the deletion of a pattern (http://bugs.openmpt.org/view.php?id=1357).
- [Fix] <js> Deleting a pattern (or undoing the deletion) did not update the color of that pattern in the order list correctly (http://bugs.openmpt.org/view.php?id=1357).

Sample tab
- [New] <js> Add support for BRR (SNES Bit Rate Reduction) sample format import.

Other formats
- [Imp] <js> MID: Support files with initial negative delta time. This is not valid according to the standard, but such files exist in the wild.
- [Fix] <js> PP20: The first few bytes of some files were not decompressed properly, making some files unplayable (depending on the original format).

Misc
- [Imp] <js> In file dialogs that can open multiple files, it is now possible to open files from different locations (e.g. through search results).
- [Imp] <js> Channel Manager: Middle-clicking a channel now shows the quick channel settings rather than just a dialog to rename.
- [Imp] <js> Channel Manager: Drag & drop now behave more naturally.
- [Fix] <js> Channel Manager: If channels were rearranged but not applied yet, middle-clicking a channel might have renamed the wrong channel.
- [Fix] <js> Some soundfont instruments with many key zones and instrument layers were no longer imported correctly since OpenMPT 1.29.01.00 (http://forum.openmpt.org/index.php?topic=6462.0).

Third-Party Libraries
- [Imp] Update nlohmann json (v3.9.1)


v1.29.02.00 (26 July 2020, revision 13346)
------------------------------------------
Tree view
- [Imp] <js> Hide empty removable drives.
- [Fix] <js> Offline / slow network shares could slow down filling of the drive list, which could also dramatically affect OpenMPT startup time (tx qsrmvt).

General tab
- [Fix] <js> Tempo tap usually broke and wrapped around to 32 BPM after several taps.

Pattern tab
- [Fix] <js> Fix wrong VU meter color at end of AdLib notes.

MPTM
- [Imp] <js> Qxy now retriggers OPL notes if new compatibility flag is set.
- [Fix] <js> Bring back old OPL note end-of-envelope behaviour for files made with OpenMPT 1.28 (http://bugs.openmpt.org/view.php?id=1344).

IT
  [Fix] <js> Global volume slides with both nibbles set preferred the "slide up" nibble over the "slide down" nibble in old OpenMPT versions, unlike other slides. Such old files are now imported correctly again.

IT::Compatible Playback Mode
- [Fix] <js> Fixed an edge case where, if the filter hit full cutoff / no resonance on the first tick of a row where a new delayed note would be triggered, the filter would be disabled even though it should stay active. Fixes trace.it by maddie.

XM
- [Fix] <js> OXM: Some sample loops were not imported correctly (http://bugs.openmpt.org/view.php?id=1329).
- [Fix] <js> Out-of-range arpeggio clamping behaviour broke in OpenMPT 1.23.05.00. The arpeggios in Binary World by Dakota now play correctly again.

S3M
- [Imp] <js> Support old-style sample pre-amp value in very early S3M files.
- [Fix] <js> Only force-enable fast slides for files saved with Scream Tracker 3.00. Previously, any S3M file made with a Scream Tracker version older than 3.20 enabled them.
- [Fix] <js> Only apply volume and middle-C speed on instrument change if the new sample slot has sample data.

MOD
- [Fix] <js> Fix an infinite loop in GamerMan by MrGamer by playing non-ProTracker MODs more like FT2 would (http://bugs.openmpt.org/view.php?id=1337).

Other formats
- [Imp] <js> STK: Improve tracker detection heuristics to never assume SoundTracker 2.0 if there is a huge number of Dxx commands, as that is a definite hint that they should be treated as volume slides. Fixes Monty On The Run by Master Blaster.
- [Imp] <js> MO3: Support OPL patches in MO3 files created from MPTM and S3M.
- [Imp] <js> DBM: If a global pattern command would be lost because both effect commands in a cell would have to go into the regular effect column (e.g. a speed and a tempo command), the lost command is now attempted to be written into a different cell on the same row. Fixes "Party-Question V" by grogon (http://bugs.openmpt.org/view.php?id=1346).
- [Imp] <js> STM: Try to import ST2 tempo more correctly.

Audio I/O
- [Fix] <jh> Work-around a Windows 10 2004 bug which causes an empty device name to be shown for the Wave Mapper device. Also provide a more useful name in other situations where the name is missing.
- [Imp] <jh> If opening the sound device failed, the name of the device is now shown.
- [Mod] <jh> On new installations, deprecated sound device types are no longer shown.

Misc
- [Imp] <js> OpenMPT now warns if saving a tuning, plugin preset or envelope failed (e.g. because of insufficient storage space, http://bugs.openmpt.org/view.php?id=1161).
- [Fix] <js> OpenMPT could crash when flushing file contents to disk failed (e.g. because disk was full).
- [Fix] <js> DLS: Tuning of drum programs was broken in OpenMPT 1.29.01.00.
- [Fix] <js> SF2: Support negative attenuation in instrument definitions. Region attenuation now adds up to instrument attenuation instead of overriding it (http://bugs.openmpt.org/view.php?id=1336).

Third-Party Libraries
- [Imp] Update nlohmann json (v3.8.0), mpg123 (v1.26.3), opusfile (v0.12) and UnRAR (v5.9.4)

Installer/release package
- [Fix] <jh> Run post-install applications as original user. Otherwise OpenMPT will create its configuration files with elevated privileges on first start.


v1.29.01.00 (24 May 2020, revision 12900)
-----------------------------------------
Tree view
- [New] <js> Can now rearrange sequences through drag & drop.
- [New] <js> Shortcut (.lnk) files to modules, samples and directories are now resolved.
- [New] <js> Allow Forward / Backward mouse buttons to be used for folder navigation in Instrument Library.
- [New] <js> Changing the instrument library directory / module can now also be achieved by editing the library header item (slow double-click).
- [Imp] <js> Can now also import samples and instrument from modules in sample browser using Ctrl + (Shift +) Enter.
- [Imp] <js> Added rename context menu entry in addition to slow double-click.
- [Imp] <js> Duplicating / inserting sequences inserts them next to the selected item. Duplicating a sequence now keeps its original name and adds "(Copy)" to it.
- [Imp] <js> Double-clicking an empty sequence now makes it the current sequence.
- [Fix] <js> Opening a module with external samples in the sample browser broke sample previewing / import for all following modules (http://bugs.openmpt.org/view.php?id=1318).

General tab
- [Imp] <js> Improved tempo tap button accuracy by using least squares algorithm rather than a simple average. The tempo is now also rounded rather than truncated for formats that do not support fractional tempos.

Pattern tab
- [New] <jb & js> Can now merge a selection of patterns into a single pattern from the order list context menu (http://bugs.openmpt.org/view.php?id=238).
- [New] <jb & js> Can now split a pattern into two patterns from the pattern editor context menu (http://bugs.openmpt.org/view.php?id=238).
- [New] <js> Row insertion and deletion can now also be done globally, affecting all patterns up to the next stop (---) pattern (http://bugs.openmpt.org/view.php?id=639).
- [New] <js> ProTracker- / FastTracker-like shortcuts for cutting, copying and pasting entire channels and patterns to separate clipboards (http://bugs.openmpt.org/view.php?id=424).
- [New] <js> New shortcut "Lose Selection".
- [New] <js> New shortcuts to cycle between sequences.
- [New] <js> Can now split sub songs into multiple sequences from the sequence context menu.
- [New] <js> Tooltips are shown for pattern properties, channel headers and plugin names (http://bugs.openmpt.org/view.php?id=1138).
- [Imp] <js> Moving patterns in the order list now behaves more logically (moving them to the right inserts them to the right of the dragged-on item). To make this change obvious, the insertion point is now displayed with a bold line. The old behaviour can be restored by toggling the hidden setting "Pattern Editor.OrderListOldDropBehaviour" (http://bugs.openmpt.org/view.php?id=1252).
- [Imp] <js> Previous / Next Order shortcuts now ignore skip patterns (+++).
- [Imp] <js> A group of channels can now be assigned to a record group at once by drag-selecting their channel headers (http://bugs.openmpt.org/view.php?id=1314).
- [Imp] <js> Channel aftertouch is now recorded to all active note channels.
- [Imp] <js> Duplicating / inserting sequences inserts them next to the current sequence. Duplicating a sequence now keeps its original name and adds "(Copy)" to it.
- [Imp] <js> Improve live parameter recording performance from non-bridged plugins (http://bugs.openmpt.org/view.php?id=1312).
- [Imp] <js> Order list separator / line color didn't work well if the window background color was dark.
- [Imp] <js> Improved screen reader read-out of order list (http://forum.openmpt.org/index.php?topic=6297.0).
- [Imp] <js> Pattern navigation and data entry now instantly trigger screen reader updates, unless a module is currently playing (http://forum.openmpt.org/index.php?topic=6297.0).
- [Fix] <js> Seeking with sample sync did not follow instruments with custom tuning (http://bugs.openmpt.org/view.php?id=1239).

Pattern tab::Chord Editor
- [Imp] <js> Clicking a key on the keyboard no longer automatically replaces the last note of the chord, new notes are only added to the chord if there is room for more notes. Instead, existing notes can now be dragged around.
- [Imp] <js> Can now specify notes up to two octaves below the base note (http://bugs.openmpt.org/view.php?id=1248).
- [Imp] <js> The dialog can now be resized, and hitting the X button no longer saves the modified chords.

Sample tab
- [New] <js> Support little-endian AU / SND files.
- [Imp] <js> Time Stretch can now be applied to sample selections.
- [Imp] <js> Instantly apply result of auto-tuning to playing channels.
- [Imp] <js> Allow resampling ratios greater than 1:512 or 512:1 again with r8brain.
- [Imp] <js> Cross-fading can now also be applied if no loop has been set but a selection has been made. The selection is then automatically set to be the sample loop.
- [Imp] <js> Improve precision of displayed auto-vibrato rate in tooltip.
- [Imp] <js> Speed up initial tab rendering.
- [Fix] <js> Adlib instrument are now always forced to be saved in S3I format, even when WAV or FLAC is selected.
- [Fix] <js> Fix accuracy and consistency of sample grid selection and grid markers with very long samples.
- [Fix] <js> Increased some OPL editor label sizes so that they work better on Wine.

Instrument tab
- [Imp] <js> Added screen reader support to note map (http://forum.openmpt.org/index.php?topic=6297.0).
- [Imp] <js> Envelope navigation and modification now instantly trigger screen reader updates, unless a module is currently playing (http://forum.openmpt.org/index.php?topic=6297.0).
- [Imp] <js> SFZ: Instrument envelopes imported / exported with SFZv2 flexible EGs (http://bugs.openmpt.org/view.php?id=1295).
- [Imp] <js> SFZ: Support for #include, macro redefinition, multiline comments, filter envelope import, synthesized samples, amplitude opcode, fractional finetune values and various other small improvements in both import and export.
- [Imp] <js> SFZ: Change filename of modified samples (loop cross-fade, offset and phase inversion) so that the original files are not modified forever.
- [Fix] <js> SFZ: Exported sample loop length was off by one.
- [Fix] <js> SFZ: Possible hang when importing malformed #define statement.

Comments tab
- [New] <js> Can now audition samples and instruments using regular note entry keys.
- [New] <js> Added shortcuts to switch between sample and instrument lists (Default: Tab) and edit selected item (Enter) (http://forum.openmpt.org/index.php?topic=6274.0).
- [New] <js> Can now copy sample and instrument names (context menu).

VST / DMO Plugins
- [Imp] <js> Resize plugin window appropriately if switching between presets results in a change of the menu bar height.
- [Mod] <js> There are some hybrid VST 2 / 3 plugins using the .vst3 file extension. It is now possible to drag & drop them on OpenMPT and add them through the Plugin Manager. Folder scan does not pick them up for now, as it might result in too many annoying warnings.
- [Mod] <js> A warning is shown when the likely cause for a plugin loading failure is a shortage of Fiber Local Storage indices.
- [Fix] <js> To circumvent a bug in some plugins made with SynthEdit 1.4 versions before February 2020, there is now a hidden setting "VST Plugins.FullyUnloadPlugins" that can be toggled to avoid fully unloading plugins when closing them (http://bugs.openmpt.org/view.php?id=1266). Alternatively, the plugins can also be bridged instead to avoid the crash.

VST::Plugin Bridge
- [Imp] <js> Speed up retrieval of parameter values when saving.
- [Fix] <js> The stability of bridged plugins has been greatly improved. Most, if not all plugins that did not work previously should run just fine now.

Playback
- [New] <js> In addition to A500 filter settings, the Amiga resampler can now also use A1200 filter settings and unfiltered output (http://bugs.openmpt.org/view.php?id=1276).
- [New] <jh> Added Bit Crush DSP to reduce the bit depth of the final output, e.g. to emulate old hardware or trackers.
- [Imp] <js> Allow NNA / DNA note-off / note fade to affect OPL notes the same way they affect samples.
- [Mod] <js> Improved OPL channel allocation when more than 18 notes are active, so that channels that have completely faded out are prioritized over channels that have already been released but have not faded out yet.
- [Fix] <js> Previewing an OPL instrument could cause the first pattern channel to no longer be played back correctly (http://bugs.openmpt.org/view.php?id=1323).
- [Fix] <js> Fix some inaccuracies in OPL emulator (original fixes by JP Cimalando).
- [Fix] <js> OPL channels were not affected by "Reset channels on loop" setting.
- [Fix] <js> End-of-sample pop reduction of surround channels was applied to front channels instead, causing a pop on the front channels instead of removing it on the back channels.

MPTM
- [Imp] <js> Raise tempo limit from 512 to 1000 BPM.
- [Imp] <js> When closing a file, a proper dialog is shown for handling modified / missing external samples (http://bugs.openmpt.org/view.php?id=1302).
- [Mod] <js> Sequence names now start at 1 rather than 0.

MPTM::Custom Tuning
- [Imp] <js> Custom tunings can now be used with OPL instruments (http://forum.openmpt.org/index.php?topic=6254.0).
- [Imp] <jh> Custom tuning and sequence names can now contain any Unicode characters.
- [New] <js> Added character '.' to drawable letters for built-in fonts.

IT
- [Mod] <js> Disable retrigger with short notes quirk for modules saved with ChibiTracker, as it does not implement that quirk.

IT::Compatible Playback Mode
- [Fix] <js> Instrument and sample panning no longer override channel panning for following notes (http://bugs.openmpt.org/view.php?id=1220).
- [Fix] <js> SBx is now prioritized over Bxx commands that are to the left of it. When combining SBx and EEx effects, don't skip the first row of the loop like in FastTracker 2. (http://bugs.openmpt.org/view.php?id=959).
- [Fix] <js> Duplicate Check Type "Sample" should only be applied if the instruments match, too.
- [Fix] <js> Duplicate Check Type "Note" should compare pattern notes, but it was comparing the new pattern note against the old translated note.
- [Fix] <js> Various fixes for envelope resetting.

XM
- [New] <jh> Add support for reading OggMod OXM files (XM with Vorbis-compressed samples).
- [Imp] <js> Raise tempo limit from 512 to 1000 BPM.
- [Mod] <js> If a file contains patterns longer than 1024 rows, they are now clamped to 1024 rows instead of 64 rows.

XM::Compatible Playback Mode
- [Fix] <js> Do not reset note-off status on portamento if there is no instrument number (http://bugs.openmpt.org/view.php?id=1223).

S3M
- [Mod] <js> Support importing empty pattern commands with non-empty parameters. They can still modify the parameter memory, so ignoring them can cause wrong effect parameters to be used.
- [Fix] <js> Offset beyond loop end wraps around to loop start like in Scream Tracker 3 + GUS (previously it just keep playing from the loop start, which is neither what GUS nor Sound Blaster drivers do). If there is no loop, the sample is stopped (consistent with both GUS and Sound Blaster output).
- [Fix] <js> Notes cannot be retriggered after they have been cut.
- [Fix] <js> Previous note offset is no longer used for retriggered notes if there was no instrument number next to the Qxy effect.
- [Fix] <js> Fix portamento after note cut (fixes antediluvian_song.s3m).
- [Fix] <js> Implement sample swapping (with and without portamento) like in Scream Tracker 3 with Sound Blaster driver. This compatibility behaviour is not enabled by default, as OpenMPT mostly follows GUS playback behaviour by default.
- [Fix] <js> When combining SBx and EEx effects, don't skip the first row of the loop like in FastTracker 2. (http://bugs.openmpt.org/view.php?id=959).

MOD
- [Fix] <js> Sample swapping now also works if the sample that is being swapped from does not loop. Swapping to a non-looped sample now stops playback once the swapped-from sample reaches its (loop) end (http://bugs.openmpt.org/view.php?id=1236).
- [Fix] <js> Fix early song ending due to ProTracker pattern jump quirk (EEx + Dxx on same row) if infinite looping is disabled. Fixes Haunted Tracks.mod by Triace.
- [Fix] <js> Previous note offset is no longer used for retriggered notes if there was no instrument number next to the E9x effect.
- [Fix] <js> Vibrato type "ramp down" was upside down.

Other formats
- [Imp] <js> MED: Greatly improved MED import. Synthesized instruments are still not supported but support was added for: Multisampled instruments, delta samples, more pattern commands, Hold and Decay, VSTi and MIDI output, multiple songs and many other small changes (http://bugs.openmpt.org/view.php?id=71).

Audio I/O
- [New] <jh> WASAPI: Provide a default device which automatically follows changes in the default audio device.
- [Imp] <jh> ASIO: Provide 64-bit floating point if supported by the driver.
- [Imp] <jh> ASIO: Support deferred processing. Can be turned off by setting "Sound Settings.AllowDeferredProcessing" to false if it causes trouble.
- [Mod] <jh> Audio driver crashes are no longer silently masked as they may leave the program in an inconsistent state. The new hidden setting "Sound Settings.MaskDriverCrashes" can be toggled to revert to the old behaviour.
- [Mod] <jh> Deprecated sound devices are no longer shown by default. Use the "Show deprecated devices" checkbox to re-enable them.
- [Mod] <jh> Notify users if they use a deprecated sound device on startup.
- [Reg] <jh> Removed hidden setting "Sound Settings.PreferSameTypeIfDeviceUnavailable". This only really made sense for WASAPI, which did not provide an explicit default device until now. For low-level APIs, falling back to any other device is not really desirable because low-level APIs tend to interfer with normal system audio processing.
- [Reg] <jh> Removed hidden settingss "Sound Settings.MoreRtAudio", "Sound Settings.MorePortAudio" and "Sound Settings.ShowNotRecommendedDeviceWarning".

Misc
- [New] <js> MIDI recording now supports Hold Pedal CC messages (http://bugs.openmpt.org/view.php?id=800).
- [Imp] <js> Use new scaling mode for non-DPI-aware applications on Windows 10 1809 or newer that makes fonts look less blurry on high-DPI displays.
- [Imp] <js> When prompting to save modified samples, also check for files that no longer exist on disk.
- [Imp] <js> SF2: Support instrument-global regions, region-specific sample loops, region tuning (only with a value of 0 for drum programs) and multi-instrument presets (http://bugs.openmpt.org/view.php?id=1320).
- [Imp] <js> Loading sound fonts no longer requires to pre-cache the entire file in memory. This makes it possible to load huge sound fonts even in 32-Bit builds.
- [Imp] <js> Legacy Playback Behaviour dialog is now searchable and resizable (http://bugs.openmpt.org/view.php?id=1285).
- [Imp] <js> MIDI Export: Add option to not export program changes per instrument (http://forum.openmpt.org/index.php?topic=6351.0).
- [Imp] <js> ultrasnd.ini import: Support section-specific PatchDir. If no path is specified, fall back to paths relative to the INI filename rather than the current directory, which we have no control over.
- [Mod] <jh> A portable installation of OpenMPT is now identified by the presence of a file called "OpenMPT.portable" rather than an entry in mptrack.ini. Existing portable installations are migrated accordingly.
- [Mod] <jh & js> mptrack.exe was renamed to OpenMPT.exe. Please update any old custom shortcuts or file associations to point to the new executable. For existing installations, the installer will try to create a symbolic link to keep the old filename working.
- [Fix] <jh> Possible crashes when loading files from network drives on unstable network connections.
- [Fix] <js> Use the default theme-aware font in various parts of the UI which now also scales correctly in high-DPI mode. The new font is different from the previous default (Tahoma) on modern Windows versions so the looks of the program are slightly changed even at 100% scaling.
- [Fix] <js> Icons were broken when using custom UI scaling factors in Windows 10 that didn't result in integer icon sizes and high-DPI mode was enabled.
- [Fix] <js> MIDI Export: Fix note-on / note-off conflict when the same note is triggered on two different pattern channels (http://forum.openmpt.org/index.php?topic=6318.0).
- [Reg] <jh> Maximum polyphony setting was removed. Even the slowest supported CPUs can handle 256 channels. The setting is still available as an advanced setting "Sound Settings.MixChannels" (defaults to 256).
- [Reg] <jh> Pre-SSE2 x86 CPUs are no longer supported. This includes Intel Pentium 3 and older, AMD Athlon XP and older and various other third-party CPUs.
- [Reg] <jh> Support for Windows XP and Windows Vista has been dropped.
- [Reg] <jh> mpg123, SoundTouch and LAME are no longer optional components; without the respective DLL files in the application directory, OpenMPT will no longer start.

Bundled plugins
- [Imp] <js> MIDI I/O Plugin: Allow to enter fractional millisecond latency values.
- [Imp] <js> I3DL2Reverb: Provide plugin presets based on OpenMPT's global reverb presets.

Third-Party Libraries
- [Imp] Update nlohmann json (v3.7.3), mpg123 (v1.26rc3), PortAudio (2020-03-26), r8brain (v4.6), RtAudio (v5.1.0)


v1.28.10.00 (13 April 2020, revision 12628)
-------------------------------------------
Pattern tab
- [Fix] <js> Do not modify existing Parameter Control Events incorrectly when interpolating normal (volume) commands or notes.
- [Fix] <js> Volume column tone portamento commands did not update portamento effect memory when seeking. XM volume column portamento quirks are now handled better when seeking.

Sample tab
- [Fix] <js> When OPL instruments were set up as external samples, changing their parameters didn't mark them as modified.

IT
- [Fix] <js> Vibrato was too fast in Old Effects mode since OpenMPT 1.27 (http://bugs.openmpt.org/view.php?id=1309).

XM
- [Fix] <js> Treat 8bitbubsy's FT2 clone exactly like Fasttracker 2 with respect to compatibility and playback flags. For example, FT2 Pan Law was not applied.

Other formats
- [Fix] <js> DMF: Some files had a wrong tempo since OpenMPT 1.25.02.00 (http://bugs.openmpt.org/view.php?id=1303).

Misc
- [Imp] <js> When changing from modern tempo mode to classic or alternative tempo mode, the initial song tempo is now retained better.
- [Fix] <js> Potential crash when trying to save a file to a drive that no longer exists.

Third-Party Libraries
- [Imp] Update UnRAR (v5.9.2)


v1.28.09.00 (22 December 2019, revision 12387)
----------------------------------------------
Pattern tab
- [Fix] <js> Chord detect interval was broken if the pattern number didn't match its location in the order list (e.g. pattern 3 at position 3) since OpenMPT 1.28.07.00.
- [Fix] <js> Potential crash when entering notes, in particular if the order list was empty (http://bugs.openmpt.org/view.php?id=1278).
- [Fix] <js> Potential crash when halving a pattern with an odd number of rows and then expanding it again (http://bugs.openmpt.org/view.php?id=1282).

MOD
- [Fix] <js> Fix initial instrument change with no note playing. Fixes first pattern of Beyond Music by Captain (http://bugs.openmpt.org/view.php?id=1275).

Misc
- [Fix] <js> Loading / creating the first OPL instrument while playback was already running didn't start the OPL emulator until the next time playback was restarted.
- [Fix] <jh> Fix compilation of Wine Integration on recent Wine versions (http://bugs.openmpt.org/view.php?id=1263).

Third-Party Libraries
- [Imp] Update UnRAR (v5.8.5)


v1.28.08.00 (27 October 2019, revision 12247)
---------------------------------------------
Playback
- [Mod] <js> Do not apply ramp from initial global volume to current global volume when jumping around in playback.
- [Fix] <js> Possible crash when trying to retrigger an OPL note with active filter.

VST::Plugin Bridge
- [Fix] <js> Bridge process kept hanging around in background if loading or closing plugin failed.

S3M
- [Imp] <js> Import edit timer from files saved with Impulse Tracker.

Other formats
- [Fix] <js> MTM: Sample loop length was off by one.
- [Fix] <js> PSM: Sample loop length was off by one in most files.
- [Fix] <js> ITP: Possible crash with malformed files.

Misc
- [Imp] <js> Small performance improvement when opening / creating new modules or starting playback.

Third-Party Libraries
- [Imp] Update mpg123 (v1.25.13), UnRAR (v5.8.3)


v1.28.07.00 (22 September 2019, revision 12079)
-----------------------------------------------
Pattern tab
- [Imp] <js> If repeating notes on key hold is enabled, the repetitions are now ignored if recording is disabled (key-jazz) or the edit step is set to 0, to avoid ugly and unnecessary repetitions (http://forum.openmpt.org/index.php?topic=6207.0).
- [Imp] <js> The "editing is disabled" prompt can no longer be dismissed by pressing the "E" key and thus re-enabling editing accidentally (http://bugs.openmpt.org/view.php?id=1250).
- [Fix] <js> Chord detect interval didn't work across pattern boundaries (http://bugs.openmpt.org/view.php?id=1246).

Sample tab
- [Imp] <js> Add shortcuts for toggling sample drawing, adding silence and configuring the sample grid.
- [Imp] <js> Add tooltips with keyboard shortcuts for buttons in waveform view (http://bugs.openmpt.org/view.php?id=980).

Instrument tab
- [Imp] <js> Add tooltips with keyboard shortcuts for buttons in envelope view (http://bugs.openmpt.org/view.php?id=980).
- [Fix] <js> Toggling some envelope features through keyboard shortcuts did not update the corresponding button status.

VST / DMO Plugins
- [Fix] <js> MIDI Mapping dialog did not appear when holding Shift key in some plugin editors (e.g. in Synth1 editor when enabling popout sliders).

VST::Plugin Bridge
- [Fix] <js> It was not possible to record parameter changes to the pattern editor (http://bugs.openmpt.org/view.php?id=991).
- [Fix] <js> Receiving MIDI messages from the bridge was broken since v1.27.08.00.
- [Fix] <js> Sending SysEx messages to a 64-bit host or bridge never worked.

Other formats
- [Fix] <js> MID: Possible crash when importing more than one sustain pedal release message following a note-off.
- [Fix] <js> MO3: MIDI program / bank was actually not imported as announced in v1.28.03.00.

Misc
- [Imp] <js> When adding a sound font fails, an error message is shown.
- [Fix] <js> Possible crash when trying to load huge sound fonts (http://forum.openmpt.org/index.php?topic=6217.0).
- [Fix] <js> SF2: Samples stored past 2 GB into the file couldn't be extracted (http://forum.openmpt.org/index.php?topic=6217.0).

Third-Party Libraries
- [Imp] Update flac (v1.3.3), mpg123 (v1.25.12), ogg (v1.3.4), UnRAR (v5.8.1)


v1.28.06.00 (10 August 2019, revision 11908)
--------------------------------------------
Tree view
- [Imp] <js> When showing folders in the lower panel, going back to the parent folder selects the previously visited folder (http://bugs.openmpt.org/view.php?id=1225).
- [Imp] <js> Scroll to last selected item when refreshing.

Pattern tab
- [Fix] <js> When pasting from IT to MPTM or vice versa, don't convert volume column commands as if they were coming from XM.

Sample tab
- [Fix] <js> Time-stretching a samples with a sample rate higher than 192 kHz crashed OpenMPT (http://bugs.openmpt.org/view.php?id=1234).

Mod Conversion
- [Fix] <js> When converting from IT to MPTM or vice versa, don't convert volume column commands as if they were coming from XM.

IT
- [Imp] <js> Detect IT files unpacked with early UNMO3 versions (http://forum.openmpt.org/index.php?topic=6189.0).

XM
- [Fix] <js> Fix VSTi playback or MIDI export with sample slots whose transpose is not set to C-5.

MOD
- [Imp] <js> Warn when samples beyond sample slot 31 are used.

Third-Party Libraries
- [Imp] Update mpg123 (v1.25.11)


v1.28.05.00 (26 May 2019, revision 11622)
-----------------------------------------
Pattern tab
- [Fix] <js> Seeking with sample sync did not stop notes with XM Key Off (Kxx) effect (http://bugs.openmpt.org/view.php?id=1223).

Mod Conversion
- [Fix] <js> Sequence splitting when converting to MPTM was broken (http://bugs.openmpt.org/view.php?id=1218).

Playback
- [Fix] <js> Possible crash when playing some XM files (introduced in OpenMPT 1.28.01.00).
- [Fix] <js> Breaking out of a sustain loop through Note-Off sometimes didn't continue in the regular sample loop, or not at the correct position.

Misc
- [Imp] <js> Show keyboard shortcuts in various tooltips (http://bugs.openmpt.org/view.php?id=980).
- [Imp] <js> Try to figure out when a USB MIDI device is disconnected and disable the MIDI record button if this device was being used for recording.
- [Imp] <js> In addition to checking for the latest development builds, it is now also possible to receive update notifications for upcoming minor updates.
- [Fix] <js> In High-DPI mode, scale initial size of the upper panel of child windows properly.

Bundled plugins
- [Fix] <js> MIDI I/O Plugin: Do not crash when sending a MIDI message fails (e.g. with Coolsoft Virtual MIDI Synth, http://bugs.openmpt.org/view.php?id=1219).

Third-Party Libraries
- [Imp] Update opus (v1.3.1), RtMidi (4.0.0) and UnRAR (v5.7.5)


v1.28.04.00 (7 April 2019, revision 11528)
------------------------------------------
Tree view
- [Fix] <js> MIDI Library preview did not preview the correct instruments for many soundfonts including GM.DLS.

Sample tab
- [Fix] <jh> FLAC: Tags were imported with incorrect character set.

VST / DMO Plugins
- [Fix] <js> Do not send MIDI volume or set dry / wet ratio on note-off. Old behaviour (this bug has gone unnoticed for more than ten years!) is retained through a compatibility setting that is only available for legacy files (http://forum.openmpt.org/index.php?topic=6115.0).

S3M
- [Mod] <js> Do not allow OPL3 waveforms in S3M files. Existing files with OPL3 waveforms are not affected.

MOD
- [Fix] <js> Sample swapping was always enabled since it has been separated from the ProTracker 1/2 compatibility flag. Now it is always enabled for Amiga-style modules and otherwise the old heuristic is used again (http://bugs.openmpt.org/view.php?id=1199).
- [Fix] <js> Saving 16-bit stereo samples (which should be converted to 8-bit mono) was broken since OpenMPT 1.28.01.00.

Other formats
- [Imp] <js> STK: SoundTracker default tempo is no longer rounded.
- [Fix] <js> MTM: Ignore unused Exy commands on import (http://bugs.openmpt.org/view.php?id=1204).
- [Fix] <js> Startrekker: Clamp speed to 31 ticks per row (http://bugs.openmpt.org/view.php?id=1201).

Audio I/O
- [Fix] <jh> Fix building Wine wrapper when RtAudio or PortAudio is not available (http://bugs.openmpt.org/view.php?id=1210).
- [Fix] <jh> Fix RtAudio configuration for Wine wrapper (http://bugs.openmpt.org/view.php?id=1211).

Misc
- [Mod] <js> On Windows 10, OpenMPT prevented Windows from shutting down even when there were no unsaved files. On Windows Vista and newer, OpenMPT now shows the number of unsaved files when preventing a shutdown.
- [Fix] <js> MIDI Export: Synchronize pitch wheel depth between instruments.
- [Fix] <js> MIDI Export: "Don't export" didn't work as intended when the ignored instrument shared pattern channels with exported instruments.
- [Fix] <jh> Do not disable Reverb if /noAssembly command line switch is passed.

Third-Party Libraries
- [Imp] Update UnRAR (v5.7.4)


v1.28.03.00 (10 February 2019, revision 11351)
----------------------------------------------
Sample tab
- [Fix] <js> When initializing an OPL instrument, the undo state of the sample slot was not updated (http://bugs.openmpt.org/view.php?id=1194).

Instrument tab
- [Fix] <js> Properly render & character in custom note names in note map (http://bugs.openmpt.org/view.php?id=1114).

MPTM
- [Mod] <js> OPL notes can now be controlled (volume / pan / pitch) after they have been released. Note Cut (^^^) now really cuts OPL notes, use === to release them instead. For existing MPTM files, the legacy behaviour is used.
- [Fix] <js> Possible crash when doing a portamento from an OPL instrument to an empty instrument note map slot.

IT::Compatible Playback Mode
- [Fix] <js> Various fixes for note-off + instrument number in Old Effects mode.

S3M
- [Fix] <js> Allow volume of OPL notes to be controlled after note-off (fixes gotoandplay_-_losing_sanctuary.s3m).

Other formats
- [Imp] <js> MO3: Import IT row highlights as written by MO3 2.4.1.2 or newer. Properly import MIDI program and bank info.

Audio I/O
- [Mod] <jh> On Wine on Linux, prefer DirectSound over WaveOut because there are still systems with winealsa.drv where WaveOut occasionally breaks. This change only affects new installations of OpenMPT (http://bugs.openmpt.org/view.php?id=1193).

Misc
- [Fix] <jh> Builds for Windows XP / Vista no longer worked on CPUs without SSE2 support (http://forum.openmpt.org/index.php?topic=6055.0).
- [Fix] <js> MIDI Export: Pitch bend was not reset when two instruments shared a MIDI channel (http://bugs.openmpt.org/view.php?id=1195).

Third-Party Libraries
- [Imp] Update UnRAR (v5.7.1)


v1.28.02.00 (6 January 2019, revision 11185)
--------------------------------------------
Pattern tab
- [Fix] <js> Properly render & character in custom fonts (http://bugs.openmpt.org/view.php?id=1114).

Playback
- [Mod] <js> Improve OPL silent note optimization.

MPTM::Custom Tuning
- [Fix] <js> Tuning Dialog: Properly render & character in note name list (http://bugs.openmpt.org/view.php?id=1114).

Other formats
- [Imp] <js> MO3: Apply playback changes based on "ModPlug-made" header flag.

Audio I/O
- [Fix] <jh> Only clip WASAPI non-exclusive floating-point output on real Windows systems. Wine does not need it.

Misc
- [Fix] <js> Open / Save file dialogs looked strange on some Wine setups (http://bugs.openmpt.org/view.php?id=1181).

Third-Party Libraries
- [Imp] Update nlohmann json (v3.5.0)


v1.28.01.00 (23 December 2018, revision 11100)
----------------------------------------------
Pattern tab
- [Imp] <js> Effect memory is now also used for volume column input.
- [Imp] <js> New shortcut "Show Chord Editor" (http://bugs.openmpt.org/view.php?id=338).
- [Imp] <jh> When using a custom pattern font, all ASCII characters are now usable for rendering custom note names in tunings.
- [Fix] <js> Seeking with sample sync did not work properly when playback was to be resumed on a row that contained an instrument-less note.

Sample tab
- [New] <jh> Add Apple CAF and Sony Wave64 sample import. Only basic uncompressed formats are supported and no detailed instrument or sample metadata is imported for now.
- [New] <js> Can now read SBI (OPL2 instrument) files.
- [New] <js> Can now write S3I (Scream Tracker 3 instrument) files, mainly intended for saving OPL instruments.
- [Imp] <js> Faster sample normalization.
- [Imp] <jh> Read sample title from AU files.
- [Imp] <jh> WAV files are now written with a CSET chunk to specify the metadata encoding as UTF-8.
- [Imp] <jh> Read ID3 tags in MP3 samples.
- [Imp] <js> Decreased memory consumption during saving of FLAC samples.
- [Mod] <js> Removed mnemonic for "slice sample" context menu entry (http://bugs.openmpt.org/view.php?id=1169).
- [Fix] <jh> FLAC metadata was not encoded correctly as UTF-8.

Instrument tab
- [New] <js> Can now specify the color of the release node section of envelopes.
- [New] <js> SFZ export. Note that many instrument properties do not map cleanly to SFZ features, so this export is quite lossy.
- [New] <js> In the envelope scaling dialog, it is now also possible to add an offset to the y axis.
- [Fix] <js> Importing ITI / XI instruments into IT / XM files did not remove the release node settings.
- [Fix] <js> Fixed possible rare crash that could occur when redrawing the envelope editor (http://bugs.openmpt.org/view.php?id=1175).

Tree view
- [Imp] <js> Show external samples with different icons.
- [Mod] <js> Sample / instrument play status update is now enabled by default on new installations.
- [Fix] <js> Previewing MIDI Library items associated with soundfonts now previews the correct instrument inside that soundfont.

Mod Conversion
- [Mod] <js> Remove E0x commands when converting from MOD / XM to S3M / IT / MPTM.
- [Mod] <js> Convert Note Cut (^^^) to C00 instead of EC0 when converting to MOD / XM.

VST / DMO Plugins
- [Mod] <js> "Pass keys to plugin" is no longer required to be activated when a standard input field is focussed in a plugin GUI to be able to enter texts.

Playback
- [New] <js> MIDI macros now support three new undocumented (but fully supported by Impulse Tracker) characters: h (tracker channel), o (sample offset) and m (sample loop direction).
- [New] <js> MIDI macros now support the non-standard macro character s, which automatically calculates the correct checksum for a GS SysEx message.
- [Imp] <js> MIDI messages FA, FC and FF reset the resonant filter settings for all channels, like in Impulse Tracker.
- [Mod] <js> Amiga resampler is now enabled by default for Amiga modules.
- [Fix] <js> NNA channel allocation did not handle instruments only associated to plugins correctly, causing VSTi NNA channels to be "lost" in many cases (unable to control with S7x).
- [Fix] <js> An instrument release node past the sustain loop end was not processed correctly with "IT-style envelope position advance + enable/disable behaviour" flag enabled (http://bugs.openmpt.org/view.php?id=1171).
- [Fix] <js> Release node volume scaling was not applied properly if an envelope loop started before the release node.

MPTM
- [New] <js> AdLib (OPL) instruments are now supported. Up to 18 simultaneous voices with OPL3-style panning (hard left / center right) and all OPL3 waveforms can be used. 4-operator instruments are not available for now, though.
- [Imp] <js> More logical release node behaviour. The release part is now scaled by the ratio between the value of the key-off point and the release node. The old behaviour is retained through a compatibility flag.
- [Mod] <js> When creating a new MPTM file, a few more sensible IT compatibility flags are now enabled by default to be more consistent with IT.

XM::Compatible Playback Mode
- [Fix] <js> If the sustain point of the panning envelope is reached before key-off, it is never released.
- [Fix] <js> Do not default recall volume / panning for delayed instrument-less notes.

S3M
- [New] <js> AdLib (OPL) instruments are now supported. Compared to Scream Tracker 3, this implementation supports 18 instead of 9 simultaneous OPL voices, OPL3-style panning (hard left / center / right) and the extra OPL3 waveforms are supported as well (http://bugs.openmpt.org/view.php?id=381).
- [Fix] <js> Notes without instrument number use previous note's sample offset.

MOD
- [Imp] <js> Support notes in octave 2, like in FastTracker 2 (fixes DOPE.MOD).
- [Fix] <js> Do not apply Amiga playback heuristics to files that have clearly been written with a PC tracker. Fixes LHS_MI.MOD (tx haspor).

Other formats
- [New] <js> Can now import C67 (CDFM / Composer 670) files.
- [Mod] <js> IMF: Import disabled channels as muted channels.
- [Fix] <js> MID: Running status should only be applied to channel events.
- [Fix] <js> MID: If the MIDI Library contained instruments not mapped to soundfonts, the wrong instruments could sometimes be loaded.
- [Fix] <js> SFX: Work around bad conversions of the "Operation Stealth" soundtrack by turning pattern breaks into note stops (http://bugs.openmpt.org/view.php?id=1170).

Stream Export
- [New] <jh> Add AU export. This allows to export uncompressed PCM audio larger than 2 GB (http://bugs.openmpt.org/view.php?id=766).
- [Imp] <jh> The LAME MP3 encoder is now shipped with OpenMPT (http://bugs.openmpt.org/view.php?id=1095).
- [Reg] <jh> Removed MP3 encoding support via ACM.

Module cleanup
- [New] <js> Can now optimize samples (Edit -> Sample Trimmer) by automatically playing the whole song and recording how much of each sample is played (http://bugs.openmpt.org/view.php?id=554).

Audio I/O
- [Mod] <jh> Modernize default sound device priority list for Wine on non-Linux systems.

Misc
- [New] <js> Can now pass more than one file via command line parameter to open with OpenMPT. Use the /shared parameter to send the files to an existing OpenMPT instance rather than opening a new instance.
- [New] <js> Added menu item and keyboard shortcut to save a copy of a module (http://bugs.openmpt.org/view.php?id=1166).
- [New] <js> MIDI Export: Added option to prevent instruments from overlapping on same MIDI channel for more "classical" MIDI export rather than expecting each track to be sent to its own device / plugin.
- [Imp] <js> MIDI Export: "Melodic (any)" channel mapping now uses up to 15 instead of 8 different channels (all but channel 10).
- [Imp] <js> New shortcut "Toggle Loop Song" (http://bugs.openmpt.org/view.php?id=338).
- [Imp] <js> Settings dialog: Added a possibility to set friendly names for MIDI input devices. For output devices, the settings still have to be edited directly.
- [Imp] <js> OpenMPT now warns if saving a module or MIDI export failed (e.g. because of insufficient storage space, http://bugs.openmpt.org/view.php?id=1161).
- [Imp] <js> On Windows Vista and later, the Places bar in file dialogs now contains links to OpenMPT's default directories.
- [Imp] <js> On Windows Vista and later, the new file dialog style is now also used when audio file preview is enabled.
- [Imp] <jh> Advanced Settings: Use a different background color for settings that have non-default values.
- [Mod] <js> Sub song search is now less thorough, finding less unwanted sub songs in partially played patterns.
- [Mod] <js> Allow compatibility flags to be part of MPTM templates. They are still reset for legacy module types to always enforce maximum compatibility even when opening templates saved with an older OpenMPT version.
- [Mod] <js> When showing a list of missing plugins on startup, offer the user to remove all or some of them (http://bugs.openmpt.org/view.php?id=1153).
- [Mod] <jh & js> Merge lossy and lossless stream export into a single menu entry and keyboard shortcut (http://bugs.openmpt.org/view.php?id=801).
- [Mod] <jh & js> Format various numbers with thousands separators to make them more readable.
- [Mod] <jh> Interpolation filters have been renamed: "XMMS-ModPlug" is now "Sinc", "Polyphase" is now "Sinc with Low-Pass".
- [Mod] <jh> Added possibility to check for updates at each program startup.
- [Mod] <jh> OpenMPT now flushes all file buffers when saving files to minimize data loss in case of an unexpected system crash. As this feature may slow down module saving especially with large modules and samples, it can be disabled through the hidden setting "Misc.FlushFileBuffersOnSave" (http://bugs.openmpt.org/view.php?id=1157).
- [Mod] New shiny icons, splash and about screens by Úlfur Kolka!
- [Fix] <js> When DPI-awareness is enabled, icons are now scaled correctly.
- [Fix] <js> Automatically re-establishing Set Spacing keys after removing another numeric key combination never worked as intended.
- [Fix] <js> OpenMPT no longer uses DDE by default to open files from Explorer, as it could sometimes show a bogus warning message (http://bugs.openmpt.org/view.php?id=1126).
- [Fix] <js> No error message was shown when trying to open a file from the Most Recent Files list that was located on a non-existing drive (http://bugs.openmpt.org/view.php?id=1057).
- [Fix] <js> Update Check: Ignoring a new version did not work.
- [Reg] <js> Remove bandwidth and windowing function selection from mixer configuration. These are often misunderstood by users and changing them can result in reduced resampling quality if one does not fully understand the consequences. They are now hidden settings and reverted back their setting to the default value.
- [Reg] <jh> Wine 1.6 is no longer supported. The minimum required version is Wine 1.8.

Third-Party Libraries
- [Imp] Update opus (v1.3), SoundTouch (v2.1.1) and UnRAR (v5.6.8)


v1.27.11.00 (21 October 2018, revision 10938)
---------------------------------------------
Pattern tab
- [Fix] <js> Amplification with both fade-in and fade-out enabled was broken.
- [Fix] <js> Partially selected channels were sometimes amplified when they should not have been.

Sample tab
- [Fix] <js> Trying to apply an invalid sample rate and then choosing the upsample or downsample option instead caused the wrong sample rate to be chosen for resampling.
- [Fix] <js> Reject resampling ratios greater than or equal to 512 when using r8brain for resampling as they resulted in a crash.

Mod Conversion
- [Mod] <js> When converting to MOD / XM, convert S8x to 8xx instead of E8x, as Fast Tracker does apparently not support E8x.

Playback
- [Fix] <js> Clicks when stopping channels that didn't end at zero volume in 64-bit builds.

XM
- [Fix] <js> Do not import commands N and M as channel volume commands (http://bugs.openmpt.org/view.php?id=1156).

Other formats
- [Fix] <js> MED: Possible crash with malformed files.

Misc
- [Imp] <js> Implement horizontal wheel scrolling for pattern / sample / instrument editors. Useful e.g. for pattern navigation with some trackpoint drivers.
- [Fix] <js> Notes triggered from any editor could be played with a panbrello effect if some other channel was previously playing with panbrello.

Third-Party Libraries
- [Imp] Update libopusenc (v0.2.1)


v1.27.10.00 (23 September 2018, revision 10852)
-----------------------------------------------
Pattern tab
- [Fix] <js> With "always center active row" disabled, cancelling a pattern selection by clicking into the pattern did not set the cursor position correctly (http://bugs.openmpt.org/view.php?id=1142).

Sample tab
- [Mod] <jh> Reject overly long MP3 / FLAC / Vorbis / Opus / Media Foundation samples.

Tree view
- [Fix] <jh> Fix crackling, initial missing frames or sometimes even completely in audible instrument preview.

Playback
- [Fix] <js> The first few frames of previewed notes in the sample, instrument and pattern editors were sometimes cut off (http://bugs.openmpt.org/view.php?id=209).
- [Fix] <js> Jump commands on the same row as the end of a pattern loop covering the restart position of the module could cause the module to loop even when looping was disabled (tx pulsewidth).

Other formats
- [Fix] <js> ITP: Possible crash with malformed files.

Misc
- [Fix] <js> Scrolling with touch gestures (on touch screens and some touchpads) did not scroll the pattern, sample and instrument editor contents (despite changing the scrollbar position) on Windows 8 and later.
- [Fix] <js> When trying to append a module with differing global swing settings, the time signature was not overridden properly.
- [Fix] <js> Advanced Settings: Crash when pressing Enter and there is no value to edit (http://bugs.openmpt.org/view.php?id=1140).
- [Fix] <jh> Some tooltips in the MIDI Mapping Dialog showed incorrect texts.

Third-Party Libraries
- [Imp] Update libopusenc (v0.2), opusfile (v0.11) and UnRAR (v5.6.6)


v1.27.09.00 (28 July 2018, revision 10630)
------------------------------------------
Pattern tab
- [Fix] <js> Mix-pasting multiple patterns including +++ or --- patterns inserted those patterns at the beginning of the orderlist. They are now ignored completely.
- [Fix] <js> Entering a note, then pressing the chord modifier and releasing the key was interpreted as releasing a chord, which could lead to a crash when accessing bogus chord key channels.
- [Fix] <js> Picking up an instrument number higher than the number of usable instruments in the dropdown list was not possible.

Playback
- [Fix] <js> Channels whose volume envelope was playing at volume 0 while being moved to a NNA background channel were cut off completely since OpenMPT 1.27.07.00.

MPTM
- [Fix] <jh & js> Crash with some malformed tunings.

Other formats
- [Fix] <js> AMF (ASYLUM): Convert 7-bit panning to 8-bit panning for playback.

Misc
- [Mod] <jh> The crash handler no longer includes the installation GUID in crash reports as it theoretically allows de-anonymizing update statistics.

Third-Party Libraries
- [Imp] Update UnRAR (v5.6.5)


v1.27.08.00 (19 May 2018, revision 10245)
-----------------------------------------
Pattern tab
- [Imp] <js> Show instrument change shortcuts also in sub menu of context menu.

Sample tab
- [Fix] <js> Convert sample properties when importing samples via Media Foundation codecs (for MOD / XM).

Instrument tab
- [Imp] <js> New shortcuts: Switch to Volume / Panning / Pitch / Filter Envelope, Toggle Volume / Panning / Pitch / Filter Envelope, Toggle Envelope Loop, Toggle Envelope Sustain Loop, Toggle Envelope Carry.
- [Fix] <js> SFZ: Assume UTF-8 encoding for region names.

Tree view
- [Imp] <js> Select next item after deleting a file to prevent scrolling back to top on Wine.

VST::Plugin Bridge
- [Fix] <js> Sending or receiving SysEx messages resulted in a crash.
- [Fix] <js> When automating more than 64 plugin parameters at the same time (also when restoring saved parameters), parameter 0 was reset to a value of 0 (http://forum.openmpt.org/index.php?topic=5967.0).

Playback
- [Fix] <js> The resonant filter was sometimes unstable when combining low-volume samples, low cutoff and high mixing rates.
- [Fix] <js> Switching between instruments with portamento did not update the NNA settings (fixes outcast the third.it, http://bugs.openmpt.org/view.php?id=1122).

Other formats
- [Fix] <js> AMS: Possible crash during load in low memory situations.
- [Fix] <js> FAR: Properly import volume commands.
- [Fix] <js> MID: GS drum channel enable and disable messages were still broken since v1.27.06.00.
- [Fix] <js> STM: Having both Bxx and Cxx commands in a pattern imported the Bxx command incorrectly (fixes ilu.stm).
- [Fix] <js> ULT: Portamento import was sometimes broken.

Third-Party Libraries
- [Imp] Update UnRAR (v5.6.4)


v1.27.07.00 (8 April 2018, revision 10044)
------------------------------------------
Pattern tab
- [Imp] <js> Keep track of active SFx macro during seeking.

Instrument tab
- [Fix] <js> Importing soundfont instruments into IT / XM files did not remove the release node settings.

VST / DMO Plugins
- [Mod] <js> Prepend plugin name to default filename when saving a plugin preset or bank (http://bugs.openmpt.org/view.php?id=1108).

Playback
- [Fix] <js> The "note cut" duplicate note action did not volume-ramp the previously playing sample.

Other formats
- [Imp] <js> DSM: Support restart position and 16-bit samples.
- [Imp] <js> DTM: Import global volume.

Misc
- [Fix] <js> Possible crash when calculating song length in patterns with many nested pattern loops.

Third-Party Libraries
- [Imp] Update libvorbis (v1.3.6) and UnRAR (v5.6.2)


v1.27.06.00 (11 March 2018, revision 9911)
------------------------------------------
General tab
- [Fix] <js> Undoing a change in number of channels did not update the channel count in the General tab.

Sample tab
- [Fix] <js> Shortcuts with Shift key for Normalize and DC Removal no longer clash with the Shift modifier for applying those actions to all samples.
- [Fix] <js> Fix previewing of notes after replacing a sample with an active sample selection by a shorter sample (http://bugs.openmpt.org/view.php?id=1093).

Instrument tab
- [Imp] <js> DLS / SF2 / SFZ: Set release node for volume envelopes in MPTM format.
- [Fix] <js> SFZ: Do not reject files with <curve> sections and import region_label as sample name.
- [Fix] <js> Allow to the first envelope node to be set as the release node.

Tree view
- [Fix] <js> Crash after removing all patterns (http://bugs.openmpt.org/view.php?id=1091).

Playback
- [Fix] <js> Some filter changes through MIDI macros were not applied if the note volume was set to 0 on the same row.

Other formats
- [Imp] <js> MED: Import "STP" note stop command.
- [Fix] <js> DBM: Key Off and Set Envelope Position were imported incorrectly. High sample offset (E7x) is now supported.
- [Fix] <js> MID: GS drum channel enable and disable messages unconditionally enabled drum channels.

Stream Export
- [Imp] <js> More accurate estimation of export duration for order list selections.
- [Fix] <js> Spin buttons for sequence and order selection export were not enabled correctly.
- [Fix] <js> Correctly estimate song length when the song is played more than once (http://bugs.openmpt.org/view.php?id=1088).

Misc
- [Fix] <jh> Welcome Dialog: FT2 and IT classic keymaps were mixed up.
- [Fix] <js> Bogus error messages were shown when loading the default keymap.
- [Fix] <js> Small memory leak when browsing for folders.
- [Fix] <js> Grey out "Close All" menu item when no documents are open (http://bugs.openmpt.org/view.php?id=1062).

Third-Party Libraries
- [Imp] Update libvorbis (security patches for v1.3.5) and mpg123 (v1.25.10)


v1.27.05.00 (11 February 2018, revision 9643)
---------------------------------------------
Pattern tab
- [Imp] <js> Seeking with sample sync now supports fine volume slides.
- [Mod] <js> Interpolating the note column no longer overwrites existing instrument numbers.
- [Fix] <js> Possible crash when trying to enter notes after deleting all patterns.

Pattern tab::Find/Replace
- [Imp] <js> If no pattern selection is made, pre-fill the Find fields with values from the current pattern cell if they have not been used in a previous search (http://bugs.openmpt.org/view.php?id=1082).
- [Fix] <js> After an unsuccessful search, show the correct search strings when searching for PC events.
- [Fix] <js> When repeating a search for PC events, the previous parameter value was not filled in correctly.
- [Fix] <js> Searching for specific plugin parameter values did not work correctly.
- [Fix] <js> Searching for PC events sometimes found normal events and vice versa.

Sample tab
- [Imp] <js> Add drop-down menu for saving all samples.
- [Fix] <js> Upsampling a sample selection did not scale the new selection correctly if its end exceeded the old sample length (tx Xemogasa).

Instrument tab
- [Imp] <js> Add drop-down menu for saving all instruments.

Comments tab
- [Fix] <js> Soft tabs did not have the correct size most of the time (http://bugs.openmpt.org/view.php?id=1083).

Tree view
- [Mod] <js> Do not enforce dragged-over items to be completely visible when using drag and drop (tx sincx).
- [Fix] <js> Duplicating or inserting instruments or samples did not refresh the pattern view properly.
- [Fix] <js> Even after removing all patterns, they were still visible.

Other formats
- [Fix] <js> IMF: Filter cutoff was upside down.
- [Fix] <js> MED: Correctly import patterns with less channels than the maximum used amount (http://bugs.openmpt.org/view.php?id=1036).
- [Fix] <js> STM: More accurate tempo calculation and better support for old format versions.
- [Fix] <js> Possible small memory leaks and crashes with malformed STP files.

Misc
- [Fix] <js> Loading the default keyboard configuration didn't load all default keys since OpenMPT 1.27.01.00, causing issues such as making instrument number entry with the regular number keys impossible.
- [Fix] <js> More accurate song length calculation for pattern loops that have no start command (SB0).


v1.27.04.00 (28 January 2018, revision 9537)
--------------------------------------------
Pattern tab
- [Fix] <js> Shrinking a selection did not work as intended when merging an effect command for the second row of two merged rows.
- [Fix] <js> It was possible to interpolate columns even if pattern editing was disabled.

Sample tab
- [Imp] <js> When dropping a sample with no filename from another module, copy the module name to the filename field instead.
- [Fix] <js> Dropping a sample from another module did not adjust its parameters to the new module format.
- [Fix] <js> When reading an ITI file as a sample, the middle-C sample was not used as intended in ITIs written with old versions of Schism Tracker.

Instrument tab
- [New] <js> SFZ: Support loop_crossfade opcode for creating crossfaded loops when importing samples.
- [Fix] <js> With extremely long envelopes (>= 46300 ticks), the closest envelope point to the cursor was not computed correctly, leading to some mouse actions not working on the intended envelope node.

MPTM::Custom Tuning
- [Fix] <jh> SCL: Do not replace ISO 8859-1 characters with space when writing the name.

XM
- [Fix] <js> E60 loop bug was not considered in song length calucation.

MOD
- [New] <js> Support MOD files from the Inconexia demo by Iguana.
- [Mod] <jh & js> Tighten STK and MOD file rejection heuristics.

Other formats
- [Fix] <js> J2B: Ignore frequency limits from file header. Fixes Medivo.j2b, broken since OpenMPT 1.26.
- [Fix] <js> STM: Last character of sample name was missing.

Stream Export
- [Fix] <js> Vorbis: Do not show ABR bitrates that are not supported (http://bugs.openmpt.org/view.php?id=1074).

Misc
- [Fix] <js> The total song length was sometimes estimated as "0mn60s" instead of "1mn00s" or similar.

Bundled plugins
- [Fix] <js> LFO Plugin: Closing the plugin editor while the pattern editor was open could lead to the LFO waveform being changed unintentionally.
- [Fix] <js> ParamEq: Center frequency should be capped at a third of the sampling rate, not half.


v1.27.03.00 (17 December 2017, revision 9370)
---------------------------------------------
General tab
- [Imp] <js> Always ensure that tempo tapping is done with a high-resolution timer. This may improve tapping accuracy if no module is playing.
- [Fix] <js> Restart position spinner was sometimes unavailable after deleting orders (http://bugs.openmpt.org/view.php?id=1056).
- [Fix] <js> Update channel plugin lists when inserting or moving plugins (http://bugs.openmpt.org/view.php?id=1058).

Pattern tab
- [Fix] <js> Effect visualizer: Dropdown lists were not DPI-aware.

Playback
- [Fix] <js> Volume envelopes of previewed notes in pattern or instrument editor were not volume-ramped correctly, causing audible clicks.

IT
- [Fix] <js> Fix broken volume envelopes with negative values as found in breakdwn.it by Elysis.

Stream Export
- [Fix] <jh> RAW encoder was set as the default encoder by mistake since OpenMPT 1.27.01.00.

Misc
- [Fix] <js> Save As dialogs changed the working directory, preventing removable media from being ejected after saving to such drive (http://bugs.openmpt.org/view.php?id=1060).
- [Fix] <js> High-resolution timers were not disabled when playback was stopped, possibly leading to unintentional increased power consumption.
- [Fix] <js> Allow numbers with trailing newlines to be pasted into decimal and signed numer edit fields (http://bugs.openmpt.org/view.php?id=1055).
- [Fix] <js> Example pattern data was not displayed correctly in the manual.
- [Fix] <js> Autosave was broken in OpenMPT 1.27.02.00.

Third-Party Libraries
- [Imp] Update libopusenc (v0.1.1), mpg123 (v1.25.8), ogg (v1.3.3), opusfile (v0.10).


v1.27.02.00 (4 November 2017, revision 9221)
--------------------------------------------
Pattern tab
- [Imp] <js> Provide tooltips for order list items to see their position (e.g. for creating a pattern jump target) and pattern name.
- [Imp] <js> Clipboad Manager is now resizable.
- [Fix] <js> Switching between normal and "extended" effects (Exy/Sxy) could confuse the parameter that was being searched for.

Sample tab
- [Fix] <js> Setting loops through the context menu did not create an undo point.

IT::Compatible Playback Mode
- [Fix] <js> In Compatible Gxx mode, allow sample changes next to a tone portamento effect if a previous sample has already stopped playing (fixes livingston_-_booger_4.it).

MOD
- [Fix] <js> Slides and delayed notes are executed on every repetition of a row with row delay (fixes "ode to protracker", http://bugs.openmpt.org/view.php?id=1053).

Other formats
- [Fix] <js> MID import: Take XG / GS drum channel setup into account for deciding whether to import note-offs.

Stream Export
- [New] <js> Can now choose which sequences to export (http://bugs.openmpt.org/view.php?id=33).
- [Reg] <jh> Remove the rather useless export file size limitation.

Misc
- [Imp] <js> Better support for opening files with very long path names via DDE.
- [Fix] <js> Possible crash when closing a currently playing module with lots of speed changes.
- [Fix] <jh> On Wine, keyboard input was not possible in some dialogs (http://bugs.openmpt.org/view.php?id=1037).

Third-Party Libraries
- [Imp] Update mpg123 (v1.25.7)


v1.27.01.00 (27 September 2017, revision 9000)
----------------------------------------------
General tab
- [Imp] <js> Indicate whether a plugin is bridged (http://bugs.openmpt.org/view.php?id=904).

Pattern tab
- [New] <js> Allow locking playback to a pattern selection through context menu or shortcut (http://forum.openmpt.org/index.php?topic=5720.0).
- [New] <js> Added option "Play notes when transposing" which previews the transposed note if the pattern selection only spans one pattern cell (tx Kab).
- [New] <js> New shortcut "Apply current instrument to existing only". Unlike "Apply current instrument", this does not affect notes without instrument numbers. Can also be found in "Change Instrument" context sub-menu.
- [New] <js> New shortcut "Transpose Custom (Quick)", which applies the previously used custom transpose amount if possible, or shows the transpose dialog otherwise (http://bugs.openmpt.org/view.php?id=947).
- [New] <js> New shortcuts "Jump to previous / next entry in column" can be used to quickly jump to the next non-empty entry in the currently selected note, instrument, etc. column.
- [New] <js> VU meters are now also shown for instrument plugins. Plugin VU meters can have their own colours defined in the Display options (http://forum.openmpt.org/index.php?topic=2006.0).
- [New] <js> Can now fade in from or fade out to arbitrary values other than 0% (http://bugs.openmpt.org/view.php?id=48).
- [New] <js> Pattern Properties: Can now add and remove rows at the beginning of the pattern (http://bugs.openmpt.org/view.php?id=280).
- [New] <js> Pasting multiple patterns without inserting new patterns is now possible when using Mix Paste and Paste Flood. Note: Overflow Paste has to be enabled to continue pasting past the current pattern's end (http://bugs.openmpt.org/view.php?id=812).
- [New] <js> Add "Select Column" which really only just selects the current column. Default: Ctrl+Shift+L.
- [New] <js> Show selection size in status bar.
- [New] <js> Added option to disable follow song on click (http://bugs.openmpt.org/view.php?id=667).
- [New] <js> Hidden setting "Pattern Editor.FontDot" can now be used to replace the empty cell placeholder character in custom pattern fonts (tx daXX).
- [New] <js> An accessibility description of the current pattern cell is now provideded for screen readers. The description format can be customized through the setting "Pattern Editor.AccessibilityFormat".
- [Imp] <js> Seeking with sample sync now also keeps track of pingpong-looped samples.
- [Imp] <js> Overwriting a MIDI macro with a PC event automatically converts the macro parameter.
- [Imp] <js> When configuring a pattern's tempo swing settings, the "Use Global Settings" button can now be used to copy the default swing settings to this pattern.
- [Imp] <js> Seeking now updates the vibrato / tremolo / panbrello position.
- [Imp] <js> Show pattern location of undo / redo action in menu entries.
- [Mod] <js> Rename old "Select Column" to "Select Channel".
- [Mod] <js> "Maintain sample sync on seek" is now enabled by default on new installations.
- [Fix] <js> Recording MIDI macros over existing PC events resulted in incorrect pattern data.
- [Fix] <js> Various order editing features (e.g. drag & drop) did not always work correctly when extending the sequence past the 256th order item.
- [Fix] <js> When pasting multiple patterns, patterns with names containing a "|" were not pasted correctly.

Sample tab
- [New] <jh & js> Can now import 64-bit PCM WAV and AIFF samples.
- [New] <js> Can now fade in from or fade out to arbitrary levels other than 0% (http://bugs.openmpt.org/view.php?id=48).
- [New] <js> Can now change the stereo width of a sample.
- [New] <js> Show selection length in beats (based on current tempo).
- [Imp] <js> Improved resampling accuracy when using the built-in resamplers.
- [Imp] <js> Directly apply global volume changes to playing channels.
- [Imp] <js> Directly update the sample rate of playing channels after resampling (only IT / MPTM / S3M).
- [Imp] <jh> mpg123 is now shipped with OpenMPT, so MP3 sample import is now supported out of the box on all systems.
- [Imp] <js> Remember previously used values when adding silence or resizing samples (http://bugs.openmpt.org/view.php?id=965).
- [Imp] <js> If not bound to a shortcut, the Application key opens the context menu.
- [Imp] <js> Can now resize sample in milliseconds instead of samples.
- [Imp] <js> Can now display cursor position in hex (http://bugs.openmpt.org/view.php?id=963).
- [Mod] <js> For samples whose path is known, offer this path when saving them rather than a name based on the possibly incomplete filename field.
- [Fix] <js> Small noise bursts when previewing sample or instrument after module was paused (http://bugs.openmpt.org/view.php?id=941).

Instrument tab
- [New] <js> Undo / Redo for instruments (http://bugs.openmpt.org/view.php?id=126).
- [New] <js> Can now import SFZ instruments. A list of supported opcodes can be found in the manual.
- [New] <js> Allow saving all instruments at once by shift-clicking the save button.
- [New] <js> An accessibility description of the currently selected envelope point is now provideded for screen readers.
- [Imp] <js> Directly apply global volume changes to playing channels.
- [Imp] <js> Indicate whether a plugin is bridged (http://bugs.openmpt.org/view.php?id=904).
- [Imp] <js> If a control is disabled, show in tooltip text why this is the case.
- [Imp] <js> Improve tuning accuracy in PAT instruments.
- [Imp] <js> If not bound to a shortcut, the Application key opens the context menu.
- [Imp] <js> Can now display cursor position in hex (http://bugs.openmpt.org/view.php?id=963).
- [Reg] <js> No longer allow per-instrument resampling to be used in IT and XM files. Legacy modules are not affected.

Comments tab
- [Imp] <js> The Tab key can now be used to insert soft tabs (http://bugs.openmpt.org/view.php?id=148).
- [Imp] <jh> Use the full available space for the comments text edit control for MPTM and XM files. For IT, limit the displayed width to 75 chars (http://bugs.openmpt.org/view.php?id=148).
- [Fix] <jh> Do not force raster font and character width for the comment font. This results in unintended bad font rendering, especially on Wine (http://bugs.openmpt.org/view.php?id=873).

Tree view
- [New] <js> New shortcut: Switch to instrument library (and back to module), default: Alt+I
- [New] <js> Ctrl+Shift+Enter loads the selected instrument or sample into an unused slot.
- [New] <js> Can now preview samples and instruments using MIDI input as well. Shortcuts bound to MIDI CCs also work here now.
- [Imp] <jh> Add new hidden option Display.FSUpdateInterval (default 500ms) to rate-limit instrument library updates.
- [Imp] <js> If not bound to a shortcut, the Application key opens the context menu (http://bugs.openmpt.org/view.php?id=964).
- [Imp] <js> Show modules with Amiga-style file extensions (i.e. mod.songname, http://bugs.openmpt.org/view.php?id=640).
- [Imp] <js> Refreshing the instrument browser retains the previously selected file / folder.

VST / DMO Plugins
- [New] <js> Add hidden setting "VST Plugins.EnableMidiMappingInEditor" to no longer open the MIDI Mapper when shift-clicking in plugin editors (http://forum.openmpt.org/index.php?topic=5794.0).
- [Imp] <js> The default DMO effects are now also available on Windows Server and Wine without any additional downloads (http://bugs.openmpt.org/view.php?id=862).
- [Fix] <js> Plugins sharing the same filename no longer cause OpenMPT to rescan them on every startup (http://forum.openmpt.org/index.php?topic=5719.0). Note: OpenMPT will have to rescan all plugins once on first launch of this version.
- [Fix] <js> In some situations, the "Plugin has previously crashed" notification could appear on every startup until a new plugin was eventually registered.

VST::Plugin Bridge
- [Imp] <js> Cache effGetTailSize opcode for improved performance.

Playback
- [New] <js> Added the Amiga Resampler, which emulates how the Amiga's soundchip (Paula) works by means of BLEP synthesis. Can be enabled from the Mixer options only for Amiga-type modules (http://bugs.openmpt.org/view.php?id=803).
- [Imp] <js> Increased accuracy of the sample position and sample rate to drift less when playing very long samples.
- [Imp] <js> All built-in DSPs (Bass Extension, Reverb, Surround) are now also available in 64-bit OpenMPT builds. Disclaimer: These DSPs have a rather low quality and should only be used for legacy projects. Plugins should be used instead to improve the sound of your modules.
- [Imp] <js> Rearranging, adding and removing channels no longer stops active NNA channels.
- [Fix] <js> For very high sample rates (starting at 88 kHz), low filter cutoff frequencies resulted in silent filter output.
- [Fix] <js> There were some tiny differences between portamento commands that were supposed to be identical (e.g. FF2 and FE8).
- [Fix] <js> If the order list was longer than 256 items and there was a pattern break effect without a position jump on the last pattern of the sequence, it did not jump to the correct restart order.

MPTM
- [Fix] <jh> It was not possible to read custom tunings written by OpenMPT 1.17.02.46 to 1.17.02.48 since OpenMPT 1.22.

MPTM::Custom Tuning
- [New] <jh> Added Scala .scl export.
- [Imp] <jh> Cleaned up tuning dialog.
- [Imp] <jh> Show cents in addition to ratios in tuning dialog.
- [Imp] <js> Allow decimal point as specified by the system locale to be used for entering tuning ratios.
- [Mod] <jh> Simplified tuning management. All tunings are now tune-specific tunings (i.e. embedded in MPTM files) - built-in, local and sandbox tunings are gone. Used built-in or local tunings are converted into tune-specific tunings during loading and will be written to the MPTM file when saving. The user is notified when this change is applied. Local tunings are loading from the local_tunings.tc file in this case.
- [Fix] <jh> Scala .scl import was broken (http://forum.openmpt.org/index.php?topic=3717.0).
- [Fix] <jh> Support for loading very early tunings (pre-1.17.02.46).
- [Reg] <jh> Local tunings do not exist anymore. Contents of local_tunings.tc are unpacked to individual tuning files on first start.

IT
- [Fix] <js> Having a vibrato command in both the volume and effect column applies vibrato twice. The volume column depth parameter takes precedence if it is not 0.

IT::Compatible Playback Mode
- [Fix] <js> Do not process auto-vibrato at all if the rate (speed) is 0. Previously, the fade-in (sweep) was still applied and audible with vibrato waveforms other than sine.
- [Fix] <js> A lone instrument number should only reset sample properties to those of the corresponding sample in instrument mode.
- [Fix] <js> Reset portamento when using a lone instrument number to retrigger a stopped note.
- [Fix] <js> If the start row of a pattern loop is past the end of the current pattern (e.g. when continued from a previous pattern due to missing SB0 effect), advance to the next pattern (http://bugs.openmpt.org/view.php?id=913).

XM
- [Fix] <js> Having a vibrato command in both the volume and effect column doubles the vibrato speed. The effect column depth parameter takes precedence if it is not 0.

XM::Compatible Playback Mode
- [Fix] <js> A non-delayed note-off for an instrument with no volume envelope enables fade-out, which can be heard when a volume command is applied afterwards.
- [Fix] <js> Separate portamento up and down effect memory.
- [Fix] <js> Just like in IT / S3M, note delays that are on the same row as a pattern delay retrigger the note on every repetition.
- [Fix] <js> Note-Off + Instrument Number + Retrigger did not fade out the note correctly.
- [Fix] <js> Reset envelope key-off status with instrument number.
- [Fix] <js> Properly emulate FT2's broken "ramp down" tremolo waveform (E71).
- [Fix] <js> More accurate emulation of arpeggio limits to "fix" some arpeggios in dubmood's "Mario Airlines".

S3M
- [Fix] <js> A portamento immediately following an arpeggio continues at the last arpeggiated note.
- [Fix] <js> Do not advance tremolo position on first tick.

MOD
- [New] <js> Added support for MOD command E0x (Set LED filter). Only supported when using the Amiga Resampler.
- [Imp] <js> Update heuristic for disabling panning commands to fix constant_romance.mod by chromag.
- [Fix] <js> Base arpeggio on portamento position rather than initial note (http://bugs.openmpt.org/view.php?id=902).

Other formats
- [New] <da & js> Can now read Soundtracker Pro II (STP) modules (http://bugs.openmpt.org/view.php?id=755).
- [New] <js> Can now read Digital Tracker / Digital Home Studio (DTM) modules.
- [New] <js> Support for synthesized instruments in Startrekker modules. Instrument files must have the same name as the module itself, followed by either ".nt" or ".as".
- [Imp] <js> Greatly improved MIDI import. New features include support for user-definable quantization level, XG and GS drum kits, sustain pedal, loop points, channel / master transpose, type 2 (multi-song) MIDI files, and many others (http://bugs.openmpt.org/view.php?id=124).
- [Imp] <js> Allow samples in DMF, GDM and MDL files to not have a default volume (http://bugs.openmpt.org/view.php?id=850).
- [Imp] <js> Tighten heuristics for rejecting invalid 669 files.
- [Mod] <jh> MO3: mpg123 is now shipped with OpenMPT, so unmo3.dll support has been removed. The internal MO3 decoder is always used.
- [Fix] <js> Possible crash with some valid FAR files.

Stream Export
- [New] <jh> Added raw PCM and floating-point export.
- [Imp] <jh> Opus export is now also possible at sample rates that are not native to the Opus codec. They are automatically resampled.
- [Reg] <jh> Removed long-deprecated BladeEnc and Lame_Enc MP3 encoder support. MP3 export via libmp3lame (openmpt-lame.dll, libmp3lame.dll or similar), as well as MP3 export via ACM codecs (lame_acm, Fraunhofer, or others) is still supported.

Module cleanup
- [Imp] <js> Unused channel removal is now more aggressive and removes any channels that contain no notes, no PC events and no global commands (so a channel that contains only Note Cuts or only portamento commands will be removed).
- [Imp] <js> Rearranging patterns no longer clears the pattern undo.

Audio I/O
- [New] <jh> Experimental direct integration with PulseAudio and ALSA when running OpenMPT through Wine (http://forum.openmpt.org/index.php?topic=5792.0).
- [New] <jh> WASAPI's internal resampler can now be used for arbitrary sample rates. WASAPI is now the default sound device on Windows 7 and later.
- [Mod] <jh> For WASAPI devices, use the high latency provided by PortAudio as the default latency. The low one is way too low.
- [Fix] <jh> Importing sound device settings from OpenMPT 1.22 and older was broken.

Misc
- [New] <js> MIDI Export: Added option to not export an instrument at all (available from the MIDI channel dropdown).
- [New] <js> Added hidden setting "Misc.SaveChannelMuteStatus" (default true), which can be used to avoid channel mute status to be saved in S3M, IT and MPTM files (http://forum.openmpt.org/index.php?topic=5736.0).
- [New] <js> Channel Manager: Channels can be renamed by middle-clicking them (applies instantly).
- [New] <js> "Friendly names" can be set for MIDI input / output ports. By adding a "Device Name=Friendly Name" pair to the [MIDI Input Ports] or [MIDI Output Ports] configuration sections respectively, the real device name gets substituted by the user-supplied name in the user interface (http://bugs.openmpt.org/view.php?id=909).
- [New] <js> MIDI Mapping: Support for 14-bit MIDI controllers. Combinations of CC 0...31 and CC 32...63 are now recognized as double-precision MIDI messages (this feature was advertised in OpenMPT 1.25 as experimental but never worked).
- [New] <js> New shortcut for editing global tempo swing settings (http://bugs.openmpt.org/view.php?id=864).
- [Imp] <jh & js> OpenMPT's file handling is now fully unicode-aware (http://bugs.openmpt.org/view.php?id=164).
- [Imp] <jh> Rather than placing them in the executable directory, LAME DLLs can (and should) now be placed in %APPDATA%\OpenMPT\Components\x86\ for 32-bit builds and %APPDATA%\OpenMPT\Components\x64\ for 64-bit builds respectively to avoid problems with VirtualStore and non-privileged Windows user accounts.
- [Imp] <js> Show the progress of stream and MIDI export in the task bar on Windows 7 and later.
- [Imp] <js> Increase waveform limit in DLS / SF2 files from 16383 to 65535.
- [Imp] <js> Added a great number of user-contributed colour schemes.
- [Imp] <js> Main toolbar and instrument editor grid are now updated more frequently when there are tempo changes (http://bugs.openmpt.org/view.php?id=1025).
- [Imp] <jh> Crash Handler: Added command line option /noCrashHandler which disables ALL custom crash handling.
- [Imp] <jh> Crash Handler: Added command line option /DebugCrashHandler for debugging purposes.
- [Mod] <jh> No longer show the system's crash handler after OpenMPT's own crash report. The old behaviour can be restored by enabling the hidden option Debug.DelegateToWindowsHandler.
- [Mod] <js> In keyboard mapping files, layout-independent scan codes are now stored for note keys, so that notes remain in the correct place regardless whether the current keyboard layout is QWERTY, QWERTZ, AZERTY, Dvorak or anything else. The default key maps are now also layout-independent.
- [Mod] <js> Default shortcuts are now only imported into custom key maps if there is no other shortcut assigned to the same command yet.
- [Mod] <js> MIDI Macro Configuration: Remove checkbox for embedding MIDI macros. They are embedded automatically when required.
- [Fix] <js> Modifying channels outside the channel editor (renaming, moving, etc.) did not update the channel manager instantly.
- [Fix] <js> SF2: Sustain level was not imported.
- [Fix] <js> The "Panic" shortcut never worked (tx isdera).
- [Reg] <jh> The minimum system requirements changed. OpenMPT now requires at least Windows XP or Wine 1.6. Older systems (Windows 98 SE, Windows ME, Windows 2000, as well as Wine 1.0 through 1.5) are no longer supported. OpenMPT 1.27 also drops support for some very old CPUs (http://forum.openmpt.org/index.php?topic=5708).

Bundled plugins
- [New] <js> Added the LFO Plugin, which can automate other plugins' parameters or MIDI CCs.
- [New] <js> MIDI Input / Output Plugin: Added possibility to not send timing information (http://bugs.openmpt.org/view.php?id=982).
- [Imp] <js> MIDI Input / Output Plugin: It is now possible to specify a custom output latency. This value can also be negative, up to the duration of OpenMPT's own output latency.
- [Fix] <js> MIDI Input / Output Plugin: Sporadic freezes and crashes (http://bugs.openmpt.org/view.php?id=843).
- [Fix] <js> DigiBooster Pro Echo DSP did not empty its delay lines when jumping around in the module.

Third-Party Libraries
- [Imp] Update opus (v1.2.1), SoundTouch (v2.0), UnRAR (v5.5.8).

Installer/release package
- [New] A new Cyrillic key map provided by Fler0301, a UK keymap resembling the Impulse Tracker shortcuts by chocosaurus, and updated Norwegian keymap by Rakib and US keymap by LPChip.


v1.26.14.00 (14 August 2017, revision 8772)
-------------------------------------------
Pattern tab
- [Fix] <js> Changing the octave of notes below middle-C was broken in OpenMPT 1.26.13.00.
- [Fix] <js> Resizing a pattern did not properly redraw the row numbers in other pattern windows.


v1.26.13.00 (12 August 2017, revision 8759)
-------------------------------------------
Pattern tab
- [New] <jh> Add hidden setting "Pattern Editor.AlwaysDrawWholePatternOnScrollSlow" for graphics drivers with scrolling issues (http://bugs.openmpt.org/view.php?id=1003).
- [Imp] <js> Increasing / decreasing an order list item now skips non-existing patterns.
- [Fix] <js> Crash when trying to change the octave of a note associated with a general tuning (http://bugs.openmpt.org/view.php?id=1004).
- [Fix] <js> Changing the octave did not work as intended with all tuning group sizes.
- [Fix] <js> Amplification now works correctly for plugin-based instruments with a global volume other than 64 (http://bugs.openmpt.org/view.php?id=1002).
- [Fix] <js> Properly erase playback position marker in order list after right-clicking another order item.

Sample tab
- [Fix] <jh> Possible crash when loading too big Vorbis or Opus samples.
- [Fix] <js> Editing various sample properties did not create an undo point.

Instrument tab
- [New] <js> Envelope points can now also be inserted by double-clicking.
- [Imp] <js> Can now use Home / End keys for sample map navigation (http://bugs.openmpt.org/view.php?id=984).
- [Fix] <js> Drag & Dropping a soundfont instrument did not update the sample editor for replaced samples.
- [Fix] <js> Possible crash with some keyboard shortcuts if there was no envelope (tx Jiyoshi).

Tree view
- [Mod] <js> Switching to another module or updating the module's sample volume now updates sample preview volume on every note, not just when previewing a new sample or instrument.

Mod Conversion
- [Fix] <js> Converting to MOD could crash if the first order list item was not a valid pattern (http://bugs.openmpt.org/view.php?id=996).
- [Fix] <js> Removing unsupported patterns (+++ / --- in MOD / XM) did not work as intended at all.

VST / DMO Plugins
- [Fix] <js> Mark module as modified if renaming a preset through the plugin editor was successful.

VST::Plugin Bridge
- [Imp] <js> Speed up filling of parameter lists.

Playback
- [Fix] <js> Loops shorter than four sample points at the end of a sample could cause the sample data before the loop to become corrupted.

MPTM::Custom Tuning
- [Fix] <js> Transpositions in the instrument note map were not applied correctly when the "Use triggered note rather than translated note for PPS and DNA note check" compatibility setting was enabled.
- [Fix] <jh> Saving single tuning .tun files actually resulted in a tuning collection being saved, which prevented the tuning from being loaded unless its file extension was changed to .tc.
- [Fix] <jh> Prevent changing the type of an existing tuning to General.

MOD
- [Fix] <js> The ProTracker note delay quirk should not retrigger already stopped samples (fixes "Subi loses the Cops" by Subi, tx h0ffman).
- [Fix] <js> Portamento between already stopped sample and another sample kept playing the old sample (fixes "anarchy-main" by Jester).
- [Fix] <js> ProTracker quirk: If there is a note with an out-of-range note delay, it is played on the next row (with an instant portamento), unless there is a new note on that row.
- [Fix] <js> ProTracker quirk: Apply tempo changes after the first tick of the row.

Other formats
- [Fix] <js> Possible crashes with malformed PLM and PSM files.


v1.26.12.00 (2 July 2017, revision 8412)
----------------------------------------
General tab
- [Fix] <js> Cloning effect plugins no longer creates an instrument for them (http://bugs.openmpt.org/view.php?id=970).

Pattern tab
- [Imp] <js> Right-clicking outside of the pattern shows a context menu for adding more channels.
- [Fix] <js> It was possible to use (but not save) l / r / u volume commands in MPTM and e / f volume commands in XM (http://bugs.openmpt.org/view.php?id=975).
- [Fix] <js> Most pattern editing functionality in pattern 2 and higher was broken after deleting pattern 1.

Pattern tab::Find/Replace
- [Fix] <js> Replacing with an extended command (Exx / Sxx) overwrote the parameter to be found.
- [Fix] <js> When re-opening the dialog, the replace parameter was not restored correctly for extended commands.

Sample tab
- [Mod] <js> Lifted the sample limit in sample mode from 199 to 255 (http://bugs.openmpt.org/view.php?id=969).

Mod Conversion
- [Imp] <js> When converting note cuts to XM, rewrite them as a v00 command if the effect column is already occupied.

VST::Specific Plugin Fixes
- [Fix] <js> Some resizable plugin GUIs (e.g. Roland D-50) were not resized correctly.

MOD
- [Fix] <js> Use M.K. signature instead of M!K! when writing exactly 64 patterns (http://bugs.openmpt.org/view.php?id=958).

Other formats
- [Imp] <js> PT36: Enable VBlank timing as specified in file and read song comment (http://bugs.openmpt.org/view.php?id=962).
- [Imp] <js> STK: Loosen heuristics to allow a few more semi-damaged files to play.
- [Fix] <js> MT2: If there were instruments with both sample and plugin assignments, sample data was not read correctly.

Module cleanup
- [Fix] <js> Remove Duplicates: Patterns with identical contents but different tempo swing settings were merged.

Third-Party Libraries
- [Imp] Update opus (v1.1.5)


v1.26.11.00 (21 May 2017, revision 8187)
----------------------------------------
Pattern tab
- [Imp] <js> Show a warning when duplicating patterns exceeds the pattern limit of the format.
- [Fix] <js> Channel panning was not always updated from instruments / samples when seeking (tx oerg866).
- [Fix] <js> Out-of-range global volume was not applied correctly in some formats when seeking.

Instrument tab
- [Fix] <js> Convert auto-vibrato sweep when saving XI from MPTM / IT files more accurately.

Tree view
- [Imp] <js> When descending into a directory that contains nothing but one subdirectory, automatically descend further down into that directory.
- [Fix] <js> Deleting patterns was not undo-able.

VST / DMO Plugins
- [Fix] <js> If a plugin's unique ID has changed (e.g. by replacing the plugin DLL with that of another plugin), the old ID was still written to module files.

VST::Specific Plugin Fixes
- [Fix] <js> Crash when trying to use SynthMaster 2.8.
- [Fix] <js> Plugin data of some newer JUCE-based plugins (e.g. latest TAL-Filter-2 version) was not saved correctly inside module files (http://bugs.openmpt.org/view.php?id=946).

Playback
- [Fix] <js> Possible crash when using Duplicate Note Actions with instruments that are associated to plugins (http://bugs.openmpt.org/view.php?id=951).

IT
- [Imp] <js> Properly identify files made with OpenMPT 1.17.02.20-25, CheeseTracker, UNMO3 and some unknown XM conversion tool.
- [Imp] <js> Work-around for reading MIDI macros and plugin settings in some malformed IT files written by old UNMO3 versions.

Installer/release package
- [New] <js> Register OpenMPT as a default application.


v1.26.10.00 (23 April 2017, revision 8041)
------------------------------------------
Pattern tab
- [Fix] <js> "Continue song as soon as MIDI notes are being received" also restarted playback from cursor position if "follow song" was disabled.

Sample tab
- [Imp] <js> Show tooltip explanations for auto-vibrato parameters.

Mod Conversion
- [Imp] <js> Convert auto-vibrato sweep between IT / MPTM and XM more accurately.

Other formats
- [Imp] <js> STM: Add support for "WUZAMOD!" magic bytes and allow some slightly malformed STM files to load which were previously rejected (putup10.stm, putup11.stm) while tightening some other heuristics.
- [Imp] <js> Tighten heuristics for rejecting invalid SoundTracker files.
- [Fix] <js> Detect whether "hidden" patterns in the order list of SoundTracker modules should be taken into account or not. Fixes wolf1.mod, wolf3.mod and jean_baudlot_-_bad_dudes_vs_dragonninja-dragonf.mod.
- [Fix] <js> MO3: Clear MIDI macros for files that were originally saved with Impulse Tracker 1.0 and Scream Tracker prior to version 3.20.

Misc
- [Imp] <jh> About Dialog: Show the real CPU features in addition to the enabled ones.
- [Imp] <js> Use icons with alpha transparency on Wine 1.6 and newer.
- [Fix] <js> Appending a sample-based module to an instrument-based module did not create instruments for the newly added samples.
- [Fix] <js> Merging sequences could sometimes fail when having to duplicate patterns.
- [Fix] <js> Fix icons with broken transparency on some systems.
- [Fix] <js> MIDI Macro Dialog: When viewing controllable plugin parameters, non-existing parameters could show up.
- [Fix] <jh> A bogus warning was shown when launching with /noAssembly command line switch.


v1.26.09.00 (19 March 2017, revision 7821)
------------------------------------------
Pattern tab
- [Fix] <js> Seeking with sample sync did not apply PTM reverse offset effect and the volume slide part of combined volume slide + vibrato commands.
- [Fix] <js> "Copy Orders" shortcut never worked (http://forum.openmpt.org/index.php?topic=5787.0).
- [Fix] <js> Crash when trying to open effect visualizer for a module with no patterns.
- [Fix] <js> When "Loop Pattern" is active, position jump commands no longer jump to the target pattern but restart the current pattern (http://bugs.openmpt.org/view.php?id=15).

Sample tab
- [Fix] <js> 16SV samples created by Fasttracker 2 / Awave were not loaded correctly.

Tree view
- [New] <js> Added "Go to Instrument / Sample directory" context menu entries to file browser to return to the default directories.

Mod Conversion
- [Fix] <js> F20 command was not converted correctly from MOD to S3M / IT / MPTM.

VST / DMO Plugins
- [Fix] <js> Duplicate Note Action checks did not work for instrument plugins with a transposed note map.
- [Fix] <js> Changing to another instrument after an arpeggio did not always stop the last plugin note (http://bugs.openmpt.org/view.php?id=916).

VST::Specific Plugin Fixes
- [Fix] <js> MIDI notes sent by randomid VST by Insert Piz Here were not being received (http://forum.openmpt.org/index.php?topic=5791.0).

XM
- [Imp] <js> Improve detection of some XM files made with ModPlug Tracker that make use of extended filter range.

XM::Compatible Playback Mode
- [Fix] <js> An instrument-less note following a note with an out-of-range offset effect was played at volume 0 (tx eightbitbubsy).

MOD
- [Fix] <js> Sample 15 in "Crew Generation" by Necros was not looped correctly.

Other formats
- [Imp] <da> SFX: Improved import of slide commands (http://bugs.openmpt.org/view.php?id=921).
- [Imp] <js> PLM: Improved import of percentage offset.
- [Fix] <js> Speed up opening of some malformed ITP and truncated AMS files.

Misc
- [Imp] <js> Visually indicate whether playback was stopped or paused by resetting the elapsed time in the status bar to 0:00:00 when stopping.
- [Fix] <jh> Guard against DLL pre-loading attacks when loading dependencies of mpg123 and unmo3 third-party libraries.


v1.26.08.00 (5 February 2017, revision 7557)
--------------------------------------------
General tab
- [Fix] <js> When modifying the number of channels from the pattern editor, the upper part of the General tab was not updated (http://bugs.openmpt.org/view.php?id=903).
- [Fix] <js> Moving, inserting and cloning plugins did not update the tree view completely.

Pattern tab
- [Mod] <js> Do not wrap around the spin wheel for the edit spacing box from 0 to 64.
- [Fix] <js> Correctly center active row when switching to a pattern that has less rows than the previously edited pattern (http://bugs.openmpt.org/view.php?id=899).
- [Fix] <js> Moving channels did not update the channel names in other windows.
- [Fix] <js> The "switch to order list" shortcut also toggled overflow paste.
- [Fix] <js> Quick Channel Settings: Entering a panning value manually did not reset the surround setting visually.
- [Fix] <js> Trying to play a part of a pattern that is not part of the regular play sequence (e.g. rows after a pattern break) caused the pattern to be played from the first row instead.

Sample tab
- [Imp] <js> Add 1:256 and 1:512 zoom factors.
- [Fix] <js> Show the correct PAL sample rate for MOD files when hovering the finetune field.

Tree view
- [Fix] <js> If a soundfont has more than 16 banks, do not cram items of further banks into the first bank's folder.

Mod Conversion
- [Fix] <js> When converting from IT / MPTM / S3M to MOD and vice versa, samples were slightly detuned (MOD plays with PAL middle-C frequency, but was translated using NTSC middle-C frequency).

VST / DMO Plugins
- [Fix] <js> Plugin Editor: Toggling bypass did not live-update the General tab for all plugins but the first (http://bugs.openmpt.org/view.php?id=911).
- [Fix] <js> Completely disable silence detection for VST plugins, as plugins built with old versions of the JUCE framework falsely claim that they support this feature.

Playback
- [Fix] <js> When performing excessive portamento down in IT linear slide mode with legacy period mode enabled or excessive portamento up with Hertz mode, the channel frequency wrapped around since OpenMPT 1.26.01.00 (fixes https://modarchive.org/module.php?175019).

S3M
- [Fix] <js> Increase maximum sample playback frequency for S3Ms saved with Impulse Tracker and Schism Tracker (http://bugs.openmpt.org/view.php?id=898).

Other formats
- [Fix] <js> Possible hangs with malformed files containing cyclic plugin routings.

Misc
- [Fix] <js> Configuring chords with a relative base note was broken since OpenMPT 1.26.01.00.
- [Fix] <js> Tempo Swing dialog: A swing amount of 100% is now displayed correctly on Wine prior to version 2.0.
- [Fix] <js> When switching between multiple windows of a single module, sample and instrument editors are now receiving playback updates instantly.
- [Fix] <js> SF2: Some stereo sample pairs were mismatched.
- [Fix] <js> Running OpenMPT with a relative path to a module file as a parameter did not work as intended.

Bundled plugins
- [Fix] <js> MIDI Input / Output plugin: Identically-named input and output ports could cause the previous plugin state to not be restored properly.

Third-Party Libraries
- [Imp] Update flac (v1.3.2), opus (v1.1.4), PortAudio (v19.6.0), zlib (v1.2.11).


v1.26.07.00 (20 November 2016, revision 7387)
---------------------------------------------
Pattern tab
- [Mod] <js> Remember channel transpose amount also after closing the tab.
- [Mod] <js> When making an order list selection using the keyboard, do not update the play position.
- [Fix] <js> Note Properties: Changing the plugin of a PC event didn't update the parameter list (tx isdera).
- [Fix] <js> Pattern transitions were executed too early if a pattern loop ended on the last row of a pattern.
- [Fix] <js> Dragging a single pattern with "Follow Song" enabled could modify the dragged pattern selection on pattern transitions.
- [Fix] <js> Duplicating patterns did not apply the original pattern's tempo swing settings.
- [Fix] <js> Tempo swing settings were ignored when setting them to 100% for each row for a specific pattern, even if this differed from the global swing settings.
- [Fix] <js> Pasting a partial PC event over a Z80...ZFF effect did not clear the parameter value properly.

Sample tab
- [Fix] <js> Very rare crash when trying to open sample tab.

Instrument tab
- [Imp] <js> Allow a maximum fadeout value of 32767 in MPTM, like in XM.

Tree view
- [New] <js> Add "Open in Explorer" to instrument library directory context menu.
- [New] <js> Insert key can now be used to insert items, Shift-Insert to duplicate them (http://bugs.openmpt.org/view.php?id=529).
- [Fix] <js> Excessive performance drop when modifying a sample or instrument in a module containing hundreds of samples or instruments.

Mod Conversion
- [Imp] <js> Converting an XM instrument with no volume envelope to IT / MPTM now creates an envelope which instantly cuts the sample on key-off.

Playback
- [Fix] <js> Tremolo on quiet notes was broken in OpenMPT 1.26.06.00 (http://bugs.openmpt.org/view.php?id=888).

S3M
- [Fix] <js> Pattern loops ending on the last row of a pattern were not executed properly (http://bugs.openmpt.org/view.php?id=887).

Other formats
- [Fix] <js> MED: Default 8-channel mode tempo should now be imported correctly.
- [Fix] <js> Possible crashes with malformed ITP and MED files.

Module cleanup
- [Fix] <js> Remove Duplicates: Patterns with identical contents but different time signatures were merged.

Misc
- [Fix] <js> Windows key and other special keys were always intercepted since OpenMPT 1.26.01.00 (http://bugs.openmpt.org/view.php?id=886).

Third-Party Libraries
- [Imp] Update UNMO3 (v2.4.1.2).


v1.26.06.00 (22 October 2016, revision 7297)
--------------------------------------------
Pattern tab
- [Fix] <js> Using overflow paste on the last possible order item overflowed into the beginning of the current pattern.
- [Fix] <js> "Change plugin parameter" only worked if the selection started in the first channel (http://forum.openmpt.org/index.php?topic=5729.0).
- [Fix] <js> Pasting partial PC events could result in invalid parameter numbers or values in patterns.
- [Fix] <js> Duplicating several identical order list items could fail if there were more than 256 order items.

Pattern tab::Find/Replace
- [Fix] <js> Searching for a specific Sxy / Exy parameter didn't bring up the correct parameter when repeatedly opening the Find/Replace dialog.

Sample tab
- [Imp] <js> When reading ITI / XI instruments as samples, prefer reading the sample at middle-C rather than the first sample in the file.
- [Fix] <js> Crossfading did not work if a sample only had a sustain loop.
- [Fix] <js> Adding silence at the beginning of the sample only updated the normal loop points, but not the sustain loop points.

Instrument tab
- [Fix] <js> Allow ITI files saved with old Schism Tracker versions to be loaded.
- [Fix] <js> Saving ITI files for instruments referencing sample slots > 255 made such files unneccessarily incompatible with other trackers.

Tree view
- [Fix] <js> Do not cycle through tree items when keeping keys pressed while a playable item is focussed (http://bugs.openmpt.org/view.php?id=872).

Playback
- [Fix] <js> Even when disabling "loop song", songs with 256 order items or more still looped (http://bugs.openmpt.org/view.php?id=878).

IT
- [Fix] <js> Correctly write MIDI program and bank instrument properties in a way that is also read by other IT-compatible applications.

MOD
- [Fix] <js> Avoid enabling some ProTracker quirks for files most likely created with Scream Tracker 3 (fixes BASIC001.MOD, tx Borg-).
- [Fix] <js> Tremolo effect only had half the intended strength.

Other formats
- [Fix] <js> Crashes with malformed files in various formats.

Module cleanup
- [Mod] <js> "Remove unused channels" will no longer remove channels from 4-channel MODs, as a user may typically want such modules to remain ProTracker-compatible (tx eightbitbubsy).
- [Fix] <js> Possible crash when removing unused plugins.

Misc
- [Imp] <js> Channel Manager: Dragging the mouse over buttons now applies the same action to all hovered buttons rather than toggling the action every time the mouse moves a bit.
- [Imp] <js> Channel Manager: Visual improvements, especially in high-DPI mode.
- [Imp] <js> Various buttons (e.g. pattern editor and sample map) look nicer in high-DPI mode.
- [Imp] <js> DLS: Experimental support for "art2" chunk.
- [Fix] <js> DLS: Embedded soundfonts could not be read in some cases.
- [Fix] <js> SF2: Region coarse-tune was not imported at all.
- [Fix] <js> MIDI Macro dialog is now DPI-aware.
- [Fix] <js> The Plugin Manager window could be placed off-screen, effectively locking the entire GUI (http://forum.openmpt.org/index.php?topic=5738.0).


v1.26.05.00 (3 September 2016, revision 7025)
---------------------------------------------
Pattern tab
- [Imp] <js> Show clamped values (or "undefined", depending on the format) for out-of-range channel / global volume parameters in the status bar (http://bugs.openmpt.org/view.php?id=866).
- [Fix] <js> Seeking with sample sync could behave strangely with portamento-ed pingpong-looped samples.
- [Fix] <js> Data Entry also modified the effect column when it was only supposed to affect other columns.
- [Fix] <js> If the same pattern occurred several times in a row, the previous / next patterns were not drawn correctly.
- [Fix] <js> The Parameter Editor window was redrawn more often than necessary (multiple times per row, for every tick - tx mandrasigma).

Pattern tab::Find/Replace
- [Fix] <js> Repeated searches for extended commands (Sxy / Exy) did not remember the correct pattern commands to search for.

Instrument tab
- [Imp] <js> Improved handling of drum patches in Gravis Patch files.

Tree view
- [Fix] <js> Some soundfont items were not previewed correctly.

Mod Conversion
- [Fix] <js> Correctly translate Lxy / Kxy with fine slide parameter when converting from S3M / IT / MPTM to MOD / XM.

VST::Specific Plugin Fixes
- [Fix] <js> Genny Beta uses parameter values outside the nominal 0...1 range, which broke when loading and saving modules using this plugin. The affected parameters can still not be automated properly, though (the same issue exists in other hosts).

VST::Plugin Bridge
- [Fix] <js> Some mouse actions did not work in bridged editors on some systems, in particular with Windows 10 Anniversary Update (http://forum.openmpt.org/index.php?topic=5703.0).
- [Fix] <js> Toggling the plugin editor could lead to a crash if the bridged editor took very long to initialize.

MOD
- [Fix] <js> Restart position was not read correctly if placed in the last two orders (http://bugs.openmpt.org/view.php?id=867).

Other formats
- [Fix] <js> MIDI Import: A channel 10 drum program change could cause melodic channels using the same program number to turn into drums (http://bugs.openmpt.org/view.php?id=462).
- [Fix] <js> Possible crashes with malformed IT, MED, MPTM, PSM and Startrekker files.

Misc
- [Fix] <js> MIDI Export: Timing precision was drifting badly, leading to notes not being properly aligned to the PPQN.
- [Fix] <js> MIDI Export: Since OpenMPT 1.26.01.00, exporting a file with a plugin in the first slot would lead to a crash when closing the file later.
- [Fix] <js> MIDI Export: Pitch bend depth was not always exported correctly.
- [Fix] <js> SF2: Region fine-tune was not imported at all. Soundfonts should now hopefully be finally in tune!
- [Fix] <js> SF2: Some sample loops were not imported correctly.
- [Fix] <js> It may have been possible that auto save also triggered on unsaved files right after they were loaded.

Bundled plugins
- [Fix] <js> Possible crash in the MIDI Input / Output plugin when a MIDI message could not be sent.


v1.26.04.00 (7 August 2016, revision 6772)
------------------------------------------
Pattern tab
- [New] <js> Can now record MIDI Pitch Wheel changes to pattern as MIDI macros (http://forum.openmpt.org/index.php?topic=1615.0).
- [Imp] <js> Redirect keys entered in the instrument column to the note column if they didn't trigger any action (tx coda).
- [Mod] <js> Switch direction of instrument selection buttons (http://bugs.openmpt.org/view.php?id=841).
- [Fix] <js> Note Properties: Parameter for "fine portamento up" command was not displayed correctly in MOD / XM files.

Sample tab
- [New] <js> Can now mix-paste from clipboard.
- [New] <js> Can now Paste (Insert) instead of just Paste (Replace) as well.
- [New] <js> Can now import Sun Audio (AU / SND) samples.
- [New] <js> Can now import 64-bit float, µ-law and A-law WAV and AIFF samples.
- [Imp] <js> Remember previously used resampler across sessions (http://bugs.openmpt.org/view.php?id=830).
- [Imp] <js> If there is no loop yet, allow setting the loop start via context menu (sample end becomes loop end).
- [Fix] <js> Cue points were not written correctly to FLAC files.

Comments tab
- [Imp] <js> Ctrl+A can now be used for selecting all text (http://bugs.openmpt.org/view.php?id=706).

Mod Conversion
- [Imp] <js> When converting restart positions to pattern commands, ensure that the modified pattern is unique, so that other instances of the pattern remain unaffected of the change.
- [Fix] <js> Since OpenMPT 1.26.01.00, converting to IT / S3M converted the restart position to a pattern jump command, but did not actually remove the restart position property.

VST / DMO Plugins
- [New] <js> Can now rename plugin presets by clicking on the preset name in the editor. Not all plugins support this.
- [Fix] <js> OpenMPT 1.26.01.00 introduced a behaviour change when restoring plugin parameters: If less plugin parameters could be restored from the file than the plugin actually has (which could happen when upgrading to a new plugin version), they were no longer ignored completely. The old behaviour is now in place again.

VST::Specific Plugin Fixes
- [Fix] <js> Work around strange crash in Admiral Quality NaiveLPF.

MPTM
- [Fix] <js> Possible crash when loading malformed tunings.

S3M
- [Mod] <js> For old ModPlug-made S3Ms, cut notes early rather than limiting them to the maximum supported frequency (fixes off-key frequency slide in watcha.s3m).

MOD
- [Fix] <js> Sample swapping with portamento didn't work as intended for ProTracker MODs.
- [Fix] <js> More accurate ProTracker arpeggio wrap-around emulation.
- [Fix] <js> ADPCM-compressed samples were broken since OpenMPT 1.26.01.00 (http://bugs.openmpt.org/view.php?id=832).

Other formats
- [Imp] <js> MDL: Vastly improved loader.
- [Fix] <js> 669: Unis 669 pan slide effect was too deep.
- [Fix] <js> DMF: Sample loop lengths were off by one.
- [Fix] <js> DSM: Some pattern commands were not imported correctly.
- [Fix] <js> MT2: Ignore plugin automation data for pre-2.5 files.
- [Fix] <js> PSM16: More accurate sample tuning.
- [Fix] <js> STM: Do not load garbage samples in some files (e.g. acidlamb.stm).
- [Fix] <js> ULT: Only import pattern commands supported by the UltraTracker version that was used to save the file. Add support for command 5-C (end loop).
- [Fix] <js> OpenMPT 1.26.03.00 broke import of many pattern commands in DBM, DMF and ULT files.
- [Fix] <js> Several valid (but slightly corrupted possibly due to disk failures or data transfer errors) SoundTracker files were no longer loading in OpenMPT 1.26.03.00.

Module cleanup
- [New] <js> Added option to remove all unused channels (http://bugs.openmpt.org/view.php?id=835).

Misc
- [Mod] <js> Update check: Operating system version is now transmitted if basic update statistics are allowed. We need this information for planning build configurations of future OpenMPT versions.
- [Fix] <js> Memory leak when loading stereo SF2 instruments.

Third-Party Libraries
- [Imp] Update opus (v1.1.3) and UnRAR (v5.4.4).


v1.26.03.00 (11 July 2016, revision 6609)
-----------------------------------------
General tab
- [Fix] <js> Show scaled Dry / Wet ratio when Expanded Mix is enabled.

Pattern tab
- [Imp] <js> When jumping around in the song, update plugin parameters to their latest value.
- [Imp] <js> Grey out add / duplicate / remove channel context menu entries when the maximum / minimum number of channels is reached (http://bugs.openmpt.org/view.php?id=820).
- [Mod] <js> Right-clicking outside a selection no longer cancels the selection (http://bugs.openmpt.org/view.php?id=823).
- [Fix] <js> Position Jump with Parameter Extension was not interpreted correctly if pattern loop was active (http://bugs.openmpt.org/view.php?id=806).
- [Fix] <js> Clicking very quickly on the order list while it was not fully initialized yet could lead to a crash.
- [Fix] <js> Pasting multiple patterns didn't update the pattern list in the tree view (http://bugs.openmpt.org/view.php?id=811).
- [Fix] <js> After removing commands from patterns, their parameters could still show up in clipboard data.

Pattern tab::Find/Replace
- [Fix] <js> Manually entering hexadecimal parameters did not work (http://bugs.openmpt.org/view.php?id=825).

Sample tab
- [New] <js> Can now use any of OpenMPT's own filters for resampling (http://bugs.openmpt.org/view.php?id=740).

Mod Conversion
- [Imp] <js> Better handling of volume slide and portamento command memory when converting from IT / MPTM / S3M to XM.

VST::Specific Plugin Fixes
- [Fix] <js> VOPM no longer crashes randomly when pressing cancel in OPM import / export dialogs.

VST::Plugin Bridge
- [Mod] <js> Initialize COM for plugins that need it.

MPTM
- [Fix] <jh> Fix possible crash when saving modules with custom tunings after deleting instruments from the tree view.

IT
- [Fix] <js> IT-compatible auto-vibrato jumped very coarsely when being applied to high-pitched notes in non-linear mode.

S3M
- [Imp] <js> Warn when writing too much pattern or sample data when saving S3M files.

MOD
- [Mod] <js> Allow MOD files with 1 to 3 channels to be created.
- [Fix] <js> MOD files with more than 128 patterns were not loaded correctly (e.g. NIETNU.MOD).

Other formats
- [Fix] <js> GDM: Some pattern commands were not imported properly since OpenMPT 1.20.
- [Fix] <js> MDL: Pattern import was broken for all but the first pattern.
- [Fix] <js> MT2: Fix some modules with "modern" tempo interpretation.
- [Fix] <js> MTM: Vibrato depth is approximately half as deep as in MOD.
- [Fix] <js> Tighten SoundTracker heuristics to reject more non-module files (e.g. SNES SPC and MP3 files).

Stream Export
- [Imp] <js> Show which sample / instrument / channel is being exported (http://bugs.openmpt.org/view.php?id=808).
- [Imp] <js> Do not export sampless and instruments that only appear on muted channels in instrument export mode (http://bugs.openmpt.org/view.php?id=808).
- [Fix] <js> Do not export muted samples and instruments in instrument export mode (http://bugs.openmpt.org/view.php?id=808).
- [Fix] <jh> Exported Ogg and Opus streams almost always had the same serial number.

Audio I/O
- [Imp] <jh> Allow setting the priority (XP) or MMCSS class (Vista) used for boosting the sound device thread. The hidden options and defaults are "Sound Settings.BoostedThreadPriority" (2) and "Sound Settings.BoostedThreadMMCSSClass" (Pro Audio) (http://forum.openmpt.org/index.php?topic=5655.0).

Misc
- [New] <jh> Allow setting the process priority class through hidden setting "Misc.ProcessPriorityClass" (default is "normal", http://forum.openmpt.org/index.php?topic=5655.0).
- [Mod] <js> Finally completely deprecate MPT 1.16 mix mode and only show it for legacy modules.
- [Fix] <jh> Some input dialogs were not sized correctly when using the build for old Windows versions (http://bugs.openmpt.org/view.php?id=810).

Third-Party Libraries
- [Imp] Update opusfile (v0.8) and UnRAR (v5.4.2).


v1.26.02.00 (22 May 2016, revision 6410)
----------------------------------------
Audio I/O
- [Fix] <jh> Fix playback on some Wave Out drivers (e.g. in Wine 1.7.46, possibly also fixes http://bugs.openmpt.org/view.php?id=620).

Misc
- [Fix] <js> Song length estimation: Length was reported incorrectly for some modules in modern tempo mode and estimation disturbed real-time playback in songs with per-pattern time signature.
- [Fix] <jh> OpenMPT did not detect Wine reliably in the previous release.


v1.26.01.00 (21 May 2016, revision 6400)
----------------------------------------
General tab
- [Imp] <js> In the plugin "Output To" box, there is now also an option to add a new plugin to which the output should be routed.
- [Imp] <js> Cloning an instrument plugin also creates a new module instrument for it.
- [Mod] <js> When cloning plugins, slightly offset the cloned editor window to not confuse it with the original window.

Pattern tab
- [Imp] <js> Double-clicking an empty order list cell creates a new pattern.
- [Mod] <js> Make Play Row behaviour consistent with cursor movement behaviour if "Continuous Scroll" is disabled: When "Cursor Wrap in Pattern Editor" is disabled, the cursor remains on the last row when reaching the pattern end (http://bugs.openmpt.org/view.php?id=753).
- [Mod] <js> When jumping around during live playback and crossing a pattern border, reset all voices.
- [Mod] <js> To make Data Entry more useful, it is now only applied to the first column type of selection, even if it spans several channels (e.g. if the selection starts in the volume column, only volume will be changed).
- [Fix] <js> Show correct (summed up) parameter for commands augmented with Parameter Extension (#xx) in the status bar.
- [Fix] <js> Note Properties: Pre-select correct item in plugin parameter list if plugin has more than 100 parameters.
- [Fix] <js> Recording automation from plugin parameters in IT/XM modules wrote incorrect Zxx parameters.
- [Fix] <js> With "follow song" enabled, order list multi-selections are no longer modified on pattern transitions.
- [Fix] <js> Redraw issues with right-click drawing in the parameter editor.
- [Fix] <js> Patterns were not drawn at all in OpenMPT 1.25 at 0 rows per measure.

Pattern tab::Find/Replace
- [New] <js> Can now find ranges of data (e.g. notes C-5 to D-6) and replace them also with relative values or percentages (http://bugs.openmpt.org/view.php?id=742).
- [Imp] <js> Can now find and replace all columns of PC events (http://bugs.openmpt.org/view.php?id=44).
- [Imp] <js> Replacing notes by +/-1 octave now works as intended for instruments with custom tunings.

Sample tab
- [New] <jh> Ogg Vorbis and Opus sample loading support.
- [New] <js> New shortcuts: Zoom to sample start (1) / end (2), trim to loop end (Ctrl+Shift+T).
- [Imp] <js> Loop cross-fader now also works with sustain loops.
- [Imp] <js> MP3-compressed WAV samples are now also tried to be decoded using Media Foundation rather than just mpg123.
- [Fix] <js> Sample tuner was broken for XM modules.
- [Fix] <js> Stereo IMA ADPCM WAV samples were not read correctly.
- [Fix] <js> Splitting a stereo sample into two mono samples didn't update the tree view.
- [Fix] <js> When extracting a single sample from an SF2 bank, import the sample name rather than the patch name (http://bugs.openmpt.org/view.php?id=758).

Instrument tab
- [New] <js> Added keyboard shortcuts for selecting loop points and moving envelope points by one beat.
- [Imp] <js> Draw selected loop points in different colour.
- [Imp] <js> Show fade-out length in ticks when hovering its edit field.
- [Imp] <js> When entering a MIDI program > 128, automatically convert it to a program + bank combination.
- [Imp] <js> Show plugin program name when hovering MIDI program / bank input fields.
- [Imp] <js> Update status bar when moving envelope points around using the keyboard.
- [Fix] <js> Preview the correct note when pressing octave keys (tx eightbitbubsy).

Tree view
- [Imp] <js> Speed up display of very long order lists.
- [Fix] <js> When removing a plugin, all other plugins were removed from the tree view as well, despite still being present in the module.

VST / DMO Plugins
- [New] <js> Disable the remove button in the plugin manager for DMO plugins, as it confused several users how to re-add the removed plugins.
- [New] <js> Shift-clicking a plugin editor toggle button closes all other editors (tx coda).
- [New] <js> OpenMPT now reads the VST plugin vendor. Searching for a plugin in the plugin manager also searches in the vendor names.
- [Imp] <js> When opening an instrument plugin editor, check if the currently selected instrument would be suitable input instrument for the plugin, rather than just the first instrument that uses this plugin.
- [Imp] <js> If available (on DirectX 9 and newer), DMO plugins now process in floating-point precision rather than 16-bit PCM.
- [Imp] <js> DMO plugins can now be tagged as well.
- [Mod] <js> Editing integer parameters of DMO plugins should be easier now.
- [Mod] <js> Always send both LSB and MSB of bank select. Otherwise some synths (e.g. Roland XV-5080) ignore it.
- [Fix] <js> Plugin editor position was not restored properly on multi-monitor setups.
- [Fix] <js> Possible drift in precision for DMO plugins that query the current play time.
- [Fix] <js> Only the first VST plugin in a module got informed about transport changes.
- [Fix] <js> Some plugins (e.g. Electri-Q) don't like it when querying the names of non-existent parameters, which could e.g. happen when entering PC events into patterns.
- [Fix] <js> Possible crash in 64-bit version of OpenMPT with any plugin (http://forum.openmpt.org/index.php?topic=5651.0).

VST::Specific Plugin Fixes
- [Fix] <js> Image-Line Sawer does not like MIDI CC 121 and 123, so do not send them when resetting playback (tx mallo).
- [Fix] <js> Superior Drummer did not load its samples until playback starts (http://bugs.openmpt.org/view.php?id=750).

Playback
- [Mod] <js> Instead of having one "compatible playback" per file, every playback quirk now has its own flag. This includes a dialog to edit these flags. These flags should not be edited manually, except for the "Set Defaults" functionality.
- [Mod] <js> For old files made with MPT / OpenMPT before v1.24, sample rates are now computed in periods again in linear slide mode. This fixes for example the drum line sample in Zanoma's "Late At Night". Similarly, old OpenMPT-made files that use portamento at speed 1 now sound as in OpenMPT 1.17 - 1.20 again.
- [Fix] <js> Volume column offset + retrigger effect combination was broken for looped samples and could lead to crashes.
- [Fix] <js> Playing a sample at a sample rate close to the mix rate could lead to small clicks when using vibrato.
- [Fix] <js> If no instrument number was provided, New Note Action with empty sample slot and Duplicate Note Action sample checks were broken.
- [Fix] <js> Do not apply offset command next to a note mapped to a non-existing sample slot in instrument mode.
- [Fix] <jh> Bass Expansion DSP was not applied to rear channels (broken since the dawn of time).
- [Fix] <js> Possible crash with excessive portamento down in some formats.

MPTM
- [New] <js> Each sequence now has its own restart position.
- [New] <js> Parameter Extension (#xx) now also works with Position Jump command (http://bugs.openmpt.org/view.php?id=789).
- [Imp] <js> Warn when trying to save too large IT / MPTM files.
- [Mod] <js> Samples are now compressed by default (lossless IT compression).
- [Fix] <js> Extra fine portamento didn't work properly with custom tunings. EEx / FEx now changes the pitch by x finetune steps on the first tick (http://bugs.openmpt.org/view.php?id=731).

IT
- [Fix] <js> Even after fixing it in OpenMPT 1.18, instrument Pitch/Pan Separation was only half as deep as it should be.
- [Fix] <js> Portamento with no active note still applied the portamento effect if the previous note just stopped playing on the previous tick.

IT::Compatible Playback Mode
- [Fix] <js> Default volume of the instrument is recalled if an instrument number is next to a note-off.
- [Fix] <js> Resuming sample playback using a note without instrument number after a note cut was broken.
- [Fix] <js> Remember new instrument number for next instrument-less note even when sample playback is stopped.
- [Fix] <js> A note-less instrument number next to an out-of-range note delay resulted in playing the new sample but using the old sample's length, leading to possible crashes (re-fixes player abuse test 08, got severely broken in OpenMPT 1.23).
- [Fix] <js> Only applies global volume on (multiples of) the first tick (re-fixes player abuse test 16, broke in OpenMPT 1.19).

XM
- [Fix] <js> Some probably hex-edited XM files (e.g. cybernostra weekend.xm) were not loaded correctly.
- [Fix] <js> MadTracker 2 plays portamento-ed notes even if previously no note was playing. Disable this FT2 compatibility fix for XMs made with MadTracker (fixes m3_cha.xm).
- [Fix] <js> Skale Tracker plays notes with out-of-range offset commands. Disable this FT2 compatibility fix for XMs made with Skale Tracker.

XM::Compatible Playback Mode
- [Fix] <js> Portamento with no active note still played the new note if the previous note just stopped playing on the previous tick (fixes u-k3symb.xm).

S3M
- [New] <js> Added support for old vibrato style which cannot be enabled in the Scream Tracker UI and is probably not used by any modules anyway.
- [Fix] <js> Pattern loop start resets on pattern transitions (http://bugs.openmpt.org/view.php?id=757).
- [Fix] <js> Do not distinguish between vibrato types in effect memory, so that e.g. U1F followed by H00 causes the second effect to play a H1F vibrato. Effectively, this also means that Kxx will never play a fine vibrato (tx eightbitbubsy).

MOD
- [New] <da & js> Support for ProTracker 3.6 IFF-style modules (http://bugs.openmpt.org/view.php?id=752)
- [Fix] <js> ProTracker does not validate the sample loop length, which can lead to detuned chip samples if the loop length is longer than the actual sample (fixes MOD.shorttune2).
- [Fix] <da & js> Try to detect NoiseTracker files disguising as ProTracker MODs and fix Dxx pattern commands for such files (http://bugs.openmpt.org/view.php?id=749, fixes 1.11song2.mod and 2-3song6.mod).
- [Fix] <da & js> Properly import finetune of His Master's Noise Tracker modules (fixes abridge.mod, questioff.mod and others, http://bugs.openmpt.org/view.php?id=749)
- [Fix] <js> Some trimmed MOD files were not loaded correctly (fixes quartex.mod).
- [Fix] <js> Infinite pattern loops were not handled properly.
- [Fix] <js> With Amiga limits enabled, do not go below period 113, independent of finetune setting.

Other formats
- [New] <da & js> Can now read SoundFX / MultiMedia Sound (SFX / MMS) modules (http://bugs.openmpt.org/view.php?id=741).
- [New] <js> DBM: Added support for echo DSP.
- [New] <js & jh> Added built-in MO3 support that does not rely on the closed-source UNMO3.
- [Imp] <js> MT2: Support for the full dynamic range of drum channels.
- [Imp] <js> MT2: Try to apply track routing by copying plugin chains.
- [Imp] <js> MT2: Import more pattern commands.
- [Fix] <js> MT2: Plugin parameters were not restored correctly.
- [Fix] <js> MT2: Do not reset instrument fade value if NNA is set to Note Fade (fixes driven.mt2 by Screes)
- [Fix] <js> MT2: Some sample to instrument associations were missing (fixes Dream Alone by Sonic)
- [Fix] <da & js> Various Ultimate SoundTracker heuristic fixes (http://bugs.openmpt.org/view.php?id=751).
- [Fix] <js> MDL: The tail of compressed samples was slightly off in OpenMPT 1.25.
- [Fix] <js> J2B: Properly import non-existing patterns.
- [Fix] <js> Files with lots of NUL bytes at the start are no longer falsely detected as Ultimate SoundTracker modules.
- [Fix] <js> Possible crashes with malformed AMF, AMS, DBM, IT, MDL, MED, MPTM, MT2, PSM and MMCMP-, XPK- and PP20-compressed files.

Module cleanup
- [New] <js> Add option to merge identical patterns (http://bugs.openmpt.org/view.php?id=738).
- [Fix] <js> Detecting unused samples in instrument mode will now get slightly less confused about instrument-less notes.

Stream Export
- [Imp] <jh> Ogg Vorbis and Opus support is now built-in and no longer requires an external library.
- [Imp] <jh> Add a new "MP3 (compatible)" export file type that is implemented only via libmp3lame and is the same as the old libmp3lame CBR mode with strictly ID3v1 tags only.
- [Imp] <jh> Switch libmp3lame non-compatible MP3 export from CBR to ABR mode since ABR gives better quality.
- [Imp] <js> Temporary export files are now marked as temporary in the file system to avoid writing them to disk if possible.
- [Mod] <jh> Relax Lame CBR mode restrictions: Allow bit reservoir, do not enforce ISO padding and bit reservoir restrictions, write out lame info tag, always use ID3v2.
- [Fix] <jh> Render to Sample slot failed when exporting quad surround. As quad surround samples cannot be loaded yet, the channel count selection is now limited to mono or stereo for Render to Sample.
- [Reg] <jh> Only show a single MP3 encoder. If libmp3lame is available, it is by far the best option. If the user provided a BladeEnc.dll, they almost certainly want it preferred to any ACM encoder. Selecting a different encoder is still possible by disabling the components of higher priority encoders.
- [Reg] <jh> Remove hidden setting Export.MP3LameAllowID3v2inCBR (now always true for "MP3 / CBR" and always false for "MP3 (compatible) / CBR").

Misc
- [New] <js> Added hidden setting Misc.DistinguishModifiers to distinguish between left and right modifiers (e.g. to create FT2-like play pattern shortcuts).
- [New] <js> Update check: Add possibility to ignore automatic notifications for a specific OpenMPT version.
- [New] <jh> Added command line switch /noWine which disables any Wine-specific code when running OpenMPT in Wine. Only use when instructed to do so by the OpenMPT developers.
- [Imp] <js> SF2: Try to load instruments with left and right layer as stereo samples.
- [Imp] <js> Add browse item in example song and template module menus (http://bugs.openmpt.org/view.php?id=220).
- [Mod] <js> When saving a module file, do not change its extension. Prompt for a new filename when saving a file loaded from an import-only format (http://bugs.openmpt.org/view.php?id=762).
- [Mod] <js> Update check: Use HTTPS by default. On Windows XP and older, always fall back to HTTP as TLS 1.0 is disabled by default on these systems.
- [Fix] <js> MIDI Export: Note cuts were exported incorrectly and bloated the MIDI size (http://bugs.openmpt.org/view.php?id=746).
- [Fix] <js> SF2: Many soundfont samples were completely detuned since OpenMPT 1.20.
- [Fix] <js> Sometimes a wrong MIDI input device was remembered (http://bugs.openmpt.org/view.php?id=756).
- [Fix] <js> Creating / loading a looped 16-bit stereo sample shorter than 4 samples could lead to a crash.
- [Reg] <jh> The bandwidth of the polyphase 8-tap resampling filter is no longer configurable and fixed at the previous default of 97% now. The setting only affected the upsampling part of the filter and not the downsampling part, which was rather unintuitive. The bandwidth stays configurable for the XMMS-ModPlug filter.

Bundled plugins
- [New] <js> DigiBooster Pro Echo DSP is now a built-in plugin that can also be used in module types other than DBM.
- [New] <js> The MIDI Input / Output plugin now sends MIDI Clock events.
- [Mod] <js> The MIDI Input / Output plugin is now built right into OpenMPT and no longer shipped as a separate DLL file.
- [Fix] <js> SysEx messages received from a MIDI device are now handled properly by the MIDI Input / Output plugin.

Third-Party Libraries
- [Imp] Update lhasa (v0.3.1), UNMO3 (v2.4.1) and UnRAR (v5.3.11).

Installer/release package
- [Fix] <js> Note Off shortcut was missing in US_mpt-ft2_classic.mkb / US_mpt-it2_classic.mkb keymaps (tx Garian).
- [Mod] <js> Added FT2-like "play pattern from start" / "play song from pattern start" shortcuts to US_mpt-ft2_classic.mkb.


v1.25.04.00 (21 November 2015, revision 5785)
---------------------------------------------
General tab
- [Fix] <js> Plugin gain control was not accessible to some screen readers (http://bugs.openmpt.org/view.php?id=337).

Pattern tab
- [New] <js> Allow to skip forward / backward with navigation keyboard shortcuts and scroll wheel during playback if "follow song" is enabled.
- [Fix] <js> Recording MIDI CCs from MIDI was broken in MPTM files since OpenMPT 1.25.01.00.

VST::Plugin Bridge
- [Fix] <js> Opening the MIDI Mapping Dialog from a bridged plugin GUI could freeze the tracker.

IT/MPTM
- [Fix] <js> Global time signature values exceeding 255 rows were not loaded (but saved) correctly.

XM::Loading
- [Fix] <js> If the order list is empty, fill it with pattern 0 instead (fixes lamb_-_dark_lighthouse.xm).

MOD::Loading
- [New] <js> Support CD61 (6-channel Octalyser), FA04-FA08 (Digital Tracker), NSMS and LARD (unknown 4-channel, probably hex-edited) magic bytes in MOD files.
- [Imp] <js> Relaxed format detection heuristics for SoundTracker modules to allow more (broken) files to be loaded.

Other formats
- [Fix] <js> 669: More thorough file validation to reject files that vaguely resemble 669 files. MOD files with a song title starting with the letters "if" or "JN" had a high chance of being mis-identified as 669 modules.
- [Fix] <js> AMF: Some malformed files could result in very long loading times.
- [Fix] <js> IMF, MT2: Possible crash with some malformed files.
- [Fix] <js> MTM: Files generated by UNMO3 were not loaded properly. Generally improved playback compatibility.

Stream Export
- [Fix] <jh> ID3v2.4 tags were malformed in OpenMPT 1.25.03.00, leading to the first audio frame being skipped when playing the MP3 file (http://bugs.openmpt.org/view.php?id=725).

Misc
- [Fix] <js> MIDI Mapping Dialog: MIDI Learn did not work when opening the dialog from a plugin editor (http://forum.openmpt.org/index.php?topic=5550.0).
- [Fix] <js> Using key bindings in paths longer than 260 characters should now work properly.
- [Fix] <js> Disabling "Repeat notes on hold" for all notes at once was broken.


v1.25.03.00 (31 October 2015, revision 5703)
--------------------------------------------
Pattern tab
- [New] <js> Added hidden setting "Pattern Editor.EditStepAppliesToCommands" to also apply edit step to command letters (tx uctumi).
- [Imp] <js> Support effect-column volume slides when using sample sync.
- [Imp] <js> Forward / backward mouse buttons can be used to switch to next / previous order.
- [Fix] <js> Go To Dialog was not filled with sensible default values since OpenMPT 1.25.01.00.

Sample tab
- [Imp] <js> Pre-select the input field in the sample resize dialog (http://bugs.openmpt.org/view.php?id=705).
- [Imp] <js> Silence tool now works the same way for stereo samples as it does for mono samples.
- [Imp] <js> Time Stretch and Pitch Shift are now abortable.
- [Imp] <js> When trying to load a module into a sample slot, open it directly in the tree view for importing samples.
- [Imp] <js> Forward / backward mouse buttons can be used to switch to next / previous sample.
- [Mod] <js> When loading several samples, only ask once if they should be associated with an instrument (http://bugs.openmpt.org/view.php?id=340).
- [Fix] <js> Properly update all sample lists when slicing a sample.
- [Fix] <js> Resampling a sample with a very high sample rate (> 1 MHz) crashed the program.

Instrument tab
- [New] <js> Option in sample map context menu to remove all sample associations.
- [Imp] <js> Added keyboard shortcut for scaling envelopes (default: Ctrl+E).
- [Imp] <js> Ctrl+Right-click can now also be used to delete an envelope point.
- [Imp] <js> Nicer envelope drawing at higher zoom levels. Adjust default zoom level for High-DPI screens.
- [Imp] <js> After grabbing a sustain or loop point with the mouse, it can now also be moved using the keyboard shortcuts for moving nodes.
- [Imp] <js> Show sample numbers in Sample Map editor (http://forum.openmpt.org/index.php?msg=15678).
- [Imp] <js> When trying to load a module into an instrument slot, open it directly in the tree view for importing instruments.
- [Imp] <js> Forward / backward mouse buttons can be used to switch to next / previous instrument.
- [Fix] <js> Previewing several notes at once was broken for XM modules.
- [Fix] <js> Bogus keys were added for some envelope editor shortcuts.

VST / DMO Plugins
- [New] <js> Allow the user to enter plugin-specific tags in the plugin selection dialog. The name filter now searches for both plugin names and tags (patch partially provided by arseniiv, http://bugs.openmpt.org/view.php?id=541).
- [Imp] <js> When loading a module, indicate which plugin is being loaded in the status bar (http://forum.openmpt.org/index.php?topic=1693.0).
- [Fix] <js> Plugin editor minimizing should now also work with Wine. As a consequence, minimizing now only works through double-clicking, there are no minimize / maximize buttons any more.
- [Fix] <js> No longer apply auto-suspend logic to plugins that don't output any audio, as they can never fulfil it.

VST::Specific Plugin Fixes
- [Fix] <js> When closing Electri-Q's editor while it was minimized and having its resizeable GUI enabled, the GUI would no longer work on any host as it stored a bogus default window size.

VST::Plugin Bridge
- [Imp] <js> Implement audioMasterOpenFileSelector opcode for opening load / save file dialogs from some plugin GUIs (e.g. VOPM; http://bugs.openmpt.org/view.php?id=539).
- [Imp] <js> Speed up preset and parameter name retrieval (e.g. in plugin editor preset menu).
- [Mod] <js> Optimized audioMasterGetTime opcode caching.

MPTM::Custom Tuning
- [Fix] <js> Pitch effects (portamento, arpeggio) triggered after a note-off were broken since OpenMPT 1.22.

MOD
- [Mod] <js> As the majority of trackers including ProTracker seem to interpret F20 as tempo rather than speed, OpenMPT now does the same. The only other programs I could find that treat F20 as speed are Scream Tracker 3 and Impulse Tracker.
- [Fix] <js> Invert Loop position was not reset with instrument numbers.
- [Fix] <js> Offset beyond sample loop end was broken.

MOD::ProTracker 1/2 Mode
- [Fix] <js> Very short sample loops starting at the first sample point were detuned.

Other formats
- [Imp] <js> Better handling of tempos > 255 in MED.
- [Mod] <js> ITP: For the rare case that an ITP file loaded a 24-bit or higher quality WAV sample as an instrument, always enable the auto-normalize feature for those samples, as this was the default and fixed setting for loading such samples during most of the time when the ITP format was actively supported.
- [Fix] <js> MT2: Better handling of filters and synchronized samples.
- [Fix] <js> Crash in MED loader.

Stream Export
- [Imp] <jh> Write ReplayGain tags when exporting VBR MP3 using libmp3lame (http://bugs.openmpt.org/view.php?id=712). Can be disabled using "Export.MP3LameCalculateReplayGain", "Export.MP3LameCalculatePeakSample" and "Export.MP3ID3v2WriteReplayGainTXXX" settings.
- [Imp] <jh> ID3v2 padding size is now configurable via hidden settings "Export.MP3ID3v2MinPadding" and "Export.MP3ID3v2PaddingAlignHint".
- [Imp] <jh> Use ID3v2.4 tags also when exporting VBR MP3 using libmp3lame. Toggle hidden setting "Export.MP3LameID3v2UseLame" to revert to ID3v2.3 tags.

Misc
- [New] <js> Allow to change between sharp and flat accidentals in Display settings.
- [New] <js> Added hidden settings "Display.HighResUI", which can be used to enable DPI-awareness in OpenMPT. Right now it is disabled by default because there are no high-DPI icons yet. In the future, people may want to keep this setting disabled when using plugin UIs that are not DPI-aware.
- [Fix] <js> Do not process keyboard commands while export dialogs are active (http://bugs.openmpt.org/view.php?id=704).
- [Fix] <js> Crash in 64-bit builds when trying to append a module.
- [Fix] <js> After changing the default rows per beat, the new value was not used in tempo approximation for classic and alternative tempo mode if the song was not currently playing.
- [Fix] <js> Some menu items were not greyed out when they should have been (http://bugs.openmpt.org/view.php?id=710).
- [Fix] <jh> Fix resource exhaustion on Wine when invoking any popup windows via a keyboard hotkey (http://bugs.openmpt.org/view.php?id=713).
- [Reg] <js> Remove hidden setting "Misc.ShowHackControls". All it did was showing an input field for changing the sequence margins, which can already be controlled through a different setting "Pattern Editor.DefaultSequenceMargins".

Third-Party Libraries
- [Imp] Update PortAudio (SVN r1963) and SoundTouch (v1.9.2).


v1.25.02.00 (13 September 2015, revision 5600)
----------------------------------------------
General tab
- [Fix] <js> Cloning plugins failed to copy the patch data in 32-bit legacy builds (and regular 32-bit builds before OpenMPT 1.25).

Pattern tab
- [Imp] <js> Update vibrato effect memory when seeking.
- [Fix] <js> Undoing pattern size changes didn't update the scrollbar size (http://bugs.openmpt.org/view.php?id=702).
- [Fix] <js> Possible crash when resizing pattern during playback with smooth pattern scrolling enabled.
- [Fix] <js> In smooth scroll mode, the dragging rectangle sometimes had the wrong colours.

Sample tab
- [New] <js> Can now slice samples at their cue points into several separate samples.
- [Imp] <js> Add support for Vorbis comments LOOPSTART and LOOPLENGTH in FLAC files to specify loop points (some audio engines seem to use this).
- [Fix] <js> Writing FLAC samples with a sample rate above 65535 Hz that was not a multiple of 10 Hz, or any sample rate above 655350 Hz failed. Note for software developers: Since FLAC sample rates are capped at 655350 Hz, OpenMPT now writes the real sample rate in a Vorbis comment called SAMPLERATE if it exceeds this limit. Feel free to add support for this tag in your software.

Instrument tab
- [Imp] <js> Also show the currently playing note in the status bar for notes received via MIDI (tx Xemogasa)
- [Fix] <js> Possible crash when recording MIDI while there was no instrument yet (tx Xemogasa).

Tree view
- [New] <js> Allow folders to be shown in lower part of sample browser through a right-click option.

VST / DMO Plugins
- [Fix] <js> Loading FXBs with parameter sets instead of chunks was broken.
- [Fix] <js> Update plugin name and slot number in editor window when renaming or moving a plugin.
- [Reg] <js> Disable the plugin window minimize feature on Wine, as it does not work as intended.

Playback
- [Fix] <js> Pitch envelopes were upside down in non-linear slides mode since OpenMPT 1.24.01.00.
- [Fix] <js> Avoid VSTi notes to stack up in XM files due to missing NNA handling (no, you should still not use VSTis in XM).

IT::Loading
- [Fix] Patterns containing command-less parameter values (which can be entered in some IT-compatible trackers) were imported incorrectly (fixes ckbounce.it).

MOD::ProTracker 1/2 Mode
- [Fix] <js> ProTracker offset quirks were partly broken since OpenMPT 1.24.04.00 (fixes professionaltracker.mod)

MOD::Loading
- [Imp] <js> If there are two Fxx commands on the same row and one can be interpreted as Set Speed and the other as Set Tempo, always treat the module to have CIA timing instead of VBlank timing.

Other formats
- [Imp] <js> MIDI export has been considerably improved. More commands are exported and it uses one MIDI track per instrument rather than one per pattern channel (http://bugs.openmpt.org/view.php?id=535).
- [Fix] <js> OKT: Portamento up and down were swapped.
- [Fix] <js> Possible crashes and hangs with malformed DMF, PLM, IMF, IT and MPTM files.

Audio I/O
- [Imp] <jh> Detect Wave Out errors during playback, display the detailed error code and message to the user, and try to gracefully shut down the device.
- [Fix] <jh> Fix stalled UI after longer playback with Wave Out devices, especially on Windows XP.

Misc
- [Imp] <js> Add Pitch Bend messages to MIDI macro generator.
- [Imp] <js> Add Zxx Macro Configuration dialog to the View menu and make its shortcut global.
- [Fix] <js> Song length estimation: Pattern breaks in a pattern followed by a --- pattern were sometimes calculated incorrectly in OpenMPT 1.25.01.00.
- [Fix] <js> There was an excessive performance drop on some GUI parts in the previous version.


v1.25.01.00 (16 August 2015, revision 5484)
-------------------------------------------
General tab
- [New] <js> Module artist can now be specified.
- [New] <js> Modules can now override the globally configured resampling mode. This setting is only saved in MPTM files, but can also be changed in other formats to quickly change a single module's resampling mode.
- [Mod] <js> Removed player settings button, as the most common (and only?) use case - changing the resampling mode - can now be achieved directly from this tab.
- [Mod] <js> In IT files, the default tempo can no longer exceed 255.
- [Fix] <js> The dB values shown in tooltips were wrong.
- [Fix] <js> When modifying default channel volume or panning using the sliders, default values were reset for all other channels on the same page (tx Xemogasa).

Pattern tab
- [New] <js> In the order list, it is now also possible to just copy the order list pattern numbers instead of their content ("Copy Orders" in context menu or Ctrl+Shift+C by default).
- [New] <js> Added option for smooth (tick-by-tick) pattern scrolling.
- [New] <js> Added hidden setting "Pattern Editor.NoEditPopup", which disables the "editing is disabled" popup and allows note previewing (keyjazz) in all pattern editor columns while editing is disabled.
- [Imp] <js> Apply DNA and NNA settings to live note preview. Entering Note Cut / Off / Fade also instantly previews its effect.
- [Imp] <js> Effect visualizer window size is now remembered across sessions.
- [Mod] <js> Reset beat highlight together with measure highlight (http://bugs.openmpt.org/view.php?id=662)
- [Fix] <js> When deleting orders, the pattern view did not switch to the newly selected order afterwards (tx coda).
- [Fix] <js> Effect visualizer could still not show up properly in some cases (http://forum.openmpt.org/index.php?topic=5476.0).
- [Fix] <js> Make note and data entry shortcuts always operate on octaves instead of +/- 12 notes when using custom tunings (http://bugs.openmpt.org/view.php?id=681).
- [Fix] <js> Show correct note name in status bar for custom tuning notes.
- [Fix] <js> Sample seeking didn't work properly on channels where the last note event was a note-off and didn't apply pitch envelopes.
- [Fix] <js> Panning commands were still applied when seeking even if ProTracker 1/2 mode was enabled.
- [Fix] <js> Playing patterns not present in the order list was broken since OpenMPT 1.24.03.00 (http://forum.openmpt.org/index.php?topic=5495.0).
- [Fix] <js> Jumping to a pattern through the order list would still execute the last row of the previous pattern in some cases since OpenMPT 1.24.03.00.
- [Fix] <js> Fix inconsistencies in the previous / next pattern displays when jumping around in the order list.
- [Fix] <js> Duplicating and inserting patterns didn't update the tree view properly.

Sample tab
- [New] <jh> Add Media Foundation (AAC, WMA, ASF, MP1, MP2, MP3, WAV-MSADPCM, ...) sample decoding support on Windows 7 and later (http://bugs.openmpt.org/view.php?id=422).
- [New] <jh> Support loading OggFlac sample files.
- [Imp] <js> Added dropdown menu to New button for duplicating samples.
- [Imp] <jh> Add a dropdown menu to the Open button which allows explicitly importing only known sample formats or only raw samples. This allows importing known formats as raw samples as well as allows avoiding the possibility of raw samples getting mis-interpreted as some known format.
- [Imp] <js> Don't reset sample draw status when modifying a sample.
- [Imp] <js> Show dB values for volume and percentage for panning in tooltip.
- [Fix] <js> Time stretch ratio calculator was always based on the current tempo, not on the user-supplied tempo.

Instrument tab
- [Imp] <js> Added dropdown menu to New button for duplicating instruments.
- [Imp] <js> Pitch/Pan Separation note list uses tuning note names.
- [Imp] <js> Show dB values for volume and percentage for panning in tooltip.

Tree view
- [Mod] <js> Sample / instrument preview is now stopped using Note Cut / Off / Fade keys instead of automatically fading out after some seconds.
- [Fix] <js> Dropping files made the tree view inaccessible until a new drag & drop action was initiated (tx coda).
- [Fix] <js> Previewing UAX samples played them at the wrong frequency.

VST / DMO Plugins
- [New] <js> Instrument random variation is now applied to the velocity of notes sent to instrument plugins.
- [New] <js> Tremor (Ixx) is now also supported for instrument plugins (http://forum.openmpt.org/index.php?topic=2736.0).
- [New] <js> Added hidden setting "VST Plugins.EnableAutoSuspend" which activates plugin auto-suspension for all plugins (later, this will be configurable per plugin). If a plugin didn't emit any sound during the last four seconds, its sound output is automatically suspended.
- [New] <js> It is now possible to override the project path reported to plugins (some plugins can store data alongside the module file) by using the hidden setting "VST Plugins.ProjectPath". In the setting value, %1 is replaced by the module path and %2 by the module filename (tx zetaPRIME).
- [Imp] <js> Automatically create instruments for newly added instrument plugins (http://forum.openmpt.org/index.php?topic=2867.0).
- [Imp] <js> Indicate bitness of non-native plugins in the plugin selection dialog.
- [Imp] <js> The default plugin editor is now DPI-aware.
- [Imp] <js> Allow sending incoming MIDI notes to plugins even if no instrument is assigned to them (pass data as-is).
- [Imp] <js> Loading and restoring missing plugins now also works when adding them through the Scan Folder button.
- [Fix] <js> Some VST plugins (e.g. SmartElectronix Ambience) write directly to the memory chunk that is passed to them when loading preset files. This memory block was not writeable since OpenMPT 1.22 and thus caused a crash.
- [Fix] <js> In OpenMPT 1.24, no more than one missing plugin was reported after loading a module.

VST::Specific Plugin Fixes
- [Fix] <js> HERCs Abakos stopped working in OpenMPT 1.22.02.00.

VST::Plugin Bridge
- [Imp] <js> Added support for audioMasterGetChunkFile opcode.
- [Fix] <js> MIDI events sent to 64-bit plugins or 64-bit OpenMPT were garbled.
- [Fix] <js> A couple of plugins whose editor previously froze (e.g. 4klang) will now work fine.
- [Fix] <js> KORG M1 crashed if the editor of more than one shared instance was opened (http://bugs.openmpt.org/view.php?id=683).

Playback
- [Imp] <js> Improve NNA channel allocation by also taking volume envelopes into account: If all NNA channels are used and are playing at full note volume, but are effectively muted due to their volume envelope, they can now be reused.
- [Fix] <js> Crash when playing extremely high-pitched samples.

MPTM
- [New] <js> Support for decimal default tempo (e.g. 123.45 BPM). Note that it is not possible to set decimal tempos using pattern commands yet (http://bugs.openmpt.org/view.php?id=145).
- [New] <js> Support for decimal tempo for instruments' pitch/tempo lock.
- [New] <js> In modern tempo mode, a swing factor can be configured which determines how much every row of a beat contributes to the beat (globally in the Song Properties and per pattern in the Pattern Properties). Unlike manual tempo changes, this will not mess up the timing information sent to plugins (http://bugs.openmpt.org/view.php?id=506).
- [Mod] <js> Newly created MPTM files use modern tempo mode and extended filter range.
- [Fix] <js> Fix potential misreading of some global song settings (was very unlikely to happen).

MPTM::Custom Tuning
- [New] <js> 'd' and '+' can now be used in note names.
- [Mod] <js> Behaviour change: When executing tone portamento and the sample doesn't change between the notes, re-apply the sample settings such as default volume and panning like with normal samples.
- [Fix] <js> Editing a tuning's note name no longer requires to remove the octave number first.

IT::Compatible Playback Mode
- [Fix] <js> Position jump effect on the same row as a pattern loop end immediately cuts the pattern loop.

XM
- [Imp] <js> Detect files made with MilkyTracker 0.90.87 or later and enable FT2 pan law for them.

S3M
- [Fix] <js> In S3M files not made with OpenMPT or Scream Tracker, support portamento between different samples again like in old versions of ModPlug Tracker (fixes k_vision.s3m, made in IT).

MOD
- [Mod] <js> Heuristically enable ProTracker 1/2 mode if 8xx commands seem likely to be used as sync markers rather than panning in 4-channel MODs.
- [Mod] <js> Treat EXO8 modules to have paired patterns like FLT8 modules.
- [Fix] <js> As in XM and IT, don't reset pattern loop counter on pattern breaks.

Other formats
- [Fix] <js> MT2: Don't load samples for instruments which already have a VST instrument assigned.
- [Fix] <js> Fixed crashes with malformed MED and MDL files and hangs with some truncated compressed IT samples.

Stream Export
- [New] <js> It is now possible to export to a sample slot rather than a file (http://bugs.openmpt.org/view.php?id=561).

Audio I/O
- [Mod] <jh> Add Debug.StopSoundDeviceBeforeDump (default false) setting and change the default behaviour to stop the audio device after dumping the crash information. This helps debugging crashes inside the audio thread with the default settings.
- [Mod] <jh> Remove "Sound Settings.Enable*" hidden settings. Allow switching off individual sound device backends via "Components.Block*" instead.
- [Fix] <jh> PortAudio latency calculation was wrong for WASAPI exclusive mode devices.
- [Fix] <jh> WaveRT devices are now shown as such (instead of WDM-KS) in the options.
- [Fix] <jh> Under increased system load, it was possible that WaveRT devices would stop rendering audio.

Misc
- [New] <js> In the settings dialog, the default artist name and default behaviour for new files (module type / template) can now be specified on the General tab.
- [New] <js> Add the possibility to forget all song window settings in the Display settings.
- [New] <js> Hidden setting Misc.AllowMultipleCommandsPerKey added to allow more than one keyboard shortcut being bound to the same key combination (may do unexpected things with existing mappings with overlapping shortcuts, so beware).
- [Imp] <js> Add dropdown menus to "New" and "MIDI Record" buttons in the main toolbar to select file type and MIDI device respectively.
- [Imp] <js> Tuning dialog: Mouse wheel can now be used to scroll the note map.
- [Mod] <js> Default directories and auto save settings have been merged into a new "Paths / Auto Save" settings tab. "Create backup files" has been moved there as well. "MIDI Record" option has been moved to the MIDI setup.
- [Mod] <jh> Show more useful information in the About dialog.
- [Mod] <jh> More defensive CPU feature detection for really old CPUs.
- [Fix] <js> Using Win+Space to change the Windows input language now takes effect immediately and no longer locks command input.
- [Fix] <jh> UnRAR code required Windows XP, while the rest of the code also works with Windows 2000. Drop the version requirement back to Windows 2000.
- [Fix] <js> Song duration estimation: Pattern loops were only calculated correctly when placed on the last channel. Pattern breaks leading to a row greater than the current pattern's size were not computed correctly.
- [Fix] <js> Fix possible crash when changing the number of channels, mostly happening when appending modules.
- [Fix] <js> When saving an external sample fails while closing the module containing the sample, the module remains open so that the user can investigate the problem.
- [Fix] <js> Hideable message box visibility settings were read from the wrong settings variable since OpenMPT 1.22.07.00.

Third-Party Libraries
- [Imp] Update lhasa (v0.3.0), SoundTouch (v1.9) and UnRAR (v5.3.2).

Installer/release package
- [Mod] <js> A great new set of example songs, with a number of free to use samples in "ExampleSongs\Samples" folder.
- [Mod] <js> Installer now places the OpenMPT icon directly in the Start menu rather than a subfolder.
- [Mod] <js> Updated US_it2_(lpchip).mkb.


v1.24.04.00 (19 April 2015, revision 4951)
------------------------------------------
Pattern tab
- [Fix] <js> Seeking with sample sync didn't apply portamento and note delay + row delay combinations accurately in some cases.

Playback
- [Fix] <js> On rows with a row delay effect, offset commands were executed on every row repetition in the previous version.

IT::Compatible Playback Mode
- [Fix] <js> Note delays are capped by the ticks per row + fine pattern delay tick count, not taking row delay into account.

MOD::ProTracker 1/2 Mode
- [Fix] <js> Instrument swapping is also applied if there was an empty sample slot "playing" (fixes arpeggios in "mr gang !!!." by arios).

Misc
- [Fix] <jh> There was a major performance regression in the previous version, mostly noticeable on Wine.


v1.24.03.00 (18 April 2015, revision 4941)
------------------------------------------
General tab
- [Fix] <js> The "Set" button for updating plugin parameters was still present by accident. Clicking the button could lead to problems with descriptive parameter values (tx eightbitbubsy).

Pattern tab
- [New] <js> Can now transpose a whole channel in all patterns via the channel header context menu (including a new shortcut).
- [New] <js> New fade curves in amplification dialog: Exponential, Logarithmic, Square Root, Quarter Sine, Half Sine.
- [Imp] <js> Greatly improved seek performance when "Maintain sample sync on seek" is enabled.
- [Mod] <js> Remove arbitrary limiting of the order list scrollbar to the first stop index in MOD / XM.
- [Fix] <js> Continuous scroll didn't work when entering chords (http://bugs.openmpt.org/view.php?id=132).
- [Fix] <js> Volume column offset command was still being displayed in the Note Properties for IT files (http://bugs.openmpt.org/view.php?id=647).
- [Fix] <js> When only enabling Amiga limits for MOD but not ProTracker 1/2 mode, invalid notes were not coloured as such.
- [Fix] <js> When switching between modules or resizing the window, it was possible for the pattern display to show garbage (http://bugs.openmpt.org/view.php?id=665).
- [Fix] <js> Clicking on the first and last item of an order selection loses the selection, like clicking any other item.
- [Fix] <js> Seeking with sample sync could misbehave when encountering PC events.

Sample tab
- [New] <js> The MPTM volume column offset command has been revamped: 9 custom cue points can be selected for each sample in the waveform's context menu, which can then be triggered using o01...o09 (http://bugs.openmpt.org/view.php?id=91).
- [New] <js> Crossfader can now use constant power (instead of constant volume) fade law for even smoother loop transitions. The sample can now optionally be faded back to its original content after the loop end.
- [New] <js> New fade curves in amplification dialog: Exponential, Logarithmic, Square Root, Quarter Sine, Half Sine.
- [Mod] <js> Middle-C finetune adjustments are now made in cents (1/100th of a semitone) instead of Hertz.
- [Fix] <js> Inputting a new middle-C frequency created an undo step for every entered digit.
- [Fix] <js> Pitch shift was broken for stereo samples.

Instrument tab
- [New] <js> Can now load and save envelopes (http://bugs.openmpt.org/view.php?id=398).
- [Imp] <js> Entering a negative envelope scaling factor also yields sensible results for the volume and filter envelope now.
- [Mod] <js> Apply DNA and NNA settings to released notes when previewing notes (http://bugs.openmpt.org/view.php?id=437).

Tree view
- [Imp] <js> Show the missing samples dialog when using "Reload All" if there are any missing samples left.
- [Fix] <js> Preview was detuned for some samples (http://bugs.openmpt.org/view.php?id=14).

Mod Conversion
- [Fix] <js> Tempo commands broke when converting XM to MOD.

VST / DMO Plugins
- [New] <js> Plugin editors now have minimize / maximize buttons, which can be used to shrink a plugin window to only display the title and menu bar.

Playback
- [Fix] <js> With "loop song" disabled, the loop detection was a bit too aggressive and would stop playback when encountering nested pattern loops.

IT
- [Fix] <js> Tick-0 effects were not executed on the first tick of row repetitions (pattern delay effect) since OpenMPT 1.23.

XM
- [Fix] <js> Out-of-range global volume commands should not be ignored in XM (fixes "Reflecter" by Zodiak).

S3M
- [Fix] <js> Properly limit sample frequency and cut the sample when sliding too high.
- [Fix] <js> Tick-0 effects were not executed on the first tick of row repetitions (pattern delay effect) since OpenMPT 1.23.

MOD::Loading
- [Imp] <js> VBlank heuristic: Do not use VBlank timing if it results in a longer tune than regular CIA timing (http://bugs.openmpt.org/view.php?id=654).

MOD::ProTracker 1/2 Mode
- [New] <js> Support for ProTracker oneshot loops: If the loop start is right at the start of the sample, play through the whole sample once and then repeat just the loop part.

Other formats
- [New] <js> Can now read PLM (Disorder Tracker 2) files.
- [Mod] <js> Allow loading PAT instruments with 0 layers (such as DOO.PAT from the original GUS sample set).
- [Fix] <js> PTM: The weird behaviour of the panning command I observed was due to DOSBox' broken GUS panning. Now panning commands are imported as expected again.

Audio I/O
- [Mod] <jh> Allow smaller buffer sizes for Wave Out devices.

Misc
- [Imp] <js> Song length estimation: Properly handle panning, parameter extension (#xx), and tempo / volume slides that are on the same row as a set speed effect.
- [Imp] <jh> VU meter's decay speed is now configurable via hidden setting "Display.VuMeterDecaySpeedDecibelPerSecond". Default value is 88.
- [Mod] <js> No longer mark module as modified when switching between sequences (http://bugs.openmpt.org/view.php?id=141).
- [Fix] <js> The bold and italic styles were ignored on custom pattern and comments fonts.
- [Fix] <js> It was possible to switch song tabs while being in a modal dialog, which could lead to crashes when exiting the dialog.
- [Fix] <js> Tooltips were missing in some windows in the 32-bit build (http://bugs.openmpt.org/view.php?id=646).
- [Fix] <js> Channel Manager window was not sized properly.
- [Fix] <jh> OpenMPT 1.24 was previously no longer running on Windows 98 + KernelEx.

Third-Party Libraries
- [Imp] Update UnRAR (v5.2.6).


v1.24.02.00 (16 February 2015, revision 4761)
---------------------------------------------
Pattern tab
- [New] <js> Added support for custom pattern fonts as well as upscaled variants of the built-in fonts for High-DPI devices.
- [Imp] <js> Data entry shortcuts / scroll wheel do now take the default volume into consideration, i.e. when making a data entry in an empty volume column field next to a note, a volume command is inserted (http://forum.openmpt.org/index.php?topic=5411.0).
- [Imp] <js> Show verbose effect descriptions in the status bar instead of the short versions (http://bugs.openmpt.org/view.php?id=51).
- [Imp] <js> Note-offs from past notes are no longer written when recording notes into patterns (http://bugs.openmpt.org/view.php?id=645).
- [Mod] <js> In IT and XM, the o command (Offset) can no longer be entered into the volume column, as it's an OpenMPT-specific command. Old files using this command will still play as intended.
- [Fix] <js> The Parameter Editor refused to work under random conditions.

Sample tab
- [New] <js> Added new shortcuts to center waveform around loop points.
- [Fix] <js> Splitting a stereo sample into mono samples didn't update the sample list in other tabs.

Instrument tab
- [Fix] <js> Plugin list was updated on every instrument change, leading to a small but noticeable performance drop.

Comments tab
- [New] <js> It is now possible to use a custom font for displaying module comments.

Tree view
- [Fix] <js> When converting samples to instruments, the instrument folder in the tree view was not updated properly (tx eightbitbubsy).
- [Fix] <js> OpenMPT 1.24 introduced a perceivable delay when loading samples for preview.

Mod Conversion
- [Imp] <js> Properly convert between IT / MPTM Hxx and XM 4xx vibrato depth.

Playback
- [Fix] <js> Vibrato was too weak in IT / MPTM with linear frequency slides since the previous version (http://bugs.openmpt.org/view.php?id=623).
- [Fix] <js> Fine portamento was sometimes too weak in IT / MPTM with linear frequency slides since the previous version.

IT
- [Mod] <js> Allow loading IT files with tempo 31 normally.

IT::Compatible Playback Mode
- [Fix] <js> Default sample and instrument panning is only reset by notes, not instrument numbers.
- [Fix] <js> Panbrello is not reset until the next note or panning command.

MOD
- [Mod] <js> To match ProTracker, the portamento target is no longer reset when a new note is encountered (like in FT2), but it is reset when the target is reached (like in IT). Fixes the intro in nuhanenatanssi.mod.
- [Fix] <jh> Fixed random crash in ProTracker 1/2 mode when using on-the-fly sample swapping (http://bugs.openmpt.org/view.php?id=626).

Other formats
- [Fix] <js> STM: Samples were not loaded correctly in some files, e.g. fracture in space" by Purple Motion (tx deus-ex, http://www.un4seen.com/forum/?msg=113496)
- [Fix] <js> STM: Volume slide nibbles are now prioritized correctly (fixes "fracture in space" by Purple Motion).

Stream Export
- [Mod] <jh> Remove >48 KHz support for Vorbis export. Even though Vorbis supports these sampling rates, it's not tuned for them, and using >48 KHz for any lossy codec generally does not make any sense at all.
- [Fix] <jh> Detection of available MP3 encoders was sometimes broken in the previous version.

Audio I/O
- [New] <jh> Added hidden options EnableWaveOut, EnableDirectSound, EnableASIO, EnablePortAudioWASAPI, EnablePortudioWDM-KS, EnablePortAudioDS, EnablePortAudioASIO in [Sound Settings] to disable certain types of audio drivers, if required for debugging.

Misc
- [New] <jh> Added hidden settings "Debug.StopSoundDeviceOnCrash" (default true) and "Debug.TraceAlwaysDump" (default false) which can be useful to debug sound device related problems that do not manifest in a crash.
- [Imp] <js> Various parts of the program are now DPI-aware: Parameter editor, pattern editor, channel manager, plugin manager, splitter positions, MIDI Input/Output Plugin
- [Fix] <js> When using the Song Properties dialog to change some properties of an IT file, re-saving the file always popped up the Save As dialog.


v1.24.01.00 (21 December 2014, revision 4662)
---------------------------------------------
General tab
- [Imp] <js> Clicking on the song type opens Song Properties dialog.
- [Imp] <js> If available, show a descriptive parameter value for plugin parameters instead of its numerical representation.

Pattern tab
- [New] <js> Ctrl + (Shift +) Scroll wheel can now be used as a replacement for the "(Coarse) Data Entry" shortcuts (http://bugs.openmpt.org/view.php?id=613).
- [Imp] <js> When previewing instruments with a fadeout value of 0, instantly stop them on key-up instead of letting them play forever.
- [Fix] <js> "Continue song as soon as MIDI notes are being received" didn't work in some situations.
- [Fix] <js> When using "Continue song as soon as MIDI notes are being received", the Edit Step setting was erroneously applied to the first note.
- [Fix] <js> When dragging a selection in the order list one order to the right, the document was marked as modified even though there was no change.
- [Fix] <js> Fixed crash when a module has no patterns at all.
- [Fix] <js> When only one parameter column was selected, the interpolation context menu didn't offer to interpolate this column.

Sample tab
- [New] <js> Support resampling to any arbitrary sampling rate using r8brain-free. Includes new keyboard shortcuts for upsampling, downsampling and resampling.
- [New] <js> As upsampling no longer automatically converts the sample to 16-bit, 16-bit conversion is now a separate option.
- [New] <js> Custom background and selection colours can now be specified (http://bugs.openmpt.org/view.php?id=371).
- [Imp] <js> Adjusting the sample frequency updates all playing notes' sample frequency (only works with IT and MPTM for now).
- [Imp] <js> Improved sample loop point input behaviour so that a loop start value greater than the current loop end value can be entered without having to enter the new loop end first.
- [Imp] <js> Finetune and transpose modifications are now undo-able.
- [Imp] <js> Visually distinguish sustain loop and sample grid markers.
- [Imp] <js> No longer show unsupported sample vibrato types in IT (Ramp Up) and XM (Random).
- [Fix] <js> Ramp Up and Ramp Down labels in XM vibrato settings were swapped since forever.
- [Fix] <js> When editing XM vibrato settings, the edit cursor always jumped back to the first character in the edit field.
- [Fix] <js> Rearranging samples (e.g. through song cleanup or the tree view) no longer messes up the undo buffer history (http://bugs.openmpt.org/view.php?id=600).
- [Fix] <js> The sample transpose dropdown was missing two complete octaves. The range has been extended and turned upside down (can now be understood intuitively as "C-5 is being played like note x").
- [Fix] <js> Silencing a single sample point lead to a crash (http://bugs.openmpt.org/view.php?id=610).

Instrument tab
- [New] <js> ITI instrument files can now contain external samples (like MPTM files). Select "Impulse Tracker Instruments with external Samples" from the save dialog (http://forum.openmpt.org/index.php?topic=2515.0).
- [New] <js> The first instrument of a soundfont can now be loaded directly without registering the soundfont in OpenMPT.
- [New] <js> Custom background colour can now be specified.
- [Imp] <js> Since Impulse Tracker's fade-out value is 32 times less precise than what is displayed in the editor, automatically round it when the user makes fade-out adjustments in IT files.
- [Imp] <js> When previewing instruments with a fadeout value of 0, instantly stop them on key-up instead of letting them play forever.
- [Mod] <js> Disallow OpenMPT-only "attack" setting to be used in IT and XM files. Old files using this setting still play as intended.
- [Fix] <js> When loading an instrument, force all sample views of the same module to be updated.
- [Fix] <js> Modifying envelopes using the keyboard didn't mark the module as modified.

Tree view
- [New] <js> Dropping a module or folder on the sample browser opens this module or folder for browsing.
- [New] <js> Dropping a soundfont file on the upper part of the tree view adds it to the list of soundfonts.
- [New] <js> Due to the change from external instruments in the ITP format to external samples in MPTM, "Set Path" and "Save" have been moved to samples. External samples are marked with [external], missing external samples are marked with [missing].
- [New] <js> Sample waveforms can now be reloaded from disk (e.g. after editing a sample in an external application) if OpenMPT knows the sample's original path, e.g. after loading or saving it, or using MPTM's external sample feature (http://bugs.openmpt.org/view.php?id=207).
- [New] <js> The first instrument of a soundfont can now be previewed directly from the sample browser (without registering the soundfont in OpenMPT).
- [Mod] <js> Apparently, some versions of Ableton Live mark exported WAV files as "temporary". Such files are no longer ignored in the sample browser.
- [Fix] <js> Duplicating samples was broken in OpenMPT 1.23.
- [Fix] <js> Previewing IMA ADPCM-compressed samples from the tree view was broken if the previously previewed sample was a stereo sample.

Mod Conversion
- [Imp] <js> When converting from IT / MPTM to XM, move volume column portamento to the effect column if possible, as it has a different meaning in XM.
- [Fix] <js> When converting from XM to IT / MPTM, volume column effects were not always limited properly.

VST / DMO Plugins
- [Imp] <js> When adding a new plugin through the plugin manager that is missing from some open file, it is now automatically loaded and restored in that file.
- [Imp] <js> "Randomize Parameters" now applies a customizable randomization factor - much more useful than completely random parameters.
- [Fix] <js> Regularly send editor idle commands to plugins with open editors.

VST::Plugin Bridge
- [Imp] <js> The plugin bridge does now also create crash dumps automatically. OpenMPT's /fullMemDump command line switch also applies to these dumps.
- [Mod] <js> By default, all instances of the same plugin do now share one bridge process, since a handful of plugins require this - and the loading performance is much better, too.
- [Fix] <js> Catch potential crashes while loading the plugin, like in OpenMPT (fixes instant crashes with multiple instances of SideKick v3 in different processes).

Playback
- [New] <js> S70 / S71 / S72 commands do now also work with instrument plugins.
- [Imp] <js> Smooth MIDI macros do now, to some extent, work with external MIDI messages. They interpolate from the previous Zxx or \xx parameter from the same channel to the new parameter.
- [Mod] <js> In all mix modes since 1.17RC2, a way too long volume ramp (some times up to 100 times longer than the user-supplied ramp setup) was applied for extreme global volume changes. This is now disabled except for legacy 1.17RC2 mix mode.
- [Mod] <js> Re-implemented stereo separation to be applied on the master mix. This means that it also works as expected with stereo samples and plugins now.
- [Fix] <js> NNA / DCA settings were not applied properly to plugins assigned to sample-less instruments.
- [Fix] <js> Instrument plugin arpeggio was executed on muted channels / instruments.
- [Fix] <js> Linear frequency slide mode (in all formats except XM, which already worked as intended) has been re-implemented to fix some unwanted inaccuracies which can add up very quickly when using extra-fine slides.
- [Fix] <js> Glissando should only affect tone portamento, not portamento up / down effects.

MTPM
- [New] <js> MPTM files can now contain external (on-disk) samples. When checking the "Keep sample on disk" checkbox in the sample editor, the sample data is not stored directly in the MPTM file but a relative link to the original sample file is kept (http://bugs.openmpt.org/view.php?id=368).

IT
- [Imp] <js> Added support for reading encrypted edit time in old IT files with no edit history present (discovered through Impulse Tracker source release, yay).

XM
- [Mod] <js> Revert XM compatibility export to always write out 256 order items.
- [Fix] <js> Use "normal" compatible mix mode instead of FT2 panning mix mode for XM files that were compatibility-exported with OpenMPT 1.22 or older, and XM files made with other trackers that use linear panning.

XM::Compatible Playback Mode
- [Fix] <js> Make arpeggio after portamento effect behave even more like in Fasttracker 2.

S3M::Compatible Playback Mode
- [New] <js> Compatible playback mode for S3M: When enabled, OpenMPT emulates certain Scream Tracker quirks as it did until now (linked pattern effect memory and ignored effects on muted channels). Compatible mode is disabled automatically for files made with less compatible trackers. S3M files made with OpenMPT always have this mode enabled, and its state is not saved in S3M files.

MOD
- [Imp] <js> Amiga frequency limits can now also be enforced without activating ProTracker 1/2 mode.

MOD::Loading and Saving
- [Mod] <js> M.K. and M!K! files that only have Amiga-compatible notes in their patterns automatically enforce Amiga frequency limits now (http://bugs.openmpt.org/view.php?id=563).
- [Fix] <js> Saving a sample loop with an odd length is now handled better (http://bugs.openmpt.org/view.php?id=590).
- [Fix] <js> Any non-ASCII characters were accidentally removed when loading a MOD file (broke in OpenMPT 1.22).

MOD::ProTracker 1/2 Mode
- [Fix] <js> Glissando is only applied on rows with a portamento effect, and never on the first tick of these rows.

Other formats
- [New] <js> Added support for a MOD variant introduced by SoundTracker 2.6 and Ice Tracker (http://bugs.openmpt.org/view.php?id=597).
- [Imp] <js> SoundTracker auto-slides are now imported using the volume column.
- [Imp] <js> MT2: Completely rewrote loader. Some files that would previously not load properly do now load. Support for VST plugins, drum patterns and some extended MT2 pattern commands has been added.
- [Fix] <js> ITP: Always load embedded MIDI macros for files made with OpenMPT 1.19 or older, since back then they were always read, no matter if the embed flag was set or not.
- [Fix] <js> ITP: Loading extended song properties was broken since OpenMPT 1.21.
- [Reg] <js> ITP: Saving and editing ITP files is no longer supported. ITP files are now imported as normal IT files. ITP's functionality is superseded by MPTM's new external sample functionality.

Stream Export
- [Fix] <js> F00 "stop song" abort detection for XM files didn't abort if there were samples playing with a global volume of 0.

Module cleanup
- [New] <js> "Remove unused sample data" now also finds samples with identical stereo channels and offers to optimize them to mono.
- [Imp] <js> Give information about how many plugins were removed.
- [Fix] <js> Removing unused samples no longer creates two undo points per sample.

Audio I/O
- [New] <jh> Support direct mode for Wave Out devices. This is mostly useful on Wine systems where it (for certain setups) prevents the Wine-internal resampler from kicking in.
- [Imp] <jh> Increased latency and period precision to allow sub-millisecond latencies.
- [Imp] <jh> Added per-device type default audio settings.
- [Mod] <jh> Query PortAudio for the default latency of PortAudio sound devices.
- [Mod] <jh> When changing between mono / stereo / quad channel configurations, always reset the channel mapping to default instead of basing the new one on the previous one.
- [Mod] <jh> Add a hidden setting setting "Sound Settings.PreferSameTypeIfDeviceUnavailable" which optionally changes the algorithm for selecting the fallback device if the device selected by the user (or read from the configuration) is currently unavailable. When this setting is set, a device of the same type as the currently selected is preferred instead of just defaulting to wave mapper.
- [Fix] <jh> If the soundcard is currently unavailable, some ASIO drivers allow opening the driver and report zero input and output channels in that case. Other drivers do not support loading the driver. In both cases, OpenMPT will now disallow selecting the driver in the setup dialog and hide it until restarting OpenMPT or the sound devices get rescanned.

Misc
- [New] <js> Dropping a folder that contains modules or VST plugins opens / registers them directly now (http://bugs.openmpt.org/view.php?id=510).
- [New] <js> Remember window positions for each tune individually when it is being saved. Plugin window positions are now stored using the same mechanism instead of being embedded into the module files. (http://forum.openmpt.org/index.php?topic=3280.0).
- [New] <js> Added a first-start dialog to set up some common settings. The corresponding settings have been removed from the installer.
- [Imp] <js> Song length estimation: Slightly improve calculation of nested pattern loops (http://bugs.openmpt.org/view.php?id=591).
- [Imp] <js> Song length estimation shows the length of all "hidden" subtunes in the current sequence.
- [Imp] <js> Made the MIDI Mapping dialog's mapping list more human-readable.
- [Imp] <jh> VU Meter: Rear channels are now also shown in quad mode.
- [Mod] <js> When merging the default key map into a custom key map, event types are now completely ignored, so if e.g. the user has assigned a certain key on "key hold" but the default key map uses the same key on "key down" only, this version is no longer added.
- [Mod] <js> Autosave: When "Use song's original directory" is enabled, but the song has not been saved so far, it is now saved in a sub folder called "Autosave" instead of the root of the settings directory. In this case, modules created from templates are now also autosaved into this folder instead of the template folder.
- [Mod] <jh> Added setting LoadOnStartup in [Components] to optionally load all optional components (such as MP3 encoders, UNMO3, etc.) on startup rather than first use. KeepLoaded (also in [Components]) determines whether components stay in memory after they have been used (this is the default behaviour).
- [Mod] <js> Rename "Colours" settings tab to "Display".
- [Fix] <js> Soft Panning check box in Mixer settings didn't work (http://bugs.openmpt.org/view.php?id=602).
- [Reg] <js> Removed noSettingsOnNewVersion command line switch. It's no longer necessary as there is also a hidden setting that does the same.

Third-Party Libraries
- [Imp] Update lhasa to version 2014-07-12 (adds support for lhx archives).
- [Imp] Update FLAC to v1.3.1 (improved decoding and encoding efficiency, fixed two vulnerabilities when loading malicious FLAC files).
- [Imp] Updated PortMidi to revision 228 (fixes potential 64-bit issues).


v1.23.05.00 (6 September 2014, revision 4238)
---------------------------------------------
Pattern tab
- [Imp] <js> "Edit Plugin assigned to PC Event" shortcut is now "Toggle PC Event/instrument plugin editor" (can now also be used to toggle the editor of the plugin assigned to the currently selected instrument).
- [Imp] <js> Deleting and inserting items in the order list automatically adjusts playback, sequence override and play lock positions.
- [Imp] <js> Greatly improve seek performance when "Maintain sample sync on seek" is enabled and there are samples with very small loops.
- [Imp] <js> When inserting a new pattern while a +++ or --- pattern is focussed in the order list, use the currently edited pattern for determining the new pattern's length.
- [Fix] <js> In windowed mode, the note properties dialog was not always visible.
- [Fix] <js> The order list's scrollbar's "Right Edge" menu entry was not working (http://bugs.openmpt.org/view.php?id=567).

Sample tab
- [Fix] <js> Enabling a sample loop when there were no loop points didn't update the loop point display.
- [Fix] <js> Silencing samples was slightly broken (http://bugs.openmpt.org/view.php?id=555).
- [Fix] <js> Undo could crash in some situations when the total undo buffer size previously exceeded the configured buffer limit.
- [Fix] <js> It was impossible to call the save dialog for a sample / instrument with a pipe character in the name (also applies to instrument tab, http://bugs.openmpt.org/view.php?id=564)
- [Fix] <js> Fixed possible crashes when using undo / redo, most notably when sample undo was disabled completely (http://bugs.openmpt.org/view.php?id=584).

Instrument tab
- [Imp] <js> In the sample map editor, show faint red dots for notes that are already assigned to another sample (http://forum.openmpt.org/index.php?msg=37495).
- [Fix] <js> Trying to play notes above B-9 caused a crash (http://bugs.openmpt.org/view.php?id=549).

Tree view
- [Fix] <js> Stopped voices sometimes still contributed to the active sample / instrument list (http://bugs.openmpt.org/view.php?id=568).

VST / DMO Plugins
- [New] <js> Plugin editor positions are now stored in module files.
- [Imp] <js> Allow drag and drop actions on plugin editors to drop preset files from Explorer.
- [Fix] <js> Program names starting with non-ASCII characters were not formatted properly.
- [Reg] <js> Partly reverted the behaviour introduced in OpenMPT 1.23.03.00 to only re-send patch numbers if they're not bank 1 patch 1, to fix legacy module playback.

Playback
- [Mod] <js> When resuming paused (not stopped) playback, previously playing samples are continued.
- [Fix] <js> "Maintain sample sync on seek" should now also work when playback was previously stopped.
- [Fix] <js> Glissando in semitones mode didn't take finetune into account (http://bugs.openmpt.org/view.php?id=585).

IT::Compatible Playback Mode
- [Fix] <js> Tone portamento target is now completely cleared with new notes, so that subsequent Gxx effects have no effect.

XM
- [Fix] <js> Clear MIDI macros for XM files made with FT2 to prevent Zxx effects from doing anything.
- [Fix] <js> Correct nominal dB values for FT2 pan law mix mode.

XM::Compatible Playback Mode
- [Fix] <js> Tentatively fix arpeggio after pitch slide behaviour (http://bugs.openmpt.org/view.php?id=542).

MOD::ProTracker 1/2 Mode
- [Fix] <js> ProTracker applies instrument changes on the first tick, even if there's a note delay (http://bugs.openmpt.org/view.php?id=574).
- [Fix] <js> Properly implemented ProTracker-style sample swapping, which is only supposed to happen at the end of the sample and not instantly.
- [Fix] <js> Correctly handle a few more edge cases of ProTracker-style 9xx offset handling.

Misc
- [New] <jh> Add hidden setting "Misc.ShowSettingsOnNewVersion" (default true) which can permanently disable showing of the settings dialog on new versions, in addition to the one-time command line switch /noSettingsOnNewVersion.
- [Imp] <js> Add support for 64-bit Vorbis library builds from mingw-w64 with slightly different file names.
- [Imp] <js> When adding a new shortcut that conflicts with an existing shortcut, do not automatically delete the existing shortcut but rather ask the user what to do.
- [Imp] <js> Add global dummy shortcut keybinding to prevent default keybindings from doing anything into if you don't like them (http://bugs.openmpt.org/view.php?id=550).
- [Imp] <js> Slightly improved icons for systems with 32-bit display mode but mysteriously missing alpha channel (http://bugs.openmpt.org/view.php?id=520).
- [Mod] <js> Merge "Note Off/Cut/Fade" and "Note Off/Cut/Fade (without instrument number)" to never write an instrument number next to those events.
- [Fix] <js> Scale main toolbar elements according to DPI settings (http://bugs.openmpt.org/view.php?id=513).
- [Fix] <js> Setting the default MIDI volume behaviour for new instruments in the Options dialog was broken.
- [Fix] <js> Potential fix for DDE error when launching OpenMPT through an associated file from Explorer (http://bugs.openmpt.org/view.php?id=461).
- [Fix] <js> After loading a new keybinding file, effect keys were no longer working until the user switched to a module with different effect keys (tx stinkbug).

Third-Party Libraries
- [Imp] Update UnRAR (v5.1.6).


v1.23.04.00 (14 June 2014, revision 4113)
-----------------------------------------
Pattern tab
- [New] <js> Added possibility to interpolate the instrument column.
- [Imp] <js> Stay at current order / pattern when removing something from the order list (http://bugs.openmpt.org/view.php?id=511).
- [Fix] <js> With overflow paste, marking the pasted pattern area was not working when the paste ended exactly in the last pattern row (broke in OpenMPT 1.23.02.00).
- [Fix] <js> Select / Copy Select keys should no longer interfere with mouse dragging (tx coda).
- [Fix] <js> Don't crash when the module doesn't have any patterns.
- [Fix] <jh> Fixed flickering of current-row highlight in pattern view on Wine (http://bugs.openmpt.org/view.php?id=522).

Sample tab
- [Fix] <js> Setting sustain loop points by typing the values in didn't update the waveform display.
- [Fix] <js> When removing DC offset from a sample, the wrong volume variable on channels currently playing the modified sample was modified.

Tree view
- [Fix] <js> It was not possible to drag and drop drums from sound banks (http://bugs.openmpt.org/view.php?id=536, x64 only).

VST / DMO Plugins
- [Imp] <js> Improve preset menu creation in the plugin editor for plugins with less than 128 presets, so that the menu is only created when needed (speeds up e.g. bridged VOPM).
- [Imp] <js> When trying to load a plugin where both the 32-bit and 64-bit version are registered in OpenMPT, prefer the native version.
- [Fix] <js> When trying to play notes in a VST GUI with no instrument assigned yet, prevent notes from being stuck after closing the instrument creation confirmation (tx coda).

VST::Plugin Bridge
- [Fix] <js> Don't crash when a plugin sends an opcode that isn't expected to have a data pointer set (http://bugs.openmpt.org/view.php?id=519).
- [Fix] <js> Unknown vendor-specific opcodes that send pointers are now rejected, as they cannot work over the bridge.

XM
- [Fix] <js> More intelligent extraction of the selected MIDI program for files that were not made with ModPlug.
- [Fix] <js> Loading ADPCM-compressed samples broke in OpenMPT 1.23 (http://bugs.openmpt.org/view.php?id=538).

S3M
- [Fix] <js> Some files created with Scream Tracker were detected as being made with Velvet Studio.

MOD
- [Fix] <js> Loading ADPCM-compressed samples was broken ever since OpenMPT 1.22.06.00.

Other formats
- [Fix] <js> IMF: Ignore note cut with a zero parameter.

Audio I/O
- [Mod] <jh> Default to 16-bit output on Wine, since some Wine versions apparently have problems with sample formats > 16bit.
- [Fix] <jh> DirectSound: Emulated drivers do not support primary buffer access. Actually test whether the device is emulated or not and do not advertise primary buffer support if it is.
- [Fix] <jh> Fix clamping / rounding of Wave Out and DirectSound buffer sizes for 24bit samples (http://bugs.openmpt.org/view.php?id=540).

Misc
